/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Gael Harbonnier.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.benchmark.benchIce.latency;

/**
 * This is the Ping interface implementation.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public class PingImpl
     extends _PingItfDisp
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    /** Ice communicator reference. */
    private Ice.Communicator _ic;

    // ==================================================================
    //
    // Construtors.
    //
    // ==================================================================

    public PingImpl(Ice.Communicator ic)
    {
        _ic = ic;
    }
  
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    /**
     * This method is used as a "ping" to evaluate latency.
     */
    public void ping(Ice.Current __current)
    {
        //Nothing to do
    }

    /**
     * Stops the Server.
     */
    public void shutdown(Ice.Current __current)
    {
        _ic.shutdown();
    }
}
