/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Gael Harbonnier.
Contributor(s): _______________.

====================================================================*/

package org.objectweb.benchmark.benchIce.latency;

/**
 * Ice benchmark server application.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public class Server
{

    /**
     * The bootstrap method.
     * 
     * @param args - Application arguments
     */
    public static void main(String[]args)
    {
        int status = 0;
        Ice.Communicator ic = null;
        
        try{
            ic = Ice.Util.initialize(args);
            Ice.ObjectAdapter adapter = ic.createObjectAdapterWithEndpoints("SimplePrinterAdapter",
                                                                            "default -p 10000");
            Ice.Object object = new PingImpl(ic);
            adapter.add(object, Ice.Util.stringToIdentity("SimplePrinter"));
            adapter.activate();
            ic.waitForShutdown();
    
            // ic.destroy();
            System.exit(0);
        }catch(Ice.LocalException e){
            e.printStackTrace();
        }
    
    }
    
}
