/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): Gael Harbonnier.

====================================================================*/

package org.objectweb.benchmark.rmi.latency;


//Package dependencies.
import java.rmi.Naming;

/**
 * This is the RMI Server. It implements the Ping interface.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public class Server
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    /** host */
    private String host;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * The default constructor.
     */
    public Server()
    {
        try
        {
            java.util.Properties properties = new java.util.Properties();
            java.io.InputStream propStream = getClass().getClassLoader().getResourceAsStream("benchmark.properties");
            properties.load(propStream);
        
            host = properties.getProperty("com.host");
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    /**
     * The bootstrap method. 
     */
    public static void main(String[] args)
    {
        Server s = new Server();

        try
        {
            PingImpl obj = new PingImpl();
            Naming.rebind("pingServer", obj);
            System.out.println("Ping server ready ...");
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}