/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.benchmark.util;

// Package dependencies.
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * This Agent is a utility class to synchronize hosts with port (sockets).
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public class PortAgent
{
    public static void
    main(String[] args)
    {
        int port = 0;
        
        if (args.length < 2)
        {
            System.err.println("usage: PortAgent activate|wait_for_activation <port> [host]");
            System.exit(0);
        }
        port = Integer.parseInt(args[1]);
        
        if (args[0].compareTo("activate") == 0)
        {
            // Activate a port on a remote host
            try
            {
                Socket socket = new Socket(args[2], port);
                socket.sendUrgentData(0);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        else if (args[0].compareTo("wait_for_activation") == 0)
        {
            // Wait a port activation
            try
            {
                ServerSocket s = new ServerSocket(port);
                Socket socket = s.accept(); // blocking
                s.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

}
