/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Harbonnier, Denimal.
Contributor(s): Christophe Demarey.

====================================================================*/

package org.objectweb.benchmark.xmlrpc.latency;

// Package dependencies.
import org.apache.xmlrpc.WebServer;

/**
 * This is the WS Server. It implements the Ping interface.
 * 
 * @author Harbonnier, Denimal.
 * 
 * @version 1.0
 */
public class Server
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    /** port */
    private String port;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * The default constructor.
     */
    public Server()
    {
        try
        {
            java.util.Properties properties = new java.util.Properties();
            java.io.InputStream propStream = getClass().getClassLoader().getResourceAsStream("benchmark.properties");
            properties.load(propStream);
        
            port = "2000";
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    private String
    getPort()
    {
        return port;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    /**
     * The bootstrap method. 
     */
   public static void
   main(String[] args)
   {
       Server s = new Server();

       try
       {
           WebServer server = new WebServer(Integer.parseInt(s.getPort())); 
           System.out.println ("Ping Server started ...");
           server.addHandler ("pingServer", new PingHandler ());
       } catch (java.io.IOException e) {
           e.printStackTrace();
       }
    }
}
