/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: AddSubComponentOnDropAction.java,v 1.1 2004/04/20 16:37:27 moroy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.menu;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.util.browser.api.DropAction;
import org.objectweb.util.browser.api.DropTreeView;

/**
 * This action allows to add a component into a composite component using the Drag&Drop mechanism.
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class AddSubComponentOnDropAction 
  implements DropAction 
{
    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public method for DropAction interface.
    //
    //==================================================================
    
    /* 
     * @see org.objectweb.util.browser.api.DropAction#execute(org.objectweb.util.browser.gui.dnd.DropTreeView)
     */
    public void execute(DropTreeView dropTreeView) throws Exception {
        if(dropTreeView!=null){
            try{
                Component subComponent = (Component)dropTreeView.getDragSourceObject();
                ContentController contentInterface = (ContentController)dropTreeView.getSelectedObject();    
                contentInterface.addFcSubComponent(subComponent);
            }catch(ClassCastException e){
                throw new Exception("You must select a component!");
            }
        }                
    }
}
