
import java.lang.Runnable;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;

/**
 * This action allows to invoke the run method of a <code>java.util.Runnable</code> object.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class InvokeAction 
    implements MenuItem 
{

    public void actionPerformed(MenuItemTreeView e) {
        Runnable r = (Runnable)e.getSelectedObject();
        InvokeThread t = new InvokeThread(r);
        t.start();
    }

    /**
     * @see org.objectweb.util.browser.api.MenuItem#isActive(org.objectweb.util.browser.gui.common.TreeView)
     */
    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }

    public class InvokeThread extends Thread {
         
        protected Runnable r_ = null;
         
        public InvokeThread(Runnable r) {
            r_ = r;
        }
 
        public void run() {
            r_.run();
        }
     }
 
}