/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.plugin.java.map;

import org.objectweb.util.browser.api.DropAction;
import org.objectweb.util.browser.api.DropTreeView;

/**
 * This action adds an element into a <code>java.util.Map</code> 
 * object using the Drag&Drop mechanism. 
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class MapAddObjectOnDropAction 
  implements DropAction 
{

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for DropAction interface.
    //
    //==================================================================

    /**
     * Adds a new entry in the given map.
     */
    public void execute(DropTreeView dropTreeView) 
    throws Exception
    {
       
        // Obtains the selected Map.
        java.util.Map map = (java.util.Map)dropTreeView.getSelectedObject();
        
        // Obtains the drag entry to add.
        Object objectKey = dropTreeView.getDragSourceEntry().getName();
        Object objectToAdd = dropTreeView.getDragSourceObject();
        
        // Adds the entry.
        map.put(objectKey, objectToAdd);
    }
        
}