/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.info;

import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.Info;
import org.objectweb.util.browser.core.api.AssociatedInfo;
import org.objectweb.util.browser.core.api.BrowserProperty;
import org.objectweb.util.browser.core.api.InfoFactory;
import org.objectweb.util.browser.core.common.AssociatedElementImpl;

/**
 * 
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class AssociatedInfoImpl 
    extends AssociatedElementImpl
    implements AssociatedInfo {

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // Constructor.
    // 
    //==================================================================

    /**
     * Constructs an AssociatedInfoImpl.
     * @param loader The propertyLoader to use to load new configuration.
     */
    public AssociatedInfoImpl(BrowserProperty loader) {
        super();
        context_ = new InfoPropertyContainer(loader);
    }
    
    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================


    public Info getInfo(Object node, boolean disabledJavaLangObject) {
        if (context_ != null) {
            Entry entry = context_.getRecursiveProperty(node);
            if (entry != null && !(entry.getName().toString().equals("java.lang.Object") && disabledJavaLangObject)) {
                InfoFactory infoFactory = (InfoFactory) entry.getValue();
                return infoFactory.newInfo(node);
            }
        }
        return null;
    }

    public Info getInfo(Object node) {
        return getInfo(node,false);
    }

}

    