/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.panel;

import java.awt.Color;
import javax.swing.JPanel;
import javax.swing.JLabel;

import org.objectweb.util.browser.api.Panel;
import org.objectweb.util.browser.api.TreeView;

/**
 * Abstract class which allows user to simply add a title in a panel.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 * 
 * @version 0.1
 */
public abstract class TitlePanel
     extends JPanel 
  implements Panel {
    
    /**
     * Overriding methods
     * @see org.objectweb.util.browser.api.Panel#selected(org.objectweb.util.browser.api.TreeView)
     */
    public void selected(TreeView treeview) {
        setBackground(Color.white);
        add(new JLabel(getTitle(treeview)));
    }

    /**
     * Overriding methods
     * @see org.objectweb.util.browser.api.Panel#getPanel()
     */
    public JPanel getPanel() {
        return this;
    }

    /**
     * Overriding methods
     * @see org.objectweb.util.browser.api.Panel#unselected(org.objectweb.util.browser.api.TreeView)
     */
    public void unselected(TreeView treeview) {
        // Nothing to do!
    }

    /**
     * Provides the title of the panel
     */
    public abstract String getTitle(TreeView treeView);
    
}
