/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.core.xmlparser;

/**
 * Parses a Java object wihch representes an XML Configuration. 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public interface XMLParser {

    // ==================================================================
    //
    // No internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Fixes the file (or directory) which contains the properties.
     * @param path The path containing the XML file(s) containing the configuration we want to abtain under a Context view (It can be a single file or a directory)
     */
    public void setPropertyFile(String path);

    /**
     * Fixes an array of files (or directories) which contains the properties.
     * @param files The path containing the XML file(s) containing the configuration we want to abtain under a Context view (Each value of the array can be a single file or a directory)
     */
    public void setPropertyFile(String[] files);

}
