/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.CORBA;

import org.objectweb.util.explorer.swing.gui.api.Console;
import org.objectweb.util.explorer.swing.gui.lib.DefaultDialogConsole;

/**
 * This class provides a graphical console.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class ConsoleFactory {
    
    /** The Console instance */
    protected static Console pingConsole_ = null;

    /** The Debug console instance */
    protected static Console debugConsole_ = null;

    public static Console getDebugConsole(){
        if(debugConsole_ == null){
            debugConsole_ = new DefaultDialogConsole("OpenCCM debug console", false);
        }
        return debugConsole_;
    }

    public static Console getPingConsole(){
        if(pingConsole_ == null){
            pingConsole_ = new DefaultDialogConsole("OpenCCM ping console", true);
        }
        return pingConsole_;
    }

}
