/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.Components;

import org.omg.Components.CCMObject;
import org.omg.Components.EmitterDescription;

/**
 * This class is composed by
 * <ul>
 * <li>A SubscriberDescription reference.</li>
 * <li>The associated PublisherDescription reference.</li>
 * <li>The component reference associates to the PublisherDescription</li>
 * </ul>
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class EmitterContainer {

    /** The EmitterDescription reference. */
    protected EmitterDescription emitter_;

    /** The EmitterDescription's associated component */
    protected CCMObject component_;

    /**
     * Gets the EmitterDescription's associated component.
     * @return
     */
    public CCMObject getComponent() {
        return component_;
    }

    /**
     * @return
     */
    public EmitterDescription getEmitter() {
        return emitter_;
    }

    /**
     * Sets the PublisherDescription's associated component.
     * @param object
     */
    public void setComponent(CCMObject component) {
        component_ = component;
    }

    /**
     * @param description
     */
    public void setEmitter(EmitterDescription emitter) {
        emitter_ = emitter;
    }

}
