/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.explorer.CosTrading;

import org.objectweb.util.explorer.api.Context;
import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.core.naming.lib.DefaultEntry;
import org.omg.CosTrading.Link;
import org.omg.CosTrading.LinkPackage.LinkInfo;

/**
 * Basic implementation of the Context interface
 * for managing trader Links. 
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 * @version 0.1
 */
public class LinkContext
  implements Context
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for interface Context.
    //
    // ==================================================================

    public Entry[] getEntries(Object object) {
        Link link_ = (Link)object;
        
        String[] names = link_.list_links();
        Entry[] values = new Entry[names.length];

        for (int i = 0; i < names.length; i++) {
            try {
                LinkInfo link = link_.describe_link(names[i]);
                values[i] = new DefaultEntry(names[i], link);
            } catch (org.omg.CosTrading.LinkPackage.IllegalLinkName ex) {
                // cannot happened !! 
            } catch (org.omg.CosTrading.LinkPackage.UnknownLinkName ex) {
                // cannot happened !! 
            }
        }
        return values;        
    }

}
