/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.menu;

import org.objectweb.fractal.api.Component;
import org.objectweb.openccm.corba.TheORB;
import org.objectweb.openccm.explorer.CORBA.ConsoleFactory;

/** The java API's imports */
import javax.swing.ImageIcon;

/**
 * This class displays the "about" box.
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class DisplayAboutDialogAction extends AbstractMenuAction {

    protected java.awt.Frame parent_ = null;

    public DisplayAboutDialogAction(java.awt.Frame parent, String nom, ImageIcon image, String desc, Integer mnemonic, Component tree) {
        super(nom, image, desc, mnemonic, tree);
        parent_=parent;
    }

    public void actionPerformed(java.awt.event.ActionEvent ae) {
        (new AboutDialog(parent_)).show();
    }

}
