/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.menu;

/** The java API's imports */
import javax.swing.JPanel;
import javax.swing.Box;
import java.io.File;

/**
 * This class represents the panel which allows to choose a file and specify a label to the entry
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class FileChooserPanel extends JPanel {

    protected LabelBox labelBox_ = null;

    protected FileChooserBox fileChooserBox_ = null;

    public FileChooserPanel(String nameFieldLabel, String nameBrowserLabel, int fileFilterType) {
        Box box = Box.createVerticalBox();
        box.add(Box.createVerticalGlue());
        labelBox_ = new LabelBox(nameFieldLabel);
        box.add(labelBox_);
        box.add(Box.createVerticalStrut(10));
        fileChooserBox_ = new FileChooserBox(nameBrowserLabel, fileFilterType);
        box.add(fileChooserBox_);
        box.add(Box.createVerticalGlue());
        add(box);
    }

    /** Returns the specify label */
    public String getLabel() {
        return labelBox_.getLabel();
    }

    /** Returns the chosen file */
    public File getFile() {
        return fileChooserBox_.getFile();
    }

}