/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.corba;

// Package dependencies.

/**
 * This interface describes an holder for CORBA::UserException exceptions.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.1
 */
public interface UserExceptionHolder
{
    /**
     * Obtains the wrapped CORBA::UserException object.
     *
     * @return The wrapped CORBA::UserException object.
     */
    public org.omg.CORBA.UserException
    getUserException();

    /**
     * Sets the wrapped CORBA::UserException object.
     *
     * @param userException The wrapped CORBA::UserException object.
     */
    public void
    setUserException(org.omg.CORBA.UserException userException);
}
