/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation AssemblyFactoryManager component.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class AssemblyFactoryManagerImpl
     extends org.objectweb.openccm.OpenCCM_DCI
             .AssemblyFactoryManagerSessionComposition
             .AssemblyFactoryManagerImpl
{
    // ==================================================================
    //
    // Internal state
    //
    // ==================================================================
   
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // contructor.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

     /**
     * Container callback to signal that the component is removed.
     *
     * @throw org.omg.Components.CCMException For any problems.*
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
    	try{
    		((AssemblyFactorySegImpl)
        	 obtain_executor("assembly_factory")).destroy_assembly_factory();
    	}
		catch(org.omg.Components.RemoveFailure e){
			System.err.println("Cannot remove all the assembly managers");
		}
        //TODO
        //(new org.objectweb.openccm.ccm.Deployment.ShutDownThread()).start();

    	org.objectweb.openccm.ccm.Deployment.ShutDownThread tr=
    		new org.objectweb.openccm.ccm.Deployment.ShutDownThread();
		tr.start();
		try{
			tr.join();
		}
		catch(InterruptedException e){
			e.printStackTrace();
		}

    }

    /**
     * Completes the component configuration.
     *
     * @exception org.omg.Components.InvalidConfiguration
     *            Thrown if the configuration is invalid.
     */
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {

        try{
            ((org.objectweb.openccm.OpenCCM_DCI.AssemblyFactoryManagerCCM)
             get_context())
                .connect_naming_service(
                                        org.omg.CosNaming.NamingContextExtHelper
                                        .narrow(
                                                org.objectweb.openccm.corba.TheNameService
                                                .getNamingContext()
                                                .getNamingContext()));
            ((AssemblyFactorySegImpl)
             obtain_executor("assembly_factory")).setup();
        }
        catch(Exception e){
            e.printStackTrace();
            System.err.println("Cannot configured the AssemblyFactory");
        }          
    }
   
    
}
