/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;
/**
 * This is the implementation of the 
 * OpenCCM_DCI::AssemblyManagerModelRegistration interface.
 * 
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */
public class AssemblyManagerModelRegistrationSegImpl  
    extends org.objectweb.openccm.OpenCCM_DCI.
            DCIManagerSessionComposition.AssemblyManagerModelRegistrationSeg
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Registration method to register a AssemblyManagerModel to a DCI
     * manager.
     * @param assembly_manager_model The component to register
     * @ return a connection cookie.
     */
    public org.omg.Components.Cookie
    register_assembly_manager_model(
                              org.objectweb.openccm.OpenCCM_DCI
                              .AssemblyManagerModel assembly_manager_model)
    {
        try{      
            //connect the ComponentServerManager and return the cookie
            return  
                ((org.objectweb.openccm
                  .OpenCCM_DCI.DCIManagerCCM)get_context())
                .connect_assembly_manager_models(assembly_manager_model) ;
        }
        catch(Exception e){e.printStackTrace();}        
        System.err.println("Error occured during assembly manager model connection");
     return null;   
    }
        
        
    /**
     * Unregistration method to unregister a AssemblyManagerModel to a DCI
     * manager.
     * @param cookie the cookie of the connection to break  
     */
    public void
    unregister_assembly_manager_model(org.omg.Components.Cookie cookie)
    throws org.omg.Components.CookieRequired
        {
           try{                         
               //Break the connection
               ((org.objectweb.openccm.OpenCCM_DCI.DCIManagerCCM)
                get_context())
                   .disconnect_assembly_manager_models(cookie);
           }
           catch(Exception e){
               e.printStackTrace();
               throw new org.omg.Components.CookieRequired();
           }
        }
    
}
