/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation of the OpenCCM_DCI::ContainerManagerRegistration
 * interface.
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */
public class ContainerManagerRegistrationImpl  
    extends org.objectweb.openccm.OpenCCM_DCI
            .ComponentServerManagerSessionComposition.
            ContainerManagerRegistrationSeg
{             

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    // Public methos.
    //
    // ==================================================================
    
    /**
     * Register a ContainerManager to the parent ComponentServer
     * @param container_manager The container manager to register
     * @return the registration cookie
     */
    public org.omg.Components.Cookie
    register_container_manager(org.objectweb.openccm
                               .OpenCCM_DCI.ContainerManager container_manager)
    {
        try{      
            //Connect the ContainerManager to the ComponentServerManager
            return  ((org.objectweb.openccm
                      .OpenCCM_DCI.ComponentServerManagerCCM)
                     get_context())
                .connect_container_managers(container_manager) ;
            }
        catch(Exception e){e.printStackTrace();}        
        return null;
    }

    /**
     * Unregister a ContainerManager to the parent ComponentServer
     * @param cookie The registration cookie to used.
     */
    public void
    unregister_container_manager(org.omg.Components.Cookie cookie)
        throws org.omg.Components.CookieRequired{
        try{ 
            ((org.objectweb.openccm.OpenCCM_DCI.ComponentServerManagerCCM)
            get_context())
            .disconnect_container_managers(cookie);
            }
            catch(Exception e){
                    e.printStackTrace();
                    throw new org.omg.Components.CookieRequired();
                    }
    }                
    
}             
