/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philipe Merle
Contributor(s): Briclet Frederic_____________________________________.

====================================================================*/


package org.objectweb.openccm.deploytool;

import java.io.*;
import java.net.*;



public class MicroServerHttp implements Runnable { 

    private Socket s; 
    private ServerSocket ss;
    private InputStream is;
    private String filename;
    
    public MicroServerHttp (ServerSocket ss) 
    { 
        this.ss=ss;         
    } 

    public MicroServerHttp(ServerSocket ss,java.io.InputStream is,String filename)
    {
        this.ss=ss;
        this.filename=filename;
        this.is=is;
    }
    
    public void run () 
    { 
        try { 
            s=ss.accept();

            InputStreamReader in = new InputStreamReader(s.getInputStream()); 
            PrintStream out = new PrintStream(s.getOutputStream()); 
            String rq = new LineNumberReader(in).readLine(); 
            System.err.println("Request received:"+rq); 
            if (rq.startsWith("GET ")) { 
                if(filename==null)
                    {                    
                        File f = new File(rq.substring(5, rq.indexOf(' ', 4))); 
                        if (f.exists() && !f.isDirectory()) { 
                            is = new FileInputStream(f); 
                        }
                        else return;
                    }               

                byte[] data = new byte[32000];                 

                out.print("HTTP/1.0 200 OK\n\n"); 
                
                 int readed=is.read(data,0,32000); 
                 while(readed>0)
                     {                                         
                         out.write(data,0,readed);            
                         readed=is.read(data,0,32000);
                     }
                
                is.read(data);
                is.close(); 
               
            } else { 
                    out.print("HTTP/1.0 404 Not Found\n\n"); 
                    out.print("<html>Document not found.</html>"); 
                } 
            out.flush();
            out.close(); 
            s.close(); 

        } catch (Exception e) {e.printStackTrace(); } 
    } 


   //   public static void 
//         main (String[] args) 
//         throws IOException 
//         { 
//         ServerSocket s = new ServerSocket(0); 
       
//      System.out.println(s);
    
    
//      System.out.println("http://" + InetAddress.getLocalHost().getHostName() + ':' + s.getLocalPort() + '/' +args[0]);
    
//      while (true) { new Thread(new MicroServerHttp(s.accept())).start(); } 
//      } 
   
} 
