/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.installer;

import org.objectweb.openccm.descriptor.componentassembly.beans.ComponentpropertiesBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.*;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.util.FileinarchiveDeployer;

/**
 * This handler is used to produce componentpropertiesployer from an
 * componentproperties bean .
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ComponentpropertiesDeployerHandler 
       extends HandlerBase 
    {
 
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================   
    private ComponentpropertiesDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================    
    /**
     * Produce the componentpropertiesdeployer binded
     * to the givean @param bean.
     * 
     * @param bean The componentproperties bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */
    public Object 
    getInstance(ComponentpropertiesBeanImpl bean)
    throws InitializationError
    {
        if(_deploy==null)
        {
             _deploy=new ComponentpropertiesDeployer();
             applyCommonConfig(_deploy);
             _deploy.connectComponentproperties(bean);
             _deploy.connectFileinarchiveDeployer
                    ((FileinarchiveDeployer)getDeployer(bean.getFileinarchive()));
              _deploy.initialize();
         }     
     return (_deploy);
    }
    
}
