/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.installer;


import org.objectweb.openccm.descriptor.componentassembly.beans.ExistinghomeBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.util.FindbyDeployer;

/**
 * This handler is used to produceexistinghomeDeployer from an
 * existinghome bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ExistinghomeDeployerHandler 
       extends HandlerBase 
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================    
    private ExistinghomeDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Produce the existinghome deployer binded
     * to the givean @param comp.
     * 
     * @param comp The existinghome bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */      
    public Object getInstance(ExistinghomeBeanImpl  comp)
    throws InitializationError 
    {
       if(_deploy==null){
           _deploy=new ExistinghomeDeployer();
           _deploy.connectExistinghome(comp);
           applyCommonConfig(_deploy);
           _deploy.connectFindbyDeployer((FindbyDeployer)getDeployer(comp.getFindby()));
           _deploy.initialize();       
       }
       return (_deploy);
    }
}
