/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.registrar;

import org.objectweb.openccm.descriptor.componentassembly.beans.RegisterwithnamingBean;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.ChildDeployerContext;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
import org.omg.CosNaming.NamingContextExt;

/**
 * The registerwithnaming deployer context defines all the connection requires for
 * corba object registration.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class RegisterwithnamingDeployerContext 
       extends ChildDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private RegisterwithnamingBean registerwithnaming;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public accessors methods.
    //
    // ==================================================================
    public void 
    connectRegisterwithnaming(RegisterwithnamingBean bean) 
    {
        this.registerwithnaming = bean;
        connectDeployerDescription(bean);
    }

    protected RegisterwithnamingBean 
    getRegisterwithnaming() 
    {
        return registerwithnaming;
    }

    protected NamingContextExt 
    getNamingcontextExt() 
    {
        return getRootDeployerContext().getNamingContextExt();
    }
    /**
     * This initialization method is used to check that all the services and 
     * information required to deploy are presents. If all is OK the deployer 
     * is put in inactive deployer state waiting for the deployment processing.
     * 
     * @exception InitializationError is thrown if a problem is detected 
     */
    public void initialize() throws InitializationError {
        // TODO Auto-generated method stub
        if(getRegisterwithnaming()==null)
             getErrorManager()
             .submitException(new InitializationError(this,"Connection on registerwithnaming bean is required"+
                                                     "check the handler code it must specify this connection"));
                      
       if(getRegisterwithnaming().getName()==null||
          getRegisterwithnaming().getName().length()==0)
                getErrorManager()
                .submitException( new InitializationError(this,"The name attribute of the registerwithnaming element"+
                                                          "must be fullfilled, check its "+
                                                          "description\n."+getStringifiedDeployerDescription()));
       if(getNamingcontextExt()==null)
             getErrorManager()
            .submitException(new InitializationError(this,"Connection on the current NameService is required to make"+
                                                     "make naming registration. Change your findby description if"+
                                                     "if you cannot start it.\n"+getStringifiedDeployerDescription()));                                                              
        getLifeCycleManager().stepEndedSuccessFully(); 
    }

}
