/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.softpkg.ccm;

import java.net.ServerSocket;

import org.objectweb.openccm.descriptor.ZipEntryRetriever;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.DeploymentLogger;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.ErrorManager;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.RootDeployerContext;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.installer.DestinationDeployerFactory;

/**
 * The root context for all the softpkg deployer tree.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class SoftpkgRootDeployerContext 
       extends RootDeployerContext 
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private RootDeployerContext globalDeployerContext;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================   

    public void
    initialize() 
    throws InitializationError 
    {
        // TODO Auto-generated method stub

    }

    /**
     * @param context
     */
    public void 
    connectGlobalDeployerContext(RootDeployerContext context) 
    {
        globalDeployerContext = context;
    }
    
    public RootDeployerContext 
    getGlobalDeployerContext()
    {
        return globalDeployerContext;        
    }
   
   
    public String 
    convertSymbol(String ch)
    {
        return getGlobalDeployerContext().convertSymbol(ch);
    }
    

       /**
     * @return
     */
    public DeploymentLogger 
    getDeploymentLogger() 
    {
       if(super.getDeploymentLogger()==null)
            super.connectDeploymentLogger
            (getGlobalDeployerContext().getDeploymentLogger());
       return super.getDeploymentLogger();
    }


    /**
     * @return
     */
    public DestinationDeployerFactory 
    getDestinationDeployerFactory() 
    {   
        if(super.getDestinationDeployerFactory()==null)
            super.connectDestinationDeployerFactory
                (getGlobalDeployerContext().getDestinationDeployerFactory());
        return super.getDestinationDeployerFactory();
    }


    /**
     * @return
     */
    public ErrorManager 
    getErrorManager() 
    {
        if(super.getErrorManager()==null)
            super.connectErrorManager
            (getGlobalDeployerContext().getErrorManager());
        return super.getErrorManager();
    }


    public ServerSocket 
    getServerSocket()
    {
        //return getGlobalDeployerContext().getServerSocket();
        if(super.getServerSocket()==null)
            super.connectServerSocket
            (getGlobalDeployerContext().getServerSocket());
        return super.getServerSocket();        
    }
    

    public ZipEntryRetriever 
    getZipEntryRetriever()
    {    
        if(super.getZipEntryRetriever()==null)
            super.connectZipEntryRetriever
            (getGlobalDeployerContext().getZipEntryRetriever());
        return super.getZipEntryRetriever();
    }
    
    public void
    connectZipEntryRetriever(ZipEntryRetriever zipEntryRetriever)
    {
        super.connectZipEntryRetriever(zipEntryRetriever);        
    }
   
    

}
