/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.DCI;

import org.objectweb.openccm.explorer.CORBA.ConsoleFactory;
import org.objectweb.util.explorer.api.RootContext;
import org.objectweb.util.explorer.api.RootEntry;
import org.objectweb.util.explorer.core.root.lib.DefaultRootEntry;

/**
 * Provides a reference on the current DCIManager if this one is started.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class DCIRootContext
  implements RootContext
{

    // ==================================================================
    //
    // No internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // No Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // No internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for interface Context.
    //
    // ==================================================================

    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.api.RootContext#getEntries()
     */
    public RootEntry[] getEntries() {
        java.util.Vector values = new java.util.Vector();
        // Adds the dci manager into the initial context
        try {
            org.omg.CORBA.Object o = org.objectweb.openccm.corba.TheORB.getORB().resolve_initial_references("DCI");
            values.add(new DefaultRootEntry("DCI Manager", o, 1));
        } catch (org.omg.CORBA.ORBPackage.InvalidName e1) {
            // DCI is not started
            ConsoleFactory.getDebugConsole().add("DCI Manager is not available! \n");
        } catch (org.omg.CORBA.TRANSIENT e1) {
            // Ignore (throws when the DCI is not started)
            ConsoleFactory.getDebugConsole().add("DCI Manager is not available! \n");
        }
        return (RootEntry[])values.toArray(new RootEntry[0]);
    }

}