/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.DCI;

import java.net.URL;

import org.objectweb.openccm.explorer.menu.JFileChooserSingleton;
import org.objectweb.openccm.explorer.menu.OpenCCMBrowserConstants;
import org.objectweb.util.explorer.api.TreeView;
import org.objectweb.util.explorer.swing.gui.api.DialogBox;
import org.objectweb.util.explorer.swing.gui.lib.FileChooserBox;
import org.objectweb.util.explorer.swing.gui.lib.LabelBox;
import org.omg.Components.Deployment.ComponentInstallation;



/**
 * The install operation installs a component on the particular host
 * on which the ComponentInstallation object resides.
 * The associated JFileChooser accepts jar files and car files.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class InstallOnComponentInstallation 
     extends org.objectweb.openccm.explorer.Deployment.InstallOnComponentInstallation {

    //==================================================================
    //
    // Internal states.
    //
    //==================================================================
    
    //==================================================================
    //
    // No constructor.
    //
    //==================================================================

    //==================================================================
    //
    // Internal methods surcharging the InstallOnComponentInstallation class.
    //
    //==================================================================

    /**
     * Creates a box containing all the box to specify all the params
     */
    protected void createBox(DialogBox dialogBox) {
        uuid_ = new LabelBox("UUID");
        dialogBox.addElementBox(uuid_);
        location_ = new FileChooserBox("Location",JFileChooserSingleton.getInstance(OpenCCMBrowserConstants.COMPONENT_ARCHIVE_FILE_CHOOSER));
        dialogBox.addElementBox(location_);
    }
}
