/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 5 juin 2003 by jerome OFFROY (offroy@lifl.fr)
 *
 */

package org.omg.lifl.eclipse.plugin.project.utils.SWT;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Listener;

/**
 * @author offroy
 *
 */
public class CheckGroup {

	private Group subGroup;
	private boolean subGroupVisible;
	private Button checkBox;
	private String groupTitle;
	private Group group;
	
	public CheckGroup(Composite parent,String title) {
		subGroupVisible = true;
		setGroupTitle(title);
		group = new Group(parent, SWT.NONE);
		checkBox = new Button(group, SWT.CHECK);
		
		group.setLayout(new RowLayout());
		group.setText(getGroupTitle());
		
		checkBox.setSelection(subGroupVisible);
		checkBox.addListener(SWT.Selection, new Listener() {

			public void handleEvent(Event e) {
				subGroupVisible = checkBox.getSelection();
				if (subGroup != null)
                // TODO disable on cascade whereas make subGroup disapear
                //    subGroup.setEnabled(subGroupVisible);
					subGroup.setVisible(subGroupVisible);
				else //TODO do something when there is no subGroup
					;
			}
		});

	}


	/**
	 * @return
	 */
	public Group getSubGroup() {
		return subGroup;
	}

	/**
	 * @param group
	 */
	public void setSubGroup(Group group) {
		subGroup = group;
	}

	/**
	 * @return
	 */
	public Group getGroup() {
		return group;
	}

	/**
	 * @param group
	 */
	public void setGroup(Group group) {
		this.group = group;
	}

	/**
	 * @return
	 */
	public String getGroupTitle() {
		return groupTitle;
	}

	/**
	 * @param string
	 */
	public void setGroupTitle(String string) {
		groupTitle = string;
	}

	/**
	 * @return
	 */
	public boolean isSubGroupVisible() {
		return subGroupVisible;
	}

	/**
	 * @param b
	 */
	public void setSubGroupVisible(boolean b) {
		subGroupVisible = b;
	}

}
