/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/
/*
 * Created on 10 juin 2003 by jerome OFFROY (offroy@lifl.fr)
 *
 */
 
package org.omg.lifl.eclipse.plugin.project.utils.SWT;

import org.eclipse.swt.widgets.Group;

/**
 * This class is used to make a basic SWT area with a Text SWT widget 
 * which allow configuration of some preferences store in a SetterGroupPreference
 *      this basic SWT use a check button to set its visibility
 *      this class implements update of the SWT Text widget's value 
 *      and synchonisation with its corresponding preferences 
 *
 * @author offroy@lifl.fr
 *
 * @version 0.1
 */
public class DirectoryChooserCheckTextSetter extends DirectoryChooserCheck {

    /**
     * Constructor
     * @param parent is the SWT parent group
     * @param preference the preferences to manage 
     */
    public DirectoryChooserCheckTextSetter(Group parent, SetterGroupPreference preference) {
        super(parent, preference);
    }

    /* (non-Javadoc)
     * @see org.omg.lifl.plugin.project.utils.SWT.DirectoryChooser#config(java.lang.String)
     */
    protected void config(String buffer) {
        get_preference().set_Name(buffer);
        get_text().setText(buffer);
    }

}
