/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmfClientComponents.ManagedObjectClientComposition;

import intt.itu.itut_x780.*;
import intt.itu.itut_q816.*;
import intt.itu.itut_x780.CreateErrorConst.*;
import intt.itu.itut_x780.ApplicationErrorConst.*;
import intt.itu.itut_x780.DeleteErrorConst.*;
import intt.itu.itut_m3120.ManagedElementFactory;
import intt.itu.itut_m3120.ManagedElementFactoryHelper;
import intt.itu.itut_m3120.ManagedElement_F;
import intt.itu.itut_m3120.ManagedElement_FHelper;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmsMib.IpNodeFactory;
import ist.coach.coachEmsMib.*;

import ist.coach.coachEmfServicesComponents.AlarmChannelProvider;
import ist.coach.coachEmfServicesComponents.BasicLogProviderHome;
import ist.coach.coachEmfServicesComponents.BasicLogProviderHomeHelper;
import ist.coach.coachEmfServicesComponents.BasicLogProvider;
import ist.coach.coachEmfServices.EmfBasicLog.BasicLog;
import ist.coach.coachEmfClientComponents.ManagedObjectClientPackage.basic_logsConnection;
import ist.coach.coachEmfServices.EmfBasicLog.LogRecord;
//import ist.coach.coachEmfCommon.NamePrimaryKeyImpl;

import ist.coach.coachEmfClientComponents.InvokeSetData;
import ist.coach.coachEmfClientComponents.ManagedObjectClient;
import ist.coach.coachEmfClientComponents.ManagedObjectClientHelper;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;

import java.text.DateFormat;

import org.omg.CosNaming.NameComponent;
import ist.coach.coachEmfClientComponents.gui.GuiMaster;
/**
 **  Implementation class for the
 **  ::coachEmfClientComponents::ManagedObjectClient component.
 **/
public class ManagedObjectClientImpl
       extends ist.coach.coachEmfClientComponents.ManagedObjectClientComposition.ManagedObjectClient_impl
       implements ist.coach.coachEmfClientComponents.gui.GuiMaster
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================

	/** Business Logic **/
	ist.coach.itut_q816Components.ChannelFinderProvider channel_finder = null;
	ist.coach.coachEmfClientComponents.gui.GuiClient ui_client = null;
	private String name_;
	private String ems_root_;
	private String root_id_, root_kind_;
    org.omg.CosNaming.NamingContext root_context;


			// need reference to this object as ManagedObjectClient
	ManagedObjectClient myself = null;

	Hashtable alarmProviders;
	Hashtable logProviders;
	Vector subscribed_log_events;
	Thread child_thread = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    ManagedObjectClientImpl()
    {
		alarmProviders = new Hashtable();
		subscribed_log_events = new Vector();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
		//System.err.println("Client configuration called...");
        //
        //  DONE : implement !!!
        //
		// HACK: NameService is not needed when defered deployment is implemented
		 try {
            org.omg.CORBA.ORB orb =
                org.objectweb.ccm.CORBA.TheORB.getORB();

            org.omg.CORBA.Object obj =
                orb.resolve_initial_references("NameService");
            root_context = org.omg.CosNaming.NamingContextHelper.narrow(obj);
        }
        catch(Exception e_c) {
            System.err.println("Exception caught will resolving naming service: "
					+ e_c.getMessage());
            e_c.printStackTrace();
        }

		subscribed_log_events.add(GuiMaster.INFO_LOG);
		subscribed_log_events.add(GuiMaster.ERROR_LOG);
		subscribed_log_events.add(GuiMaster.WARNING_LOG);

		// LogService must be found to retrieve log records and events
		//
	//
	// HACK: currently home_finder interface has not been finalised by openccm.
	// the only way to find the homes is through the Naming Service
	//

		  //org.objectweb.openccm.components.HomeManager home_manager =
		  //  org.objectweb.ccm.Components.Runtime.get_home_manager();
/************************
		NameComponent[] homefinder_name = new NameComponent[3];
		homefinder_name[0] = new NameComponent("OpenCCM", "");
		homefinder_name[1] = new NameComponent("Services", "");
		homefinder_name[2] = new NameComponent("HomeFinder", "");

		try {
			 org.omg.CORBA.Object obj =
                    root_context.resolve(homefinder_name);
			org.omg.Components.HomeFinder home_manager =
				  org.omg.Components.HomeFinderHelper.narrow(obj);

		  if (home_manager != null)
		    System.err.println("Client> Home Manager was found!");
		  org.omg.Components.CCMHome ccm_logHome = home_manager.find_home_by_home_type(
		    BasicLogProviderHomeHelper.id());
		  //org.omg.Components.CCMHome ccm_logHome = home_manager.find_home_by_name("BasicLogHome");
		  BasicLogProviderHome logHome = BasicLogProviderHomeHelper.narrow(ccm_logHome);
		  if (logHome != null)
		    System.err.println("Client> Log Home has been retrieved!");

		  ist.coach.coachEmfServices.EmfBasicLog.BasicLog[] list_logs =
			  logHome.list_logs();
		  for(int i = 0; i < list_logs.length; i++) {
			System.err.print("ManagedObjectClient>list_logs[" + i + "].id = " + list_logs[i].id() + ", ");
			System.err.print("list_logs[" + i + "].get_max_size = " + list_logs[i].get_max_size());

		  }
		  //logHome.create();
		  //BasicLogProvider newLog = logHome.create(new NamePrimaryKeyImpl(1));
		  //newLog.configuration_complete();
		  //System.err.println("TEST = " + newLog.provide_i_BasicLog().id());
		  //System.err.println("Client> new log with id " + newLog.logId() + " has been created!");
		}
		catch(org.omg.Components.HomeNotFound ex_home) {
		  System.err.println("Client> Log Home can not be found!" + ex_home.getMessage());
		  ex_home.printStackTrace(System.err);
		}

		catch(org.omg.Components.DuplicateKeyValue log_ex) {
		  System.err.println("Client> Log component can not be created due to DuplicateKeyValue");
		}
		//catch(org.omg.CORBA.TypeCodePackage.BadKind log_ex2) {
		//  System.err.println("Client> Log Home can not be found due to bad kind!");
		//}
		catch(org.omg.Components.InvalidKey log_ex3) {
		  System.err.println("Client> Log component can not be created due to InvalidKey");
		}
		catch(org.omg.Components.CreateFailure log_ex4) {
		  System.err.println("Client> CreateFailure");
		}

	    catch(Exception e) {
				System.err.println("Client> Could not locate Log components");
				System.err.println("Message: " + e.getMessage());
				e.printStackTrace();
		}

************************/
		//
		// Register to all channels!!
		//
		NameComponent[] channel_finder_name = new NameComponent[3];
		channel_finder_name[0] = new NameComponent(root_id_, root_kind_);
		channel_finder_name[1] = new NameComponent("emf", "services");
		//channel_finder_name[0] = new NameComponent("coach", "ist");
		channel_finder_name[2] = new NameComponent("", "ChannelFinderService");

		try {
			 org.omg.CORBA.Object obj =
                    root_context.resolve(channel_finder_name);
			channel_finder = ist.coach.itut_q816Components.ChannelFinderProviderHelper.narrow(obj);

			if (channel_finder != null) {

				ChannelInfoType[] available_channels = channel_finder.provide_query().list();

				org.omg.CORBA.Object myself_o;
				myself_o = ((org.omg.Components.SessionContext) get_context()).get_CCM_object();
            	myself = ManagedObjectClientHelper.narrow(myself_o);

				AlarmChannelProvider alarm_channel_provider = null;
				for (int i = 0; i <  available_channels.length; i++) {

					if (available_channels[i].channel != null) {
							alarm_channel_provider =
						ist.coach.coachEmfServicesComponents.AlarmChannelProviderHelper.narrow(
								available_channels[i].channel);

							if (alarm_channel_provider == null) {
								System.err.println("alarm_channel_provider is null");
								continue;
							}

							String[] eventTypes = alarm_channel_provider.eventTypes();
							System.err.println("eventTypes.length = " + eventTypes.length);

							Vector alarmTypeV = new Vector();
							for (int j = 0; j < eventTypes.length; j++) {
								//System.err.println("--->INITIATING SUBSCRIPTION FOR " +
								//		eventTypes[j]);
									add_alarm_provider(alarm_channel_provider, eventTypes[j]);
									subscribe_alarm(eventTypes[j]);

							}

					}
				}
			}
			else
				System.err.println("Client> ChannelFinder reference is null...");
		}
		catch(Exception e) {
				System.err.println("Client> Could not locate ChannelFinder so that to " +
					" subscribe to alarms!");
				System.err.println("Message: " + e.getMessage());
				e.printStackTrace();
		}

		//
		// Start the gui
		//
        //HACK THREAD
	child_thread =	new Thread( ui_client = new ist.coach.coachEmfClientComponents.gui.GuiClient(name_, ems_root_,
					 this));
		//ui_client = new ist.coach.coachEmfClientComponents.gui.GuiClient(name_, this);
		System.err.println("Client configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // DONE: implement !!!
        //
		// Release the associated gui client.
        ui_client.dispose();
	if (child_thread != null) {
		child_thread.stop();
	}

    }

	public void add_alarm_provider(AlarmChannelProvider alarm_channel_provider,
						String alarmType) {


		Vector alarmTypeV = new Vector();

		if (alarmProviders.containsKey(alarmType))
            alarmTypeV = (Vector) alarmProviders.remove(alarmType);

		AlarmSubscriptionInfo alarm_channel_provider_record;
		int alarmTypeV_size = alarmTypeV.size();

		for(int i = 0; i < alarmTypeV_size; i++) {
			alarm_channel_provider_record = (AlarmSubscriptionInfo)  alarmTypeV.get(i);
			if (alarm_channel_provider_record.alarm_channel_provider.channelId().equals(
					alarm_channel_provider.channelId()))
					alarmTypeV.removeElementAt(i);
		}
		alarm_channel_provider_record = new AlarmSubscriptionInfo(alarm_channel_provider, null);
		alarmTypeV.add(alarm_channel_provider_record);

		alarmProviders.put(alarmType, alarmTypeV);
//		System.err.println("Addinf provider of " + alarmType + " alarms");

	}

	public void subscribe_alarm(String alarmType) {


		if (! alarmProviders.containsKey(alarmType))
			return;

		Vector alarmTypeV = new Vector();
		alarmTypeV = (Vector) alarmProviders.get(alarmType);

		int alarmTypeV_size = alarmTypeV.size();

		AlarmChannelProvider alarm_channel_provider = null;
		org.omg.Components.Cookie ck = null;

		AlarmSubscriptionInfo alarm_channel_provider_record;

		for(int i = 0; i < alarmTypeV_size; i++) {

			alarm_channel_provider_record = (AlarmSubscriptionInfo)  alarmTypeV.get(i);
			alarm_channel_provider = alarm_channel_provider_record.alarm_channel_provider;

		  try {
			if (alarmType.equals(GuiMaster.OBJECT_CREATION_ALARM)) {
                  ck = alarm_channel_provider.subscribe_objectCreation_alarm(
                        myself.get_consumer_object_creation_alarm());
			}
			else
			if (alarmType.equals(GuiMaster.OBJECT_DELETION_ALARM)) {
                  ck = alarm_channel_provider.subscribe_objectDeletion_alarm(
                       myself.get_consumer_object_deletion_alarm());
			}
			else
			if (alarmType.equals(GuiMaster.STATE_CHANGED_ALARM)) {
				ck = alarm_channel_provider.subscribe_stateChanged_alarm(
                       myself.get_consumer_state_changed_alarm());
			}
			else
			if (alarmType.equals(GuiMaster.OPERATIONAL_ALARM)) {
				ck = alarm_channel_provider.subscribe_operational_alarm(
                       myself.get_consumer_operational_violation_alarm());
			}
			else
			if (alarmType.equals(GuiMaster.HEARTBEAT_ALARM)) {
					ck = alarm_channel_provider.subscribe_heartbeat_event(
					 myself.get_consumer_heartbeat_alarm());
			}
			else
			if (alarmType.equals(GuiMaster.CHANNEL_CHANGE_ALARM)) {
				ck = alarm_channel_provider.subscribe_channelChange_event(
					myself.get_consumer_channel_change_alarm());
			}
		  }
		  catch(org.omg.Components.ExceededConnectionLimit ex1) {
			System.err.println("org.omg.Components.ExceededConnectionLimit caught " +
					ex1.getMessage());
			}

            if (ck == null) {
					System.err.println("Subscription cookie of " + alarmType +
							" is NULL!");
                  continue;
			}

            AlarmSubscriptionInfo info = new AlarmSubscriptionInfo(
                        alarm_channel_provider, ck);

            alarmTypeV = (Vector) alarmProviders.remove(alarmType);
			alarmTypeV.removeElementAt(i);
            alarmTypeV.add(info);

            alarmProviders.put(alarmType, alarmTypeV);
			System.err.println("Subscription for " + alarmType + " finished!");
		}
	}

	public void unsubscribe_alarm(String alarmType) {

	if (! alarmProviders.containsKey(alarmType))
            return;

        Vector alarmTypeV = new Vector();
        alarmTypeV = (Vector) alarmProviders.get(alarmType);

        int alarmTypeV_size = alarmTypeV.size();

        AlarmChannelProvider alarm_channel_provider = null;
        org.omg.Components.Cookie ck = null;

        AlarmSubscriptionInfo alarm_channel_provider_record;
		org.omg.Components.Cookie cookie = null;

        for(int i = 0; i < alarmTypeV_size; i++) {

            alarm_channel_provider_record = (AlarmSubscriptionInfo)  alarmTypeV.get(i);
            alarm_channel_provider = alarm_channel_provider_record.alarm_channel_provider;
			cookie = alarm_channel_provider_record.cookie;

			if (cookie == null)
				continue;

		  try {
            if (alarmType.equals(GuiMaster.OBJECT_CREATION_ALARM)) {
                  alarm_channel_provider.unsubscribe_objectCreation_alarm(cookie);
			}
			else
            if (alarmType.equals(GuiMaster.OBJECT_DELETION_ALARM)) {
                  alarm_channel_provider.unsubscribe_objectDeletion_alarm(cookie);
            }
            else
            if (alarmType.equals(GuiMaster.STATE_CHANGED_ALARM)) {
                alarm_channel_provider.unsubscribe_stateChanged_alarm(cookie);
            }
            else
            if (alarmType.equals(GuiMaster.OPERATIONAL_ALARM)) {
                alarm_channel_provider.unsubscribe_operational_alarm(cookie);
            }
            else
            if (alarmType.equals(GuiMaster.HEARTBEAT_ALARM)) {
                alarm_channel_provider.unsubscribe_heartbeat_event(cookie);
            }
            else
			if (alarmType.equals(GuiMaster.CHANNEL_CHANGE_ALARM)) {
                alarm_channel_provider.unsubscribe_channelChange_event(cookie);
            }

		  }
		  catch(org.omg.Components.InvalidConnection ex1) {}
		}
	}

	public void set_heartbeat_period(short period) {

		  NameComponent[] heartbeat_name =new NameComponent[3];
          heartbeat_name[0] = new NameComponent(root_id_, root_kind_);
          heartbeat_name[1] = new NameComponent("emf", "services");
          //heartbeat_name[0] = new NameComponent("coach", "ist");
          heartbeat_name[2] = new NameComponent("", "HeartbeatService");

		  try {
		    org.omg.CORBA.Object obj = root_context.resolve(heartbeat_name);

		    ist.coach.itut_q816Components.HeartbeatProvider heartbeat_provider =
			  ist.coach.itut_q816Components.HeartbeatProviderHelper.narrow(obj);

			    heartbeat_provider.provide_admin().periodSet(period);
		  }
		  catch(Exception e) {
			System.err.println("Client: set_heartbeat_period> Caught Exception " +
				  e.getMessage());
			e.printStackTrace(System.err);
		  }
	}

	public String[] get_all_logs() {

	    logProviders = new Hashtable();

		basic_logsConnection[] connected_logs = get_context().get_connections_basic_logs();
		String[] connected_logs_str = new String[connected_logs.length];

		for(int i = 0; i < connected_logs.length; i++) {
		  connected_logs_str[i] = connected_logs[i].objref.get_display_name();
		  System.err.println("ManagedObjectClient> " + connected_logs_str[i] + " Log found...");
		  logProviders.put(connected_logs_str[i],
						  connected_logs[i].objref);
		}


		return connected_logs_str;
	}

	public ist.coach.coachEmfServices.EmfBasicLog.LogRecord[] retrieve_logs(
		    String log_name, long from_time, int how_many) {

	    ist.coach.coachEmfServices.EmfBasicLog.LogRecord[] records =
		    new	ist.coach.coachEmfServices.EmfBasicLog.LogRecord[0];

		if (! logProviders.containsKey(log_name))
		    return records;

		BasicLog requested_log = (BasicLog) logProviders.get(log_name);
		ist.coach.coachEmfServices.EmfBasicLog.IteratorHolder iteratorH =
		    new ist.coach.coachEmfServices.EmfBasicLog.IteratorHolder();

		records = requested_log.retrieve(from_time, how_many, iteratorH);
		System.err.println("ManagedObjectClientImpl> retrieved_logs = " + records.length);
		return records;
	}

	public synchronized void subscribe_log(String logType) {
	    if (! subscribed_log_events.contains(logType))
		  subscribed_log_events.add(logType);
	}

	public synchronized void unsubscribe_log(String logType) {
	    if (subscribed_log_events.contains(logType))
		  subscribed_log_events.remove(logType);
	}

    // ==================================================================
    //
    // Public methods for the CCM_ManagedObjectClient local interface.
    //

    //
    //  IDL:coach.ist/coachEmfClientComponents/CCM_ManagedObjectClient/push_channel_change_alarm:1.0
    //
    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient::push_channel_change_alarm operation.
     **/
    public void
    push(ist.coach.itut_q816Components.ChannelChangeEvent event)
    {
        //
        //  DONE : implement
        //
			AlarmChannelProvider alarm_channel_provider =  
					ist.coach.coachEmfServicesComponents.AlarmChannelProviderHelper.narrow(
								event.channelInfo.channel);	

			String[] eventTypes = alarm_channel_provider.eventTypes();
			String display_types_str = new String();
			for (int j = 0; j < eventTypes.length; j++) {
					add_alarm_provider(alarm_channel_provider, eventTypes[j]);
					display_types_str += eventTypes[j];
					if (j < eventTypes.length - 1)
						display_types_str += ", ";

			}
			String[] sourceClasses = alarm_channel_provider.sourceClasses();
			String display_source_str = new String();
			for (int j = 0; j < sourceClasses.length; j++) {
					display_source_str += sourceClasses[j];
					if (j < sourceClasses.length - 1)
						display_source_str += ", ";
			}
		if (event.channelModification == ChannelModificationType.ChannelCreate) {

			for (int j = 0; j < eventTypes.length; j++) 
					add_alarm_provider(alarm_channel_provider, eventTypes[j]);

			ui_client.print_alarm("",
				ist.coach.coachEmfClientComponents.gui.GuiMessages.channel_change_alarm,
				"ChannelFinder", event.channelInfo.channelID, "", 
				"Create: " + display_types_str  + " events will be served from " + display_source_str + " sources");
		}
		else
		if (event.channelModification == ChannelModificationType.ChannelUpdate) {
			ui_client.print_alarm("",
				ist.coach.coachEmfClientComponents.gui.GuiMessages.channel_change_alarm,
				"ChannelFinder", event.channelInfo.channelID, "", 
				"Modify: " + display_types_str  + " events will be served from " + display_source_str + " sources");
		}
		else
		if (event.channelModification == ChannelModificationType.ChannelDelete) {
			ui_client.print_alarm("",
				ist.coach.coachEmfClientComponents.gui.GuiMessages.channel_change_alarm,
				"ChannelFinder", event.channelInfo.channelID, "", 
				"Remove: " + display_types_str  + " events will not be served from " + display_source_str + " sources");
		}
/***
		ui_client.print_alarm("",
				ist.coach.coachEmfClientComponents.gui.GuiMessages.channel_change_alarm,
				"", "", "", "");
******/
    }


    //
    //  IDL:coach.ist/coachEmfClientComponents/CCM_ManagedObjectClient_Executor/name:1.0
    //
    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::name attribute as accessor operation.
     **/
    public java.lang.String
    name()
    {
        //
        //  DONE : implement
        //
        return name_;
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::name attribute as mutator operation.
     **/
    public void
    name(java.lang.String val)
    {
        //
        //  DONE : implement
        //

		name_ = val;
		if (ui_client != null)
            ui_client.set_name(name_);
		System.err.println("Name is set to " + name_);
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::ems_root attribute as accessor operation.
     **/
    public java.lang.String
    ems_root()
    {
        //
        //  DONE : implement
        //
        return ems_root_;
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::ems_root attribute as mutator operation.
     **/
    public void
    ems_root(java.lang.String val)
    {
        //
        //  DONE : implement
        //

		ems_root_ = val;
		System.err.println("EMS Root is set to " + ems_root_);
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::root_id attribute as accessor operation.
     **/
    public java.lang.String
    root_id()
    {
        //
        //  DONE : implement
        //
        return root_id_;
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::root_id attribute as mutator operation.
     **/
    public void
    root_id(java.lang.String val)
    {
        //
        //  DONE : implement
        //

		root_id_ = val;
		System.err.println("EMS Root ID is set to " + root_id_);
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::root_kind attribute as accessor operation.
     **/
    public java.lang.String
    root_kind()
    {
        //
        //  DONE : implement
        //
        return root_kind_;
    }

    /**
     **  Implementation of the ::coachEmfClientComponents::CCM_ManagedObjectClient_Executor::root_kind attribute as mutator operation.
     **/
    public void
    root_kind(java.lang.String val)
    {
        //
        //  DONE : implement
        //

		root_kind_ = val;
		System.err.println("EMS Root Kind is set to " + root_kind_);
    }
    // ==================================================================
    //
    // Methods for the ist.coach.coachEmfClientComponents.gui.GuiMaster interface
    //
    // ==================================================================

    public void print(String msg) {
       // ui_client.print(msg);
        // HACK - Use of trace can be exploited
        System.err.print(msg);
    }

    public void println(String msg) {
        //ui_client.println(msg);
        System.err.println(msg);
    }

    public String createByManager(String object_class,
                        String[] param_names,
                        Object[] values,
                        String parent_key_val) {

        NameComponent[] parent_object_key = Utils.string2name(parent_key_val);
		String new_object_key = (values != null && values.length > 0) ?
			(String) values[0] : new String();

        //println("create is called on " + object_class);
        //println("param_names = " + param_names[0]);
        //println("param_val = " + (String) values[0]);

	  	try {

        	NameComponent[] factoryfinder_name =new NameComponent[3];
            factoryfinder_name[0] = new NameComponent(root_id_, root_kind_);
            factoryfinder_name[1] = new NameComponent("emf", "services");
            //factoryfinder_name[0] = new NameComponent("coach", "ist");
            factoryfinder_name[2] = new NameComponent("", "FactoryFinder");

			org.omg.CORBA.Object obj = root_context.resolve(factoryfinder_name);

			 ist.coach.itut_q816Components.FactoryFinderProvider factory_finder =
				ist.coach.itut_q816Components.FactoryFinderProviderHelper.narrow(obj);

			ManagedObjectFactory  mobject_f =  factory_finder.provide_query().find(
                			object_class + "Factory");

/***
			 ManagedObjectFactory mobject_f =
				ManagedObjectFactoryHelper.narrow(
					 factory_finder.provide_query().find(
				object_class + "Factory"));
		**/

			/** NameBinding is <subordinate_class>_<superior_class>.
				If superior class is the root object then kind is organisation
			*/
			String nameBinding = object_class + "_"
					+ Utils.name2kind(parent_key_val);
			System.err.println("Name Binding is " + nameBinding);

			if (mobject_f == null)  {
				System.err.println("Factory Object was null!!");
				 return new String();
			}

			NameComponent[] new_name = null;
			//new_object_key = new String();

				/* HACK: INTROSPECTION COULD BE EXPLORED!! */
			if (object_class.equals("ManagedObject")) {
				 new_name = mobject_f.create_base(nameBinding,
								parent_object_key, new_object_key);
			}
			else
			if (object_class.equals("ManagedElement")) {

				ManagedElementFactory element_factory =
				  ManagedElementFactoryHelper.narrow(mobject_f);

				String userLabel  = new String();
                if (values.length > 1 && values[1] != null)
					userLabel = (String) values[1];
				System.err.print("userLabel = " + userLabel + ", ");

				String vendorName  = new String();
                if (values.length > 2 && values[2] != null)
					vendorName = (String) values[2];
				System.err.print("vendorName = " + vendorName + ", ");

				String version  = new String();
                if (values.length > 3 && values[3] != null)
					version = (String) values[3];
				System.err.print("version = " + version + ", ");

				String locationName  = new String();
                if (values.length > 4 && values[4] != null)
					locationName = (String) values[4];
				System.err.println("locationName = " + locationName);

				new_name = element_factory.create(nameBinding,
									parent_object_key,
									new_object_key,
									new String[0],
									intt.itu.itut_x780.AdministrativeStateType.locked,
									userLabel,
									vendorName,
									version,
									locationName
			  );

			}
			else
			if (object_class.equals("IpNode")) {

				IpNodeFactory ipnode_factory = IpNodeFactoryHelper.narrow(
						mobject_f);

				String domainName = new String();
				if (values.length > 1 && values[1] != null)
					domainName = (String) values[1];
				System.err.print("domainName = " + domainName + ", ");

				String hostname = new String();
				if (values.length > 2 && values[2] != null)
					hostname = (String) values[2];
				System.err.print("hostname = " + hostname + ", ");

				byte[] managementIPAddress =  new byte[0];
				if (values.length > 3 && values[3] != null)
					managementIPAddress = ((String) values[3]).getBytes();
				System.err.print("managementIPAddress = " +  values[3] + ", ");

				int supportedSnmpVersions = 0;
				if (values.length > 4 && values[4] != null)
					supportedSnmpVersions = Integer.parseInt((String) values[4]);
				System.err.println("supportedSnmpVersions = " + supportedSnmpVersions);

				String userLabel  = new String();
                if (values.length > 5 && values[5] != null)
					userLabel = (String) values[5];
				System.err.print("userLabel = " + userLabel + ", ");

				String vendorName  = new String();
                if (values.length > 6 && values[6] != null)
					vendorName = (String) values[6];
				System.err.print("vendorName = " + vendorName + ", ");

				String version  = new String();
                if (values.length > 7 && values[7] != null)
					version = (String) values[7];
				System.err.print("version = " + version + ", ");

				String locationName  = new String();
                if (values.length > 8 && values[8] != null)
					locationName = (String) values[8];
				System.err.println("locationName = " + locationName);

				int snmpPort = 0;
				if (values.length > 9 && values[9] != null)
					snmpPort = Integer.parseInt((String) values[9]);
				System.err.print("snmpPort = " + snmpPort + ", ");

				String sysName =  new String();
				if (values.length > 10 && values[10] != null)
					sysName = (String) values[10];
				System.err.print("sysName = " + values[10] + ", ");

				String sysContact =  new String();
				if (values.length > 11 && values[11] != null)
					sysContact = (String) values[11];
				System.err.println("sysContact = " + values[11]);

                 //new_name = ((IpNodeFactory) mobject_f).create(nameBinding,
				System.err.println("Client>Ready to invoke create on IpNodeFactory...");
                 new_name = ipnode_factory.create(nameBinding,
									parent_object_key,
									new_object_key,
									new String[0],
									domainName,
									hostname,
									managementIPAddress,
									supportedSnmpVersions,
									intt.itu.itut_x780.AdministrativeStateType.locked,
									userLabel,
									vendorName,
									version,
									locationName,
									snmpPort,
									sysName,
									sysContact
							);

			}
			if (new_name != null && new_name.length > 0) {
				new_object_key = Utils.name2string(new_name);
			}
			else
				new_object_key = new String();
	    }
    	catch(CreateError create_e) {
			treat_create_exceptions(create_e);
			new_object_key = new String();
    	}
    	catch(ApplicationError appl_e) {
			treat_application_exceptions(appl_e);
			new_object_key = new String();
    	}
    	catch(Exception e_c) {
        	System.err.println("Exception caught: " + e_c.getMessage());
        	e_c.printStackTrace();
			new_object_key = new String();
    	}

    	return new_object_key;
    }

	public boolean removeByManager(String name) {

    	if (name == null || name.length() == 0)
        	return false;

    	try {
			NameComponent[] terminator_name = new NameComponent[3];
			terminator_name[0] = new NameComponent(root_id_, root_kind_);
			terminator_name[1] = new NameComponent("emf", "services");
			//terminator_name[0] = new NameComponent("coach", "ist");
			terminator_name[2] = new NameComponent("", "TerminatorService");

			org.omg.CORBA.Object obj = root_context.resolve(terminator_name);

			ist.coach.itut_q816Components.TerminatorServiceProvider terminator =
				ist.coach.itut_q816Components.TerminatorServiceProviderHelper.narrow(obj);

			if (terminator != null)  {
				terminator.provide_terminator().deleteByName(Utils.string2name(name));
				return true;
			}

		}
    	catch(DeleteError delete_e) {
			treat_delete_exceptions(delete_e);
			return false;
    	}
    	catch(ApplicationError appl_e) {
			treat_application_exceptions(appl_e);
			return false;
    	}
    	catch(Exception e_c) {
        	System.err.println("Exception caught: " + e_c.getMessage());
        	e_c.printStackTrace();
			return false;
    	}
		return false;

	}

	public ManagedObjectValueType attributesGet(String object_class,
                                String object_key,
                                String []attributes) {


		System.err.println("\n--->attributesGet is called for " + object_key +
				" of type " + object_class);

		ManagedObjectValueType attributes_values = null;
        NameComponent[] facade_name = new NameComponent[2];
    	try {
        	if (object_key == null || object_key.length() == 0)
            	return null;

            //facade_name[0] = new NameComponent("coach", "ist");
            facade_name[0] = new NameComponent(root_id_, root_kind_);
            facade_name[1] =
				//new NameComponent("", object_class + "Facade");
				new NameComponent("", Utils.name2facade(object_key));

			//System.err.println("Before resolving " + Utils.name2string(facade_name));
        	org.omg.CORBA.Object obj = root_context.resolve(facade_name);

			//System.err.println("Before narrowing " + Utils.name2string(facade_name));

			intt.itu.itut_x780.ManagedObject_F mobject_f =
			intt.itu.itut_x780.ManagedObject_FHelper.narrow(obj);
        	//ist.coach.itut_x780Components.ManagedObjectProvider mobject_f =
			//ist.coach.itut_x780Components.ManagedObjectProviderHelper.narrow(obj);

        	if (mobject_f == null) {
				System.err.println("Facade object can not be found!");
				return null;
			}

           	NameComponent[] obj_name = Utils.string2name(object_key);

           	attributes_values = (ManagedObjectValueType) mobject_f.attributesGet(
					Utils.string2name(object_key),
                   	new intt.itu.itut_x780.StringSetTypeHolder(attributes));

    	}
    	catch(ApplicationError appl_e) {
			treat_application_exceptions(appl_e);
    	}
    	catch(Exception e_c) {
        	System.err.println("Exception caught>"
					+ Utils.name2string(facade_name) +
						": " + e_c.getMessage());
        	e_c.printStackTrace();
    	}

        return attributes_values;
	}

	public String[] getContained(String superior) {

		//System.err.println("\n--->getContained is called for " + superior);
    	String[] subordinates = new String[0];
    	try {

        	NameComponent[] c_query = new NameComponent[3];
        	//c_query[0] = new NameComponent("coach", "ist");
        	c_query[0] = new NameComponent(root_id_, root_kind_);
        	c_query[1] = new NameComponent("emf", "services");
        	c_query[2] = new NameComponent("", "ContainmentService");
        	org.omg.CORBA.Object obj = root_context.resolve(c_query);

        	ist.coach.itut_q816Components.ContainmentServiceProvider containment =
				ist.coach.itut_q816Components.ContainmentServiceProviderHelper.narrow(obj);

        	if (containment != null)  {
            	NameComponent[][] children =
					containment.provide_containment_query().getContained(
                        Utils.string2name(superior));
            //println("Get contained " + superior + " returned " + children.length+ " children");

            	if (children != null && children.length > 0) {
                	subordinates = new String[children.length];
                	for(int i = 0; i < subordinates.length; i++)
                    	subordinates[i] = Utils.name2string(children[i]);
            	}
        	}
    	}
    	catch(Exception e_c) {
        	System.err.println("Exception caught: " + e_c.getMessage());
        	e_c.printStackTrace();
    	}

    	return subordinates;
	}

	public boolean setAttributes(String object_key, Vector set_data) {

		System.err.println("setAttributes is called on " + object_key +
				" of type " + Utils.name2kind(object_key));

        if (object_key == null || object_key.length() == 0)
                return false;

		String objectkind = Utils.name2kind(object_key);
		NameComponent[] facade_name = new NameComponent[2];
        try {
            facade_name[0] = new NameComponent(root_id_, root_kind_);
            //facade_name[0] = new NameComponent("coach", "ist");
            facade_name[1] =
                new NameComponent("", Utils.name2facade(object_key));
			 org.omg.CORBA.Object obj = root_context.resolve(facade_name);

			if (objectkind.equals("ManagedElement")) {

				ManagedElement_F  facade = ManagedElement_FHelper.narrow(obj);
				Enumeration set_operations = set_data.elements();
				while(set_operations.hasMoreElements()) {
					InvokeSetData set_method = (InvokeSetData) set_operations.nextElement();
					set_method.methodName.invoke(facade, set_method.methodArguments);
				}
			}
			else
			if (objectkind.equals("IpNode")) {

				IpNode_F  facade = IpNode_FHelper.narrow(obj);
				Enumeration set_operations = set_data.elements();
				while(set_operations.hasMoreElements()) {
					InvokeSetData set_method = (InvokeSetData) set_operations.nextElement();
					set_method.methodName.invoke(facade, set_method.methodArguments);
				}
			}
			else
			if (objectkind.equals("LogicalInterface")) {
				LogicalInterface_F facade = LogicalInterface_FHelper.narrow(obj);
				Enumeration set_operations = set_data.elements();
                while(set_operations.hasMoreElements()) {
                    InvokeSetData set_method = (InvokeSetData) set_operations.nextElement();
					set_method.methodName.invoke(facade, set_method.methodArguments);
                }
            }
			else
			if (objectkind.equals("SnmpProtocolMonitor")) {
			  SnmpProtocolMonitor_F facade = SnmpProtocolMonitor_FHelper.narrow(obj);
			  Enumeration set_operations = set_data.elements();
                while(set_operations.hasMoreElements()) {
                    InvokeSetData set_method = (InvokeSetData) set_operations.nextElement();
					set_method.methodName.invoke(facade, set_method.methodArguments);
                }
			}


		}
	 	//catch(ApplicationError appl_e) {
         //   treat_application_exceptions(appl_e);
		//	return false;
        //}
        catch(Exception e_c) {
            System.err.println("Exception caught>"
                    + Utils.name2string(facade_name) +
                        ": " + e_c.getMessage());
            e_c.printStackTrace();
			return false;
        }
		return true;
	}


	public void treat_create_exceptions(CreateError create_e) {
		System.err.println("Client caught exception during create operation:");
            switch(create_e.info.error.value) {
                case intt.itu.itut_x780.CreateErrorConst.duplicateName.value :
                    System.err.println("Object already exists");
                    System.err.println(create_e.info.details);
                    break;
                case intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value :
                    System.err.println("InvalidNameBinding has been provided");
                    System.err.println(create_e.info.details);
                    break;
                case intt.itu.itut_x780.CreateErrorConst.badName.value :
                    System.err.println("Bad Name");
                    System.err.println(create_e.info.details);
                    break;
            default:
                System.err.println(create_e.info.details);
            }
			ui_client.showCreateError(create_e.info.details);
	}

	public void treat_delete_exceptions(DeleteError delete_e) {
		System.err.println("Client caught exception during remove operation");
            switch(delete_e.info.error.value) {
                case intt.itu.itut_x780.DeleteErrorConst.notDeletable.value :
                    System.err.println("Element can not be deleted by the manager");
                    System.err.println(delete_e.info.details);
                    break;
                case intt.itu.itut_x780.DeleteErrorConst.containsObjects.value :
                    System.err.println("Element contains children and thus can not be deleted");
                    System.err.println(delete_e.info.details);
                    break;
            	default:
                	System.err.println(delete_e.info.details);
            }
			ui_client.showDeleteError(delete_e.info.details);

	}

	 public void treat_application_exceptions(ApplicationError appl_e) {
            System.err.println("Application exception caught:");
            switch(appl_e.info.error.value) {
                case intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value :
                    System.err.println("Object Not Found");
                    System.err.println(appl_e.info.details);
                    break;
                case intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value :
                    System.err.println("Invalid Parameter");
                    System.err.println(appl_e.info.details);
                    break;
            default:
                System.err.println(appl_e.info.details);
            }
			ui_client.showAttributesError(appl_e.info.details);
    }


private class AlarmSubscriptionInfo {

	org.omg.Components.Cookie cookie;
	AlarmChannelProvider alarm_channel_provider;

	AlarmSubscriptionInfo(AlarmChannelProvider alarm_channel_provider,
						org.omg.Components.Cookie cookie) {

		this.alarm_channel_provider = alarm_channel_provider;
		this.cookie = cookie;
	}
}
}
