package ist.coach.coachEmfClientComponents.gui;

import ist.coach.coachEmsMib.IpNodeValueType;
import intt.itu.itut_x780.ManagedObjectValueType;
import java.util.Vector;
import java.util.Hashtable;
import ist.coach.coachEmfClientComponents.InvokeSetData;
import ist.coach.coachEmfCommon.Utils;
import javax.swing.JPopupMenu;

import javax.swing.ImageIcon;

public class VisualIpNode
extends VisualManagedElement {

	static String[] subordinate_names = new String[0]; // { "IpNode"};
//	static String[] subordinate_vtype = new String[0]; //  { "VisualIpNode"};

	static boolean canRefresh = true;

	static String object_type = "IpNode";
	static String emsClassName = "ist.coach.coachEmsMib.IpNode_F";

    static String DISPLAY_TYPE = "IpNode";
    //
    // create arguments
    //
    static String[] create_arg_name = {"Name",
										"Domain Name",
										"Host Name",
										"IP Address",
										"SNMP Version",
										"User Label",
										"Product Vendor",
										"Product Version",
										"Location",
										"SNMP Port",
										"System Name",
										"Contact Person"};
    static String[] create_arg_editor = { "", "", "", "", "", "", "" };
    static String[] create_arg_renderer = { "", "", "", "", "", "", "" };
    //
    // get/set arguments
    //
    static String[] attributes_name = {"Name",
										"Element Type",
										"Creation Source",
										"Delete Policy",
												// ManagedElement attributes
										"Administrative State",
                                        "Operational State",
                                        "Usage State",
                                        "User Label",
                                        "Product Vendor",
                                        "Product Version",
                                        "Location",
												// IpNode attributes
									 	"Domain Name",
                                        "Host Name",
                                        "IP Address",
                                        "SNMP Version",
                                        "SNMP Port",
										"Number of Interfaces",
										"System Description",
										"SystemOID",
										"SNMP Agent Up Time",
										"System Services",
                                        "System Name",
                                        "Contact Person",
									};
    static boolean[] attributes_readonly = {false,
                                            false,
                                            false,
                                            false,
												// ManagedElement attributes
                                            true,
                                            false,
                                            false,
                                            true,
                                            false,
                                            true,
                                            true,
												// IpNode attributes
											false,
											false,
											false,
											false,
											false,
											false,
											false,
											false,
											false,
                                            false,
                                            true,
											true };


            //
            // settable arguments
            //
		static int SYSNAME_POS = 21;
		static int CONTACT_POS = 22;


	public VisualIpNode(String key) {

		super(key);
		leafIcon = new ImageIcon(
			VisualIpNode.class.getResource("images/ipnode_icon.gif"));

		nodeIcon = new ImageIcon(
        	VisualIpNode.class.getResource("images/ipnode_icon.gif"));

	}

    public Object[] translate_values( ManagedObjectValueType original_value_type) {

        if (original_value_type == null)
            return new Object[0];

		Object[] mo_values = super.translate_values(original_value_type);
        Object[] values = new Object[attributes_name.length];

		//System.err.println("Attributes of managed_element size = " +
		//		mo_values.length);
		int i = 0;
		for (i = 0 ; i < mo_values.length; i++)  {
					values[i] = mo_values[i];
		//			System.err.println(i + "= " + values[i]);
		}

		for (int k = i; k < values.length; k++)
				values[k] = "unspecified";

		IpNodeValueType value_type = (IpNodeValueType) original_value_type;

		String domainName = value_type.domainName;
		if (domainName != null && domainName.length() > 0)
			values[i] = new String(domainName);
		i++;

		String hostname = value_type.hostname;
		if (hostname != null && hostname.length() > 0)
			values[i] = new String(hostname);
		i++;

		if (value_type.managementIPAddress.length > 0)
			values[i] = new String(value_type.managementIPAddress);
		i++;

		values[i] = String.valueOf(value_type.supportedSnmpVersions);
		i++;

		values[i] = String.valueOf(value_type.snmpPort);
		i++;
		values[i] = String.valueOf(value_type.ifNumber);
		i++;

		String sysDescr = value_type.sysDescr;
		if (sysDescr != null && sysDescr.length() > 0)
			values[i] = new String(sysDescr);
		i++;

		String sysObjectID = value_type.sysObjectID;
		if (sysObjectID != null && sysDescr.length() > 0)
			values[i] = new String(sysObjectID);
		i++;

		values[i] = String.valueOf(value_type.sysUpTime);
		i++;

        //values[i++] = String.valueOf(value_type.sysServices);
		values[i] = SysServicesParser.parseSysServices(value_type.sysServices);
		i++;

		String sysName = value_type.sysName;
		if (sysName != null && sysName.length() > 0)
            values[i] = new String(sysName);
		i++;

		String sysContact = value_type.sysContact;
		if (sysContact != null && sysContact.length() > 0)
            values[i] = new String(sysContact);
		i++;

        return values;
    }

	public Vector translate_updates(Hashtable values) {

        System.err.println("Translate has been called on VisualIpNode!");
		Vector updates = super.translate_updates(values);
		 org.omg.CosNaming.NameComponent[] objectName = Utils.string2name(key);

		 if (values.containsKey(attributes_name[SYSNAME_POS])) {

            String attr_value = (String) values.get(attributes_name[SYSNAME_POS]);
            Object[] arg_val = {objectName, attr_value};
            InvokeSetData data_set = new InvokeSetData(emsClassName,
                        "sysNameSet",
                            arg_val
            );
            updates.add(data_set);
        }

		 if (values.containsKey(attributes_name[CONTACT_POS])) {

            String attr_value = (String) values.get(attributes_name[CONTACT_POS]);
            Object[] arg_val = {objectName, attr_value};
            InvokeSetData data_set = new InvokeSetData(emsClassName,
                        "sysContactSet",
                            arg_val
            );
            updates.add(data_set);
		}
		return updates;
    }

}
