package ist.coach.coachEmfClientComponents.gui;

/**
 * @author Administrator (digi@intracom.gr)
 *
 * Copyright (c) Intracom S.A., N.T., 2003
 */
public class SysServicesParser {
	
	private static final int PHYS_MASK = 1;
	private static final int DATALINK_MASK = 2;
	private static final int NETWORK_MASK = 4;
	private static final int TRANSPORT_MASK = 8;
	private static final int SESSION_MASK = 16;
	private static final int PRESENTATION_MASK = 32;
	private static final int APPLICATION_MASK = 64;
	
	private static final String PHYS_STR = "Physical Layer";
	private static final String DATALINK_STR = "Link Layer";
	private static final String NETWORK_STR = "Network Layer";
	private static final String TRANSPORT_STR = "Transport Layer";
	private static final String SESSION_STR = "Session Layer";
	private static final String PRESENTATION_STR = "Presentation Layer";
	private static final String APPLICATION_STR = "Application Layer";
	private static final String DELIMITER = ", ";
	private static final String END_DELIMITER = ".";
	
	public static String parseSysServices(int sysServices) {
		
		if (sysServices > (PHYS_MASK + DATALINK_MASK + 
			NETWORK_MASK + TRANSPORT_MASK + SESSION_MASK +
			PRESENTATION_MASK + APPLICATION_MASK))
		
			return new String ("System Services id (" + 
				sysServices + ") could not be parsed!");
		
		String systemSupportedServices = new String();
		
		if ( (sysServices & PHYS_MASK) ==  1)
		systemSupportedServices = systemSupportedServices.concat(PHYS_STR);
		
			
		if ( (sysServices & DATALINK_MASK) == DATALINK_MASK) {
			if(systemSupportedServices.equals("") == false)
				systemSupportedServices = systemSupportedServices.concat(DELIMITER);
			systemSupportedServices = systemSupportedServices.concat(DATALINK_STR);
		}
		
		if ( (sysServices & NETWORK_MASK) == NETWORK_MASK) {
			if(systemSupportedServices.equals("") == false)
				systemSupportedServices = systemSupportedServices.concat(DELIMITER);
			systemSupportedServices = systemSupportedServices.concat(NETWORK_STR);
		}
		
		if ( (sysServices & TRANSPORT_MASK) == TRANSPORT_MASK) {
			if(systemSupportedServices.equals("") == false)
				systemSupportedServices = systemSupportedServices.concat(DELIMITER);
			systemSupportedServices = systemSupportedServices.concat(TRANSPORT_STR);
		}
		
		if ( (sysServices & SESSION_MASK) == SESSION_MASK) {
			if(systemSupportedServices.equals("") == false)
				systemSupportedServices = systemSupportedServices.concat(DELIMITER);
			systemSupportedServices = systemSupportedServices.concat(SESSION_STR);
		}	
		
		if ( (sysServices & PRESENTATION_MASK) == PRESENTATION_MASK) {
			if(systemSupportedServices.equals("") == false)
				systemSupportedServices = systemSupportedServices.concat(DELIMITER);
			systemSupportedServices = systemSupportedServices.concat(PRESENTATION_STR);
		}
		
		if ( (sysServices & APPLICATION_MASK) == APPLICATION_MASK) {
			if(systemSupportedServices.equals("") == false)
				systemSupportedServices = systemSupportedServices.concat(DELIMITER);
			systemSupportedServices = systemSupportedServices.concat(APPLICATION_STR);
		}
		
		systemSupportedServices = systemSupportedServices.concat(END_DELIMITER);
		
		
		return systemSupportedServices;
	}
	
}
