/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_m3120Components.ManagedElementFactoryProviderComposition;

import org.omg.CosNaming.NameComponent;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.CreateController;
import ist.coach.coachEmfCommon.CreateBindingInfo;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.itut_m3120Components.ManagedElementMgmt;
import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;

import intt.itu.itut_m3120.conditionalPackages.*;
import intt.itu.itut_m3120.ManagedElementFactory;
import intt.itu.itut_m3120.ManagedElementFactoryHelper;

import ist.coach.coachEmfServices.EmfBasicLog.*;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/itut_m3120Components/ManagedElementFactoryProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class ManagedElementFactoryProviderImpl
     extends ist.coach.itut_m3120Components.ManagedElementFactoryProviderComposition.ManagedElementFactoryProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
 	   /* Business logic **/
    intt.itu.itut_q816.ContainmentComponent c_admin = null;
    intt.itu.itut_q816.Containment c_query = null;
	private BasicLog logSupport;

	private static final String FACTORY_CLASS = "ManagedElementFactory";
	ManagedElementMgmt facade = null;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public ManagedElementFactoryProviderImpl()
    {
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
	    if ((facade = get_context().get_connection_facade()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_admin = get_context().get_connection_containment_admin()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_query = get_context().get_connection_containment_query()) == null)
            throw new org.omg.Components.InvalidConfiguration();

		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		    // If managers may create, then the factory must register to the
            // factory finder service
        intt.itu.itut_q816.FactoryFinderComponent factoryfinder_admin =
            get_context().get_connection_factoryfinder_admin();

		 org.omg.CORBA.Object myself_o;
		 ManagedElementFactory myself = null;

        try {
			myself_o = ((org.omg.Components.SessionContext) get_context()).get_CCM_object();
        	myself = ManagedElementFactoryHelper.narrow(myself_o);

            factoryfinder_admin.register(FACTORY_CLASS, myself);
        }
        catch(intt.itu.itut_x780.ApplicationError ex) {
            throw new org.omg.Components.InvalidConfiguration();
        }
		catch(Exception e) {
			System.err.println("ManagedElementFactory has problems retrieving CCM component");
		}

		System.err.println("ManagedElementFactoryProvider configuration completed...");
    }
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_m3120::ManagedElementFactory::create operation.
     */
    public org.omg.CosNaming.NameComponent[]
    create(java.lang.String nameBinding,
	    org.omg.CosNaming.NameComponent[] superior,
		java.lang.String reqID,
		java.lang.String[] packageNameList,
		intt.itu.itut_x780.AdministrativeStateType administrativeState,
		java.lang.String userLabel,
		java.lang.String vendorName,
		java.lang.String version,
		java.lang.String locationName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
	    //
        //  DONE : implement
        //

	    String nameBinding_str = "intt.itu.itut_m3120.NameBindings." +
                nameBinding;

		CreateBindingInfo info = CreateController.checkNameBinding(nameBinding_str);

		String objectKind = info.objectKind;
		short deletePolicy = info.deletePolicy;

        // Check if the parent exists
        if (! c_query.exists(superior)) {
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);

            error_code.details = Utils.name2string(superior) +
                            ExceptionMessages.parent_object_error;

            throw new ApplicationError(error_code);
        }
		        // The system must have the capability of auto-naming objects
        String allocatedId = reqID;
        if (reqID == null || reqID.length() == 0) {

            org.omg.CosNaming.NameComponent[][] siblings =
                c_query.getContained(superior);

				allocatedId = CreateController.autoCreateId(siblings);
        }

        // Construct the name of the new object
        org.omg.CosNaming.NameComponent[] full_name = CreateController.createFullName(
					superior,
					allocatedId,
					Utils.name2facade(facade.facade_name()),
					objectKind);

        // Decide the conditional packages that are supported.
        String [] supportedConditionalPackages = packageNameList;
         if (packageNameList.length == 0) {

            System.err.println("No packages are specified." +
                "Trying to determine supported packages...");

            if (vendorName.equalsIgnoreCase("Linux") ||
                vendorName.equalsIgnoreCase("RedHat Linux")  ||
                vendorName.equalsIgnoreCase("RedHat")) {

                System.err.println("ManagedElementFactoryProvider>Found linux System...");

                System.err.println("supported packages:");
                System.err.println("\t" + locationNamePackageType.value);
                System.err.println("\t" + userLabelPackageType.value);
                System.err.println("\t" + vendorNamePackageType.value);
                System.err.println("\t" + versionPackageType.value);

                supportedConditionalPackages = new String[4];

                supportedConditionalPackages[0] = locationNamePackageType.value;
                supportedConditionalPackages[1] = userLabelPackageType.value;
                supportedConditionalPackages[2] = vendorNamePackageType.value;
                supportedConditionalPackages[3] = versionPackageType.value;
            }
        }
        else {
            System.err.println("ManagedElementFactory;create> " +
			" will not determine supported conditional Packages," +
                " because Manager already specified them.");
        }
		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "proceed to create " + Utils.name2string(full_name));
		facade.create(full_name, objectKind, supportedConditionalPackages, deletePolicy,
                    intt.itu.itut_x780.SourceIndicatorType.managementOperation,
					administrativeState,
					userLabel,
					vendorName,
					version,
					locationName);


		c_admin.addName(full_name, superior);
		System.err.println("ManagedElementFactory>Registered " +
		  Utils.name2string(full_name) + "  to the containment service");

		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "successfully created " + Utils.name2string(full_name));
		return full_name;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObjectFactory::create_base operation.
     */
    public org.omg.CosNaming.NameComponent[]
    create_base(String nameBinding, org.omg.CosNaming.NameComponent[] superior, String reqId)
    throws intt.itu.itut_x780.CreateError,

           intt.itu.itut_x780.ApplicationError
    {
        //
        // TODO : Implement
        //
        return null;
    }

}
