/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_q816Components.TerminatorServiceProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.DeleteErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.DeleteError;
import intt.itu.itut_x780.ManagedObject_F;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/itut_q816Components/TerminatorServiceProviderComposition/TerminatorServiceProviderHome_impl/TerminatorServiceProvider_impl/terminatorSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class terminatorSegImpl
     extends ist.coach.itut_q816Components.TerminatorServiceProviderComposition.terminatorSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	// ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public terminatorSegImpl()
    {

    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816::TerminatorService::deleteByName operation.
     */
    public void
    deleteByName(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,
    intt.itu.itut_x780.DeleteError
    {
	    //
        //  DONE : implement
        //

		String name_str 	= Utils.name2string(name);
		String facade_name 	= Utils.name2facade(name_str);

		if (facade_name.length() == 0) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.root_delete_error;

			System.err.println("Terminator: Root Object can not be deleted!");
            throw new ApplicationError(error_code);
		}
		System.err.println("Terminator>deleteByName called for " + name_str + " of " +
				facade_name);

	  intt.itu.itut_q816.Containment c_query = null;

	  if ((c_query = get_context().get_connection_containment_query()) == null) {
		  ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.components_connect_error;

			System.err.println("Terminator:ContainmentQuery can not be located!!");
            throw new ApplicationError(error_code);
	  }

/* HACK: Must have <componentsupportedinterface> in deployment script */
/********/
		ist.coach.itut_q816Components.
		TerminatorServiceProviderPackage.target_facadesConnection [] facades =
			get_context().get_connections_target_facades();

		int i = 0;
		org.omg.CosNaming.NameComponent[] facade_name_comp;
		for(i = 0; i < facades.length; i++) {
			facade_name_comp = facades[i].objref.nameGet();
			//System.err.println("TerminatorService>Examining facade " +
			//  Utils.name2string(facade_name_comp));

			int len = facade_name_comp.length;
			if (len > 0 &&
				facade_name_comp[len - 1].kind.equals(facade_name))

					break;
		}

		if (i >= facades.length) {

			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.facade_not_exists_error;

			System.err.println("Terminator: Could not locate the facade!");
            throw new ApplicationError(error_code);
		}

		ManagedObject_F facade = facades[i].objref;

		short objectDeletePolicy = facade.deletePolicyGet(name);

		org.omg.CosNaming.NameComponent[][] contained_objects = null;
		switch (objectDeletePolicy) {

		case intt.itu.itut_x780.notDeletable.value:

			//System.err.println("notDeletable policy holds");

			DeleteErrorInfoTypeImpl error_code =
               	new DeleteErrorInfoTypeImpl();
           	error_code.error = new UIDType(
               	intt.itu.itut_x780.DeleteErrorConst.moduleName.value,
               	intt.itu.itut_x780.DeleteErrorConst.notDeletable.value);
           	error_code.details = name_str + ExceptionMessages.manager_delete_error;
			throw new DeleteError(error_code);

		case intt.itu.itut_x780.deleteOnlyIfNoContainedObjects.value:

			//System.err.println("deleteOnlyIfNoContainedObjects policy holds");

			contained_objects = c_query.getContained(name);

			if (contained_objects.length > 0) {

				DeleteErrorInfoTypeImpl error_contained =
                	new DeleteErrorInfoTypeImpl();
            	error_contained.error = new UIDType(
                	intt.itu.itut_x780.DeleteErrorConst.moduleName.value,
                	intt.itu.itut_x780.DeleteErrorConst.containsObjects.value);
            	error_contained.details = ExceptionMessages.contains_object_error +
								".\n " + name_str + " contains " +
                	contained_objects.length + " children";
				throw new DeleteError(error_contained);
			}

			delete(name, facade);
			//delete(name, facades[i].objref);
			return;

		case intt.itu.itut_x780.deleteContainedObjects.value:

			//System.err.println("deleteContainedObjects policy holds");

            contained_objects = c_query.getContained(name);

			if (contained_objects.length ==  0) {
				delete(name, facade);
				//delete(name, facades[i].objref);
				return;
			}

			for(int j = 0; j < contained_objects.length; j++) {
				deleteByName(contained_objects[j]);
			}
			delete(name, facade);
			//delete(name, facades[i].objref);
			return;

		default:		// Signifies error in provided deletePolicy
				return;
    	}
	}

	public void delete(org.omg.CosNaming.NameComponent[] name,
						intt.itu.itut_x780.ManagedObject_F facade)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
	{

			// remove object from the facade
		facade.destroy(name);
			// remove object from the containment service
		intt.itu.itut_q816.ContainmentComponent c_admin = null;

		if ((c_admin = get_context().get_connection_containment_admin()) == null) {
		    ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.components_connect_error;
			System.err.println("Terminator:ContainmentAdmin can not be located!!");
			throw new ApplicationError(error_code);
		}

		c_admin.removeName(name);
		System.err.println("delete: Successfully removed object " +
			Utils.name2string(name) + " from its facade and containment service!");
	}

}
