package ist.coach.coachEmsCommon;

import ist.coach.coachEmfServices.SnmpAdapter.DataType;


public class SnmpUtils {

  public static synchronized int[]
  getIntColumnData(DataType [] snmpTable,
				  int tableRows,
				  int[] indexRows) {

		int numOfEntries = snmpTable.length;
		int numOfRows = numOfEntries/tableRows;

		int [] snmp_values = new int[numOfRows];

		for (int i = 0; i < numOfRows; i++) {

			for (int j = 0; j < indexRows.length; j++) {

				int position = (indexRows[j] - 1)*numOfRows + i;

				if (position >= numOfEntries) {
					System.err.println("SnmpUtils: getIntColumnData> " +
					    "Cannot determine table indexes!");
					return null;
				}

				snmp_values[i] = snmpTable[position].value.extract_long();
			}
		}

		return snmp_values;
	}

  public static synchronized String[]
  getStringColumnData(DataType [] snmpTable,
				  int tableRows,
				  int[] indexRows) {

		int numOfEntries = snmpTable.length;
		int numOfRows = numOfEntries/tableRows;

		String [] snmp_values = new String[numOfRows];

		for (int i = 0; i < numOfRows; i++) {

			for (int j = 0; j < indexRows.length; j++) {

				int position = (indexRows[j] - 1)*numOfRows + i;

				if (position >= numOfEntries) {
					System.err.println("SnmpUtils: getStringColumnData> " +
					    "Cannot determine table indexes!");
					return null;
				}

				snmp_values[i] = snmpTable[position].value.extract_string();
			}
		}

		return snmp_values;
	}

  public static synchronized String[]
  getOctetColumnData(DataType [] snmpTable,
				  int tableRows,
				  int[] indexRows) {

		int numOfEntries = snmpTable.length;
		int numOfRows = numOfEntries/tableRows;

		String [] snmp_values = new String[numOfRows];

		for (int i = 0; i < numOfRows; i++) {

			for (int j = 0; j < indexRows.length; j++) {

				int position = (indexRows[j] - 1)*numOfRows + i;

				if (position >= numOfEntries) {
					System.err.println("SnmpUtils: getOctetColumnData> " +
						  "Cannot determine interface descriptions!");
					return null;
				}
				snmp_values[i] = new String(
				org.omg.CORBA.OctetSeqHelper.extract(snmpTable[position].value));
				//System.err.println("snmp_values[" + i + "] = " + snmp_values[i]);
				//by digi
				//snmp_values[i] = snmpTable[position].value.extract_string();
			}
		}
		return snmp_values;
	}

  public static synchronized byte[][]
  getOctetColumnDataAsBytes(DataType [] snmpTable,
				  int tableRows,
				  int[] indexRows) {

		int numOfEntries = snmpTable.length;
		int numOfRows = numOfEntries/tableRows;

		byte[][] snmp_values = new byte[numOfRows][];

		for (int i = 0; i < numOfRows; i++) {

			for (int j = 0; j < indexRows.length; j++) {

				int position = (indexRows[j] - 1)*numOfRows + i;

				if (position >= numOfEntries) {
					System.err.println("SnmpUtils: getOctetColumnData> " +
						  "Cannot determine interface descriptions!");
					return null;
				}
				snmp_values[i] = org.omg.CORBA.OctetSeqHelper.extract(snmpTable[position].value);
				//System.err.println("snmp_values[" + i + "] = " + snmp_values[i]);
				//by digi
				//snmp_values[i] = snmpTable[position].value.extract_string();
			}
		}
		return snmp_values;
	}
}
