/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.IpAddressDataFactoryProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.CreateController;
import ist.coach.coachEmfCommon.CreateBindingInfo;
import ist.coach.coachEmfCommon.ExceptionMessages;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;

import intt.itu.itut_m3120.conditionalPackages.*;

import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmsMibComponents.IpAddressDataMgmt;

import ist.coach.coachEmfServices.EmfBasicLog.*;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/IpAddressDataFactoryProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class IpAddressDataFactoryProviderImpl
     extends ist.coach.coachEmsMibComponents.IpAddressDataFactoryProviderComposition.IpAddressDataFactoryProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
    intt.itu.itut_q816.ContainmentComponent c_admin = null;
    intt.itu.itut_q816.Containment c_query = null;
	private BasicLog logSupport;

	private static final String FACTORY_CLASS = "IpAddressDataFactory";
	IpAddressDataMgmt facade = null;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public IpAddressDataFactoryProviderImpl()
    {
    }


    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
	    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
        if ((facade = get_context().get_connection_facade()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_admin = get_context().get_connection_containment_admin()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_query = get_context().get_connection_containment_query()) == null)
            throw new org.omg.Components.InvalidConfiguration();

		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

       System.err.println("IpAddressDataFactoryProvider configuration completed...");
	}
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmsMib::IpAddressDataFactory::create operation.
     */
    public org.omg.CosNaming.NameComponent[]
    create(String nameBindingID,
		  org.omg.CosNaming.NameComponent[] superior,
		  String reqID,
		  String[] packageNameList,
		  byte[] ipAdEntAddress,
		  byte[] mgmtIpAddress,
		  int snmpPort,
		  int supportedSnmpVersions)
    throws intt.itu.itut_x780.ApplicationError,
           intt.itu.itut_x780.CreateError
    {
        //
        // DONE : Implement
        //
                String nameBinding_str = "ist.coach.coachEmsMib.NameBindings." +
                nameBindingID;

//		String objectKind = CreateController.checkNameBinding(nameBinding_str);

		CreateBindingInfo info = CreateController.checkNameBinding(nameBinding_str);

		String objectKind = info.objectKind;
		short deletePolicy = info.deletePolicy;

        // Check if the parent exists
        if (! c_query.exists(superior)) {
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);

            error_code.details = Utils.name2string(superior) +
                            ExceptionMessages.parent_object_error;

            throw new ApplicationError(error_code);
        }

        // The system must have the capability of auto-naming objects
        String allocatedId = reqID;
        if (reqID == null || reqID.length() == 0) {

            org.omg.CosNaming.NameComponent[][] siblings =
                c_query.getContained(superior);

				allocatedId = "IPAddress" + CreateController.autoCreateId(siblings);
        }

        // Construct the name of the new object
        org.omg.CosNaming.NameComponent[] name = CreateController.createFullName(
					superior,
					allocatedId,
					Utils.name2facade(facade.facade_name()),
					objectKind);
		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "proceed to create " + Utils.name2string(name));
/********************************
		System.err.println("IpAddressDataFactoryProvider> Before invoking the facade " +
			Utils.name2facade(facade.facade_name()) + " to create " +
			Utils.name2string(name));
**************************************/
			facade.create(
				name,
				objectKind,
				packageNameList,
				deletePolicy,
				intt.itu.itut_x780.SourceIndicatorType.resourceOperation,
				superior,
				ipAdEntAddress,
				mgmtIpAddress,
				supportedSnmpVersions,
				snmpPort);

			//System.err.println("Before registering to the containment service");
			c_admin.addName(name, superior);

			//System.err.println("IpAddressDataFactory>create returns for " +
			//	Utils.name2string(name));
		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "successfully created " + Utils.name2string(name));
			return name;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObjectFactory::create_base operation.
     */
    public org.omg.CosNaming.NameComponent[]
    create_base(String nameBinding, org.omg.CosNaming.NameComponent[] superior, String reqId)
    throws intt.itu.itut_x780.CreateError,

           intt.itu.itut_x780.ApplicationError
    {
        //
        // TODO : Implement
        //
        return null;
    }

}
