/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy, Areski Flissi.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.ccm.filetransfer.explorer;

import javax.swing.JOptionPane;

import org.objectweb.ccm.filetransfer.Channel;
import org.objectweb.ccm.filetransfer.ChannelHome;
import org.objectweb.util.explorer.api.TreeView;
import org.objectweb.util.explorer.api.MenuItem;
import org.objectweb.util.explorer.api.MenuItemTreeView;

/**
 * This action allows to create a channel with a specific name.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class ChannelCreationAction 
  implements MenuItem 
{

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    //
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for MenuItem interface.
    //
    //==================================================================

    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }
    
    public void actionPerformed(MenuItemTreeView e) throws Exception {
        String name = "";
        while (name != null && name.equals("")) {
            name = JOptionPane.showInputDialog("Enter the Channel's name:");
        }
        if(name!=null){
            ChannelHome channelHome = (ChannelHome) e.getSelectedObject();
            Channel channel = channelHome.create();
            channel.the_name(name);
        }
    }

}
