/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.plugin.java;

import java.util.Iterator;
import java.util.List;

import org.objectweb.util.explorer.api.MenuItem;
import org.objectweb.util.explorer.api.MenuItemTreeView;
import org.objectweb.util.explorer.api.TreeView;
import org.objectweb.util.explorer.core.common.lib.ClassesInheritance;


/**
 * Allows to manipulate wrapper configuration
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class InheritClassesAction 
    implements MenuItem {

    public void actionPerformed(MenuItemTreeView treeView) {
        ClassesInheritance c = new ClassesInheritance(treeView.getSelectedObject().getClass());
        System.out.println(treeView.getSelectedObject().getClass().getName() + "'s type");
        List list = c.getInheritClasses();
        Iterator it = list.iterator();
        while (it.hasNext()) {
            System.out.println("=> " + it.next());
        }
    }

	/**
     * @see org.objectweb.util.browser.api.MenuItem#getStatus(org.objectweb.util.browser.api.TreeView)
	 */
	public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
	}

}
