/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.api;

import java.io.Serializable;

/**
 * Defines the way to explore a resource (i.e. Its children).<br>
 * In order to define a context, you can have a look to the corresponding
 * <a href="explorer-dtd.html#wrapper">DTD element</a> or to 
 * an <a href="package-summary.html#xml">XML example.</a>
 *  
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>  
 * 
 * @version 0.2
 *
 */
public interface Context
         extends Serializable
{

    /**
     * Returns an array containing the entries contained by the context.
     * @param object The object containing the returned entries values.
     * @return The entries of the context.
     */
    Entry[] getEntries(Object object);

}