/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.common.api;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface Description {
    
    /** The list of available properties. */
    public static final String CODE_DESCRIPTION = "code";
    public static final String ICON_DESCRIPTION = "icon";
    public static final String MENU_DESCRIPTION = "menu";
    public static final String ROLE_DESCRIPTION = "role";
    public static final String ROOT_DESCRIPTION = "root";
    public static final String ITEM_DESCRIPTION = "item";
    public static final String ACCELERATOR_DESCRIPTION = "accelerator";
    public static final String MNEMONIC_DESCRIPTION = "mnemonic";
    public static final String SEPARATOR_DESCRIPTION = "separator";
    public static final String DND_DESCRIPTION = "dnd";
    public static final String PANEL_DESCRIPTION = "panel";
    
    /**
     * Provides the type of the description.
     * The available types are:
     * <ul>
     *   <li>CODE_DESCRIPTION for defining code.</li>
     *   <li>ICON_DESCRIPTION for defining icon.</li>
     *   <li>MENU_DESCRIPTION for defining menu.</li>
     *   <li>ROLE_DESCRIPTION for defining role.</li>
     *   <li>...</li>
     * </ul>
     * @return The type of the description.
     */
    public String getDescriptionType();
    
    /**
     * Indicates if an Object is considered as null.
     * For instance, a object may be considered as null
     * if its attributes are null.
     * @return true if the object is considered as null.
     */
    public boolean isEmpty();
    
    // TODO: Need to be defined (i.e.: toString, equals, hashCode)
        
}
