/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.common.lib;

import org.objectweb.util.monolog.api.Loggable;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.LoggerFactory;
import org.objectweb.util.trace.TraceTemplate;

/**
 * 
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>.  
 * 
 * @version 0.1
 */
public class BasicLoggable 
  implements Loggable
{

    // ==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    /** Log wrapper. */
    protected TraceTemplate trace;

    /** LoggerFactory. */
    protected LoggerFactory factory;
        
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for Loggable interface.
    //
    // ==================================================================    

    /**
    * @return Returns the trace.
    */
    protected TraceTemplate getTrace() {
        return trace;
    }

    /**
    * @param trace The trace to set.
    */
    protected void setTrace(TraceTemplate trace) {
        this.trace = trace;
    }

    /* (non-Javadoc)
    * @see org.objectweb.util.monolog.api.Loggable#getLogger()
    */
    public Logger getLogger() {
        return getTrace().getLogger();
    }

    /* (non-Javadoc)
    * @see org.objectweb.util.monolog.api.Loggable#setLogger(org.objectweb.util.monolog.api.Logger)
    */
    public void setLogger(Logger log) {
        setTrace(new TraceTemplate(log));
    }

    /* (non-Javadoc)
    * @see org.objectweb.util.monolog.api.Loggable#getLoggerFactory()
    */
    public LoggerFactory getLoggerFactory() {
        return this.factory;
    }

    /* (non-Javadoc)
    * @see org.objectweb.util.monolog.api.Loggable#setLoggerFactory(org.objectweb.util.monolog.api.LoggerFactory)
    */
    public void setLoggerFactory(LoggerFactory loggerFactory) {
        this.factory = loggerFactory;
    }
    
}
