/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.common.lib;

import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.util.explorer.core.common.api.BadParamException;
import org.objectweb.util.explorer.core.common.api.KeyProvider;
import org.objectweb.util.explorer.core.role.api.Role;
import org.objectweb.util.explorer.core.role.api.RoleProvider;

/**
 * Basic implementation of the <code>KeyProvider</key> component. 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class DefaultKeyProvider 
     extends BindingFeature 
  implements KeyProvider 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    protected DefaultKey getKey(String[] values){
        Role role = null;
        try {
            role = ((RoleProvider)lookupFc(RoleProvider.ROLE_PROVIDER)).getRole(values[2]);
        } catch (NoSuchInterfaceException e) {
            e.printStackTrace();
        }
        return new DefaultKey(values[0],values[1],role);
    }
    
    // ==================================================================
    //
    // Public methods for BindingFeature abstract class.
    //
    // ==================================================================    
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.core.common.lib.BindingFeature#clientFc()
     */
    public String[] clientFc() {
        return new String[]{RoleProvider.ROLE_PROVIDER};
    }

    // ==================================================================
    //
    // Public methods for KeyProvider interface.
    //
    // ==================================================================    
        
    /* (non-Javadoc)
     * @see org.objectweb.util.browser.parser.api.KeyProvider#computeKey(java.lang.Object)
     */
    public Object computeKey(Object key) 
      throws BadParamException {
        try{
            String[] value = (String[])key;
            return getKey(value);
        } catch (ClassCastException e){
            throw new BadParamException("Array of String expected!");
        }
    }

}
