/*====================================================================

Objectweb Browser framework
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.core.dnd.lib;

import org.objectweb.util.explorer.api.DropTreeView;
import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.api.Tree;
import org.objectweb.util.explorer.core.common.lib.DefaultTreeView;

/**
 * Provides all the data required to execute a drop action.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class DefaultDropTreeView 
    extends DefaultTreeView 
    implements DropTreeView {

    //==================================================================
    //
    // Internal states.
    //
    //==================================================================

    /** The drag source entry */
    public Entry dragSource_ = null;

    //==================================================================
    //
    // Constructors.
    // 
    //==================================================================

    /**
     * Default constructor
     */
    public DefaultDropTreeView(Tree tree, Entry current, Entry parent, Entry dragSource){
        super(tree, current, parent);
        dragSource_ = dragSource;    
    }

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================

    /**
     * Returns the wrapped object of the drag source Entry
     */
    public Object getDragSourceObject(){
        return getValue(dragSource_);
    }

    /**
     * Returns the drag source Entry
     */
    public Entry getDragSourceEntry(){
        return dragSource_;    
    }

}
