/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.explorer.core.menu.lib;

import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.api.MenuItemTreeView;
import org.objectweb.util.explorer.api.Tree;
import org.objectweb.util.explorer.core.common.lib.DefaultTreeView;
import org.objectweb.util.explorer.core.menu.api.MenuItemTreeViewConfiguration;

/**
 *
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class DefaultMenuItemTreeView
     extends DefaultTreeView 
  implements MenuItemTreeView, MenuItemTreeViewConfiguration 
{

    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    protected Object actionEvent_ = null;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public DefaultMenuItemTreeView(Tree tree, Entry current, Entry parent) {
        super(tree, current, parent);
    }

    // ==================================================================
    //
    // Public methods from MenuItemTreeView interface.
    //
    // ==================================================================

    /** 
     * Returns the initial ActionEvent
     */
    public Object getEvent() {
        return actionEvent_;
    }

    // ==================================================================
    //
    // Public methods from MenuItemTreeViewConfiguration interface.
    //
    // ==================================================================

    /**
     * Fixes the associated action event
     * @param e The associated action event
     */
    public void setEvent(Object event){
        actionEvent_ = event;
    }

}
