/*====================================================================

Objectweb Browser framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.role.api;


/**
 * Define a role used to define a configuration.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public interface RoleManager {

    /** Reference to the RoleManager server interface name.*/
    public static String ROLE_MANAGER = "role-manager";
    
    /** 
     * Provides the current roles list.
     * @return The current roles. 
     */
    public String[] getCurrentRoleIds();
    
    /** 
     * Fixes the current roles.
     * 
     * @param role_id The list role ids to define as current roles.
     */
    public void setCurrentRoleIds(String[] roleIds);

    /**
     * Fixes the current roles.
     * 
     * @param roles The list of roles to define as current roles.
     */
    //public void setCurrentRoles(Role[] roles);
    
}
