/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.parser.lib;

import java.util.Vector;

import org.objectweb.util.explorer.core.common.lib.BasicLoggable;
import org.objectweb.util.explorer.parser.api.ParserConfiguration;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public abstract class AbstractParser 
              extends BasicLoggable 
           implements ParserConfiguration
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    /** The URL of the files to parse (Elements are instances of String and cannot be null or empty)*/
    protected Vector urlFiles_; 
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * Empty constructor.
     */
    public AbstractParser() {
        this.urlFiles_ = new Vector();
    }    
    
    // ==================================================================
    //
    // No internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for ParserConfiguration interface.
    //
    // ==================================================================
    
    /**
     * Adds the given urlFile if this one neither null nor empty.
     * @see org.objectweb.util.explorer.parser.api.ParserConfiguration#addPropertyFile(java.lang.String)
     */
    public void addPropertyFile(String urlFile) {
        if(urlFile!=null && !urlFile.equals("") && !urlFiles_.contains(urlFile))
            urlFiles_.add(urlFile);
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.util.browser.core.xmlparser.api.ParserConfiguration#parse()
     */
    public abstract void parse();
    
}


