/*====================================================================

 Objectweb Explorer Framework
 Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
 Contact: openccm@objectweb.org

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA

 Initial developer(s): Latitia Lafeuille.
 Contributor(s): ______________________________________.

 ====================================================================*/
package org.objectweb.util.explorer.swing.graph;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;

/**
 * 
 * @version 0.2
 */
public interface VertexGraphicsInterface {

    /** The size of the open composite (super composite) membrane*/
    public final int COMPOSITE_MEMBRANE_SIZE = 5;

    /** The size of the verteces inside the super composite */
    public final int PRIMITIVE_MEMBRANE_SIZE = 2;

    /** The location of the super composite label */
    public final Point SUPER_COMPOSITE_NAME_LOCATION = new Point(
            25 + COMPOSITE_MEMBRANE_SIZE, 25 + COMPOSITE_MEMBRANE_SIZE);

    /** The origin of the super composite */
    public final Point SUPER_COMPOSITE_ORIGIN = new Point(10, 10);

    /** The origin of the first vertex when there isn't a super composite */
    public final Point PRIMITIVE_ORIGIN = new Point(10, 10);

    /** The first vertex location into the super composite */
    public final Point FIRST_VETEX_LOCATION = new Point(
            COMPOSITE_MEMBRANE_SIZE + 55, COMPOSITE_MEMBRANE_SIZE + 60);

    /** The max width of a vertex */
    public final int VERTEX_MAX_WIDTH = 300;

    /** The width of the super composite label */
    public final int COMPOSITE_NAME_WIDTH = 12;

    /** The with of the verteces label inside the super composite */
    public final int PRIMITIVE_NAME_WIDTH = 7;

    /** The height of the verteces label inside the super composite */
    public final int PRIMITIVE_NAME_HEIGHT = 4;

    /** Returns the default size of a vertex */
    Dimension getDefaultSize();

    /** Returns the super composite size */
    Dimension getSuperCompositeSize();

    /** Draw the specific vertex into the specific graphics */
    void drawVertex(Graphics g, String vertexType, Dimension d,
            PrimitiveVertex vertex);

}