/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.swing.gui.api;

import org.objectweb.util.explorer.api.Tree;

/**
 * Used to create new DynamicTree.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public interface TreeProvider {

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================

    //TODO: Maybe obsolete ... might be removed ...
    
    /**
     * Creates a new Tree instance with a same configuration of one contains in the explorer component.
     * Equivalent to a <code>duplicate(true);</code> call.
     * @return The new Tree instance. 
     * @see org.objectweb.util.explorer.api.Tree
     * @see TreeProvider#duplicate(boolean)
     */
    public Tree duplicate();

    /**
     * Creates a new Tree instance with a same configuration of one contains in the explorer component.
     * @param withData A boolean to specify if the data of the source tree have to be added into the new one. The default value is "true"
     * @return The new Tree instance.
     * @see org.objectweb.util.explorer.api.Tree
     */
    public Tree duplicate(boolean withData);

}