/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.swt.api;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface Explorer {

    /** The name of the fractal interface reference. */
    public static String EXPLORER = "explorer";        

    // TODO : SWT features are only partly implemented!
    
    /**
     * Provides the DynamicTree.
     * @return The Dynamic Tree.
     */
    public Tree getTree();  
    
    /**
     * Fixes the display to use.
     * @param display The display to use
     */
    public void setDisplay(Display display);
    
    /**
     * Fixes the shell to use.
     * @param shell The shell to use.
     */
    public void setShell(Shell shell);    
    
    /**
     * Fixes the menu to use
     * @param menu The menu to use.
     */
    public void setMenuBar(Menu menu);
    
}
