/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.swt.lib;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.objectweb.util.explorer.core.common.api.TextComponent;
import org.objectweb.util.explorer.swt.api.StatusBar;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class DefaultStatusBar 
  implements StatusBar, TextComponent 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================
    
    protected Text text_ = null;
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public DefaultStatusBar(){
        text_ = new Text(new Shell(), SWT.BORDER);
    }
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for TextComponent interface. 
    //
    // ==================================================================    
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.core.common.api.TextComponent#setText(java.lang.String)
     */
    public void setText(String message) {
        if(message!=null){
            text_.setText(message);
        }
    }    
    
    // ==================================================================
    //
    // Public methods for StatusBar interface. 
    //
    // ==================================================================    
        
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.swt.api.StatusBar#getStatusBar()
     */
    public Text getStatusBar() {
        return text_;
    }

}

