/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer;

import org.objectweb.util.explorer.core.code.CodeDescriptionTest;
import org.objectweb.util.explorer.core.code.CodeInterpreterTest;
import org.objectweb.util.explorer.core.common.DefaultKeyTest;
import org.objectweb.util.explorer.core.icon.IconDescriptionTest;
import org.objectweb.util.explorer.core.menu.AcceleratorDescriptionTest;
import org.objectweb.util.explorer.core.menu.ItemDescriptionTest;
import org.objectweb.util.explorer.core.menu.MenuDescriptionTest;
import org.objectweb.util.explorer.core.menu.MenuSeparatorTest;
import org.objectweb.util.explorer.core.menu.MnemonicDescriptionTest;
import org.objectweb.util.explorer.core.role.RolePropertyTest;
import org.objectweb.util.explorer.parser.lib.ParserUtilsTest;
import org.objectweb.util.trace.TraceSystem;

import junit.framework.Test;
import junit.framework.TestSuite;


/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class AllTests {

    //==================================================================
    //
    // No internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // No constructor.
    //
    // ==================================================================
    public AllTests(){
        TraceSystem.setLevel("debug");
    }
    
    // ==================================================================
    //
    // No internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================    

    public static Test suite() {
        TestSuite suite = new TestSuite("Test for Explorer Framework");
        //$JUnit-BEGIN$
        suite.addTestSuite(ExplorerUtilsTest.class);
        suite.addTestSuite(DefaultKeyTest.class);
        suite.addTestSuite(ParserUtilsTest.class);
        suite.addTestSuite(MenuSeparatorTest.class);
        suite.addTestSuite(AcceleratorDescriptionTest.class);
        suite.addTestSuite(MnemonicDescriptionTest.class);
        suite.addTestSuite(CodeDescriptionTest.class);
        suite.addTestSuite(IconDescriptionTest.class);
        suite.addTestSuite(ItemDescriptionTest.class);        
        suite.addTestSuite(MenuDescriptionTest.class);        
        suite.addTestSuite(RolePropertyTest.class);
        suite.addTestSuite(CodeInterpreterTest.class);
        //suite.addTestSuite(ExplorerParserTest.class);
        //$JUnit-END$
        return suite;
    }
    
    // ==================================================================
    //
    // Main method.
    //
    // ==================================================================    
    
    public static void main(String[] args) {
        junit.textui.TestRunner.run(AllTests.suite());
    }
    
}