/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.code;

import org.objectweb.util.explorer.core.code.api.CodeDescription;
import org.objectweb.util.explorer.core.code.lib.BasicCodeDescription;

import junit.framework.Assert;
import junit.framework.TestCase;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class CodeDescriptionTest 
     extends TestCase 
{


    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    protected String l1_="Java", l2_="Python", c1_="java.lang.Object", c2_="java.util.Map_";
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    
    
    public void testEqualsMethod(){
        CodeDescription codeDesc = new BasicCodeDescription();
        CodeDescription expected = new BasicCodeDescription();
        Assert.assertEquals(expected, codeDesc);
        codeDesc.setLanguage(l1_);
        Assert.assertNotSame(expected, codeDesc);
        expected.setLanguage(l2_);
        Assert.assertNotSame(expected, codeDesc);
        expected.setLanguage(l1_);
        Assert.assertEquals(expected, codeDesc);
        codeDesc.setCode(c1_);
        Assert.assertNotSame(expected, codeDesc);
        expected.setCode(c2_);
        Assert.assertNotSame(expected, codeDesc);
        expected.setCode(c1_);
        Assert.assertEquals(expected, codeDesc);
        Assert.assertEquals(codeDesc, codeDesc);
    }
    
    public void testIsEmptyMethod(){
        CodeDescription codeDesc = new BasicCodeDescription();
        Assert.assertTrue(codeDesc.isEmpty());
        codeDesc.setLanguage("");
        Assert.assertTrue(codeDesc.isEmpty());
        codeDesc.setLanguage("java");
        Assert.assertTrue(codeDesc.isEmpty());   
        codeDesc.setCode("java.lang.Object");
        Assert.assertFalse(codeDesc.isEmpty());
    }
    
}

