#! /bin/sh -f
# ==================================================================== 
#                                                                      
# ObjectWeb Util Package                                               
# Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL                   
# Contact: openccm@objectweb.org                                       
#                                                                      
# This library is free software; you can redistribute it and/or        
# modify it under the terms of the GNU Lesser General Public           
# License as published by the Free Software Foundation; either         
# version 2.1 of the License, or any later version.
#                                                                      
# This library is distributed in the hope that it will be useful,      
# but WITHOUT ANY WARRANTY; without even the implied warranty of       
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     
# Lesser General Public License for more details.                      
#                                                                      
# You should have received a copy of the GNU Lesser General Public     
# License along with this library; if not, write to the Free Software  
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
# USA                                                                  
#                                                                      
# Initial developer(s): Romain Rouvoy                                  
# Contributor(s): Christophe Demarey
#                 Christophe Contreras
#                 Philippe Merle
#
# ====================================================================
# $Id: launcher.sh,v 1.6 2004/10/18 16:20:03 contrera Exp $
# ====================================================================
#  Start a Java Application from an xml configuration file.
#
#  If $1 = "exec", simply run the application.
#  If $1 = "fork", run the application as a server.
#
#  Parameters :
#  - $2 represents jvm parameters.
#  - $3 represents application parameters.
#  - $4 is the file where standard output is redirected. (ex: cmd.output, cmd.ior)
#  - $5 is a file containing the Processus ID.
#
# ====================================================================

CLASSPATH=@LAUNCHER_CLASSPATH@

PROPERTIES="-DOW_HOMEDIR=${OW_HOMEDIR} -DOW_CONFIGDIR=${OW_CONFIGDIR}"

if [ "$1" = "exec" ]
then
    java $2 -classpath ${CLASSPATH} ${PROPERTIES} @OW_LAUNCHER_CLASSNAME@ $3
elif [ "$1" = "fork" ]
then
    java $2 -classpath ${CLASSPATH} ${PROPERTIES} @OW_LAUNCHER_CLASSNAME@ $3 > $4 &
    echo $! > $5
    while [ ! -s $4 ]
    do
        sleep 1
    done
else
    echo "Syntax: launcher.sh exec|fork [JVM] arguments"
fi
