@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Sylvain Leblanc.
rem # Contributor(s): Philippe Merle.
rem #
rem # ====================================================================
rem #
rem # Starting the JacORB 2.2 CosTrading Service.
rem #
rem # ====================================================================

setlocal

rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

rem # Check if the CosTrading Service is already started.
if not exist %OpenCCM_CONFIG_DIR%\TradingService.IOR goto :not_exist

echo Error: The CosTrading Service is already started!
goto :eof

:not_exist

rem # Check if the OpenCCM Platform is installed.
call %OpenCCM_HOMEDIR%\bin\ccm_installed
if %CCM_INSTALLED%==0 goto :eof

:do_start
echo The CosTrading Service will be started.

rem # Create the CosTradingService Data Base.
if not exist %OpenCCM_CONFIG_DIR%\TradingService.db mkdir %OpenCCM_CONFIG_DIR%\TradingService.db

echo Launching the JacORB 2.2 CosTrading Service.

call launcher fork "" "%OpenCCM_HOMEDIR%/xml/launcher/Trader.xml" %OpenCCM_CONFIG_DIR%\TradingService.output %OpenCCM_CONFIG_DIR%\TradingService.PID

rem # Wait for the TradingService.IOR file produced
rem # by the JacORB 2.2 CosTrading Service.
:wait
set READY=
if not exist %OpenCCM_CONFIG_DIR%\TradingService.IOR goto :wait
copy %OpenCCM_CONFIG_DIR%\TradingService.IOR %OpenCCM_CONFIG_DIR%\TradingService.IOR.tmp >nul
for /f %%i in (%OpenCCM_CONFIG_DIR%\TradingService.IOR.tmp) do set READY=ok
if not defined READY goto :wait
del %OpenCCM_CONFIG_DIR%\TradingService.IOR.tmp

echo Feeding the CosTrading Service Type Repository with OpenCCM basic service types.
call trader_feed %OpenCCM_HOMEDIR%\xml\trading\basic.xml

echo The CosTrading Service is started.
