/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

/**
 * Implementation of the CORBA::HomeDef reference.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.4
 */

public class HomeDef_ref
     extends IRObject_ref
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * TODO.
     */
    public
    HomeDef_ref(IRObject_impl owner)
    {
        // Calls the IRObject_ref constructor.
        super(owner);
    }

    /**
     * TODO.
     */
    public
    HomeDef_ref(IRObject_impl owner,
                HomeDef_impl object)
    {
        // Calls the IRObject_ref constructor.
        super(owner, object);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Obtains its reference.
     */
    public HomeDef_impl
    getImpl()
    {
        return (HomeDef_impl)(super.getBaseImpl());
    }

    /**
     * Obtains its CORBA::HomeDef reference.
     */
    public org.omg.CORBA.ComponentIR.HomeDef
    asHomeDef()
    {
        if (getTarget() == null) return null;
        return getImpl().asHomeDef();
    }

    /**
     * Obtains its repository ID.
     */
    public String
    getId()
    {
        if (getTarget() == null) return "";
        return getImpl().id();
    }
}
