/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet.

====================================================================*/

package org.objectweb.ccm.IR3;

import org.omg.CORBA.*;

/**
 * Implementation of the CORBA::Initializer helper class.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.4
 */

public class Initializer_impl
     extends StructMembers
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The initializer name. */
    protected String name_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /** TODO */
    public
    Initializer_impl(ValueDef_impl owner)
    {
        super(owner, null);
        name_ = null;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
        Obtain the name.
     **/
    public String
    getName()
    {
        return name_;
    }

    /**
        Obtain as CORBA::Initializer.
     **/
    public Initializer
    getInitializer()
    {
        return new Initializer(getStructMemberSeq(), name_);
    }

    /**
        Set as CORBA::Initializer.
     **/
    public void
    setInitializer(Initializer val)
    {
        setStructMemberSeq(val.members);
        name_ = val.name;
    }
}
