/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/


package org.objectweb.ccm.descriptor;

import java.io.IOException;
import java.io.Reader;
import java.io.InputStream;
import java.io.File;
import java.util.zip.ZipFile;
/**
 *
 * The stream manager is in charge to manage all the temporary
 * files and stream used in deployment.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</a>
 *
 * @version 0.1
 */
public interface StreamManager 
{
    public void
    connectTemporaryFile(File file);
    
    public void
    deleteAllTemporaryFiles();
    
    public void
    connectOpenInputStream(InputStream isr);
    
    public void
    closeAllOpenInputStreams()
    throws IOException;
    
    public void
    connectOpenReader(Reader reader);
    
    public void
    closeAllOpenReaders()
    throws IOException;
    
    public void
    clearAllStream()
    throws IOException;
    
    public void
    connectOpenZipFile(ZipFile zipFile);
    
    public void
    closeAllOpenZipFile()
    throws IOException;
    
}