/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.managers;

import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.Deployer;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.DeployerScheduler;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.FatalDeploymentException;

/**
 * The DefaultdeployerScheduler is the default scheduler implementation
 * which schedule sequencially the deployment.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class DefaultDeployerScheduler implements DeployerScheduler {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * The traverse method schedule and execute the deployment of
     * @param deployers children using the visit method of @param deployer
     * 
     * @param deployer the deployer executor
     * @param deployers the deployers to execute.
     * @throws FatalDeploymentException if a fatal problem occured
     */
    public void 
    traverse(Deployer deployer, Deployer[] deployers)
    throws FatalDeploymentException
    {
        for(int i=0;i<deployers.length;i++)
             deployer.visit(deployers[i]);
              
    }    
    
}
