/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): .

====================================================================*/

package org.objectweb.corba.command.api;

/**
 * Base interface for commands using the OpenCCM's Interface Repository.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *
 * @version 0.3
 */

public interface CommandOnIR3
         extends Application
{
    /**
     * Checks availability of the OpenCCM's Interface Repository.
     *
     * @return True if ok, else false.
     */
    public boolean
    checkComponentRepository();

    /**
     * Obtains the OpenCCM's Interface Repository reference.
     *
     * @return The OpenCCM's Interface Repository reference.
     */
    public org.objectweb.ccm.ComponentRepository
    getComponentRepository();
}
