/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.generator.translator.idl2java.api;

// Package dependencies.

/**
 * This interface translates some PSDL declarations to their java mapping.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */

public interface PSDL_JavaTranslator
         extends org.objectweb.corba.generator.translator.idl2java.api.IDL_JavaTranslator
{
    /**
     * Translate a PsdlTypeRef into its java mapping.
     *
     * @param type - The PsdlTypeRef to translate.
     *
     * @return The resulting mapping.
     **/
    public java.lang.String
    toJava(org.objectweb.corba.ast.api.PsdlTypeRef type);

    /**
     * Translate a psdl parameter into its java mapping.
     *
     * @param type - The PsdlTypeRef to translate.
     * @param mode - The parameter mode (in, out or inout).
     *
     * @return The resulting mapping.
     **/
    public java.lang.String
    toJava(org.objectweb.corba.ast.api.PsdlTypeRef type,
           int mode);

    /**
     * Translate a psdl reference into its java mapping,
     * i.e. ref<A> => A.
     *
     * @param type - The PsdlTypeRef to translate.
     *
     * @return The resulting mapping.
     **/
    public java.lang.String
    RefToJava(org.objectweb.corba.ast.api.PsdlTypeRef type);
}
