/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;
/**
 * This is the implementation of the OpenCCM_DCI::AssemblyManagerRegistration
 * component type.
 * In that implementation all the registration event are manage with connection
 * on the main component interface. 
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class AssemblyManagerRegistrationImpl  
    extends org.objectweb.openccm.OpenCCM_DCI
            .AssemblyFactoryManagerSessionComposition
            .AssemblyManagerRegistrationSeg    
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    // Publics methods.
    //
    // ==================================================================
    /**
     * This method allows the assembly manager to register itself
     * to its parent AssemblyFactory
     * @param assembly_manager The AssemblyManager to register
     * @return A cookie connection
     */
    public org.omg.Components.Cookie
    register_assembly_manager(org.objectweb.openccm
                               .OpenCCM_DCI.AssemblyManager assembly_manager)
    {
        try{      
            // Connect the assembly manager
            return  
                ((org.objectweb.openccm
                  .OpenCCM_DCI.AssemblyFactoryManagerCCM)get_context())
                .connect_assembly_managers(assembly_manager) ;
                
        }
        catch(Exception e){
            System.err.println("Error occured during the AssemblyManager connection");
            e.printStackTrace();
        }        
        return null;   
    }

    /**
     * This method allows a AssemblyManager to unregister itself
     * from its parent AssemblyFactory
     * @param cookie The cookie connection
     */
    public  void
    unregister_assembly_manager(org.omg.Components.Cookie cookie)
        throws org.omg.Components.CookieRequired
    {
        try{
            //Disconnect the assembly manager
               ((org.objectweb.openccm
                 .OpenCCM_DCI.AssemblyFactoryManagerCCM)get_context())
                   .disconnect_assembly_managers(cookie);
        }
        catch(Exception e){
            e.printStackTrace();
            throw new org.omg.Components.CookieRequired();
        }
    }    
}
