/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric
Contributor(s):  

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the factory for AssemblyManagerRemoved valuetypes.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Frdric Briclet</A>
 */

public class AssemblyManagerRemovedDefaultFactory
  implements org.omg.CORBA.portable.ValueFactory
{
    // ==================================================================
    //
    // Methods for OMG IDL org.omg.CORBA.portable.ValueFactory
    //
    // ==================================================================
    
    /** 
     * To read a FoodImpl on a CORBA stream.
     */
    public java.io.Serializable 
    read_value(org.omg.CORBA_2_3.portable.InputStream in) 
    {
        java.io.Serializable v = new AssemblyManagerRemovedImpl(); 
        return in.read_value(v); 
    }

    // ==================================================================
    //
    // Public static methods.
    //
    // ==================================================================

    /**
     * Register the event factory on the ORB.
     */
    public static void
    register()
    {
        AssemblyManagerRemovedFactoryHelper
            .register(new AssemblyManagerRemovedDefaultFactory());
    }
}
