/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation of the OMG IDL3 demo3::Consumer component type.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class AssemblyManagerXMLImpl
     extends org.objectweb.openccm.OpenCCM_DCI.
             AssemblyManagerSessionComposition.AssemblyManagerImpl
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================   

    private String assemblyLoc;
    private String xmlFilePath;
    private org.objectweb.openccm.OpenCCM_DCI.AssemblyManagerRegistration AMR;
    private org.omg.Components.Cookie cookie;
    private boolean removed;
    private String xml;
    //The AssemblyManager instanceID
    public String instanceUUID;
    //Reference on the main interface
    private org.objectweb.openccm.OpenCCM_DCI.AssemblyManager AM;

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================   


    // ==================================================================
    //
    // Constructor
    //
    // ==================================================================   
    public AssemblyManagerXMLImpl(String xml){     
        this.xml=xml;
        instanceUUID=System.currentTimeMillis()+"";
        instanceUUID.substring(instanceUUID.length()-5,instanceUUID.length());
        instanceUUID="AssemblyManagerInstance"+instanceUUID;   
        // System.err.println("AMI >> AIM"+instanceUUID+"created");

    }    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================   

    public  void 
    configuration_complete()
    {
        
        try{
            //((AssemblySegImpl)obtain_executor("assembly")).setupXML(xml);
            //((NodeManagementSegImpl)obtain_executor("node_management")).setupDCI();
            AMR=get_context().get_connection_assembly_manager_registration();
        
        try{
            org.omg.Components.SessionContext sc=
                (org.omg.Components.SessionContext)get_context();

            AM=org.objectweb.openccm.
                OpenCCM_DCI.AssemblyManagerHelper
                .narrow(sc.get_CCM_object());

            cookie=AMR.register_assembly_manager(AM);  
            
            ((AssemblySegImpl)obtain_executor("assembly"))
                .setupAssemblyManager(org.objectweb.openccm.
                                      OpenCCM_DCI.AssemblyManagerHelper
                                      .narrow(sc.get_CCM_object()));
           
        }
        catch(Exception e)
            {
                e.printStackTrace();
            }

        }
        catch(Exception e){
            e.printStackTrace();
        }
        
        
    }
    
    
    public  void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        /*TODO add the possibility to aware a node of DCI stop*/
        if(!removed){
            removed=true;
            try{
                AMR.unregister_assembly_manager(cookie);
                get_context().push_assembly_manager_removed
                    (new AssemblyManagerRemovedImpl(AM));
                //CSMR.unregister_component_server_manager(cookie);             
                if(org.omg.Components.Deployment.AssemblyState.INSERVICE==                   
                   ((AssemblySegImpl)obtain_executor("assembly")).get_state())                
                    ((AssemblySegImpl)obtain_executor("assembly")).tear_down();
                        }
            catch(Exception e )
                {
                    System.out.println("Cannot tear_down assembly");
                    e.printStackTrace();
                }
           
        }          
    }

    public void
    push(org.objectweb.openccm.OpenCCM_DCI.ComponentServerManagerRemoved csmr)
    {
        return ;
    }

    // ==================================================================
    //
    // Accessor methods.
    //
    // ==================================================================   

   
    public org.ist.coach.DCI.DeploymentDescriptor[] descriptors(){        
        return new org.ist.coach.DCI.DeploymentDescriptor[0];
    }

    public String ass_id(){
        return instanceUUID;
    }
    
    public void
    assembly_loc(java.lang.String assemblyLoc)
    {
        this.assemblyLoc=assemblyLoc;
    }
    
    public String
    assembly_loc()
    {
        return this.assemblyLoc;
    }
  

}
