/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/

package org.objectweb.openccm.browser.CORBA;

/** The console's imports. */
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.Wrapper;
import org.objectweb.util.browser.api.Context;
import org.objectweb.util.browser.core.naming.DefaultName;
import org.objectweb.util.browser.core.naming.DefaultEntry;

/**
 * Contains the CORBA attribute which must be displayed.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class CORBAAttributes
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The list of attribute to display */
    protected String[] attributesName_ = new String[0];

    // ==================================================================
    //
    // No Constructor.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    /**
     * Indicates if an attribute exists or not. An attribute exists in an 
     * object definition if the method called name can be found.
     */
    protected boolean exists(String name, org.omg.CORBA.Object obj){
        if(obj!=null) {
            try{
                obj.getClass().getMethod(name,null);
                return true;
            } catch(NoSuchMethodException e) {
                ConsoleFactory.getDebugConsole().add(name + " attribute doesn't exist!\n");
                return false;   
            }
        }
        return false;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Fixes a list of attributes to display
     */
    public void setAttributesName(String[] attributesName){
        if(attributesName != null)
            attributesName_ = attributesName;
    }

}