/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/

package org.objectweb.openccm.browser.CORBA;

import org.objectweb.util.browser.api.Info;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.openccm.browser.util.ior.IorPrinter;

/**
 * Provides data about a CORBA Object (IDL Type, Host, Port)
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class CORBAObjectInfo
    implements Info {

    // ==================================================================
    //
    // No internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // No Constructor.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    protected String getInfo(org.omg.CORBA.Object object){
        org.omg.CORBA.ORB orb = org.objectweb.ccm.CORBA.TheORB.getORB();
        IorPrinter iorPrinter = new IorPrinter(orb.object_to_string(object));
        return "ID: " + iorPrinter.getTypeId() + ", Host: " + iorPrinter.getHost() + ", Port: " + iorPrinter.getPort();
    }

    // ==================================================================
    //
    // Public methods for Info interface.
    //
    // ==================================================================

    public String getInfo(TreeView treeView) {
        return getInfo((org.omg.CORBA.Object) treeView.getSelectedObject());
    }

}
