/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.CosTrading.gui;

/** To use the Field class */
import javax.swing.JLabel;
import javax.swing.BoxLayout;
import java.awt.Dimension;
import java.awt.Color;
import javax.swing.Box;

/**
 * A Box used to display a Service Type SuperTypes
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 * @version 0.1
 */
public class SuperTypesGUI extends Box {

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    protected String[] superTypes_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * Default constructor.
     *
     * @param superTypes The names of super types.
     */
    public SuperTypesGUI(String[] superTypes) {
        super(BoxLayout.Y_AXIS);
        setBackground(Color.white);

        // Store super types names
        superTypes_ = superTypes;

        add(Box.createHorizontalGlue());

        for (int i=0 ; i<superTypes_.length ; i++) {
            JLabel label = null;
            label = new JLabel(superTypes_[i]);
            
            label.setPreferredSize(new Dimension(350, 20));
            add(label);
        }

        add(Box.createHorizontalGlue());
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

}







