/*===========================================================================

ObjectWeb Naming Context Framework 
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.gui.panel;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import java.awt.*;
import org.objectweb.util.browser.gui.panel.NodeViewPanel;
import org.objectweb.util.browser.gui.common.TreeView;

/**
 * This class represents an empty panel
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class WhitePanel extends NodeViewPanel {

    /**
     * Default Constructor
     */
    public WhitePanel() {
        setBackground(Color.white);
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    }

    /**
     * Constructor with text
     * Customizes the JPanel and adds the message in it.
     */
    public WhitePanel(String message) {
        this();
        add(new JLabel(message), BorderLayout.CENTER);
    }

    /**
     * Invokes just after instanciation
     */
    public void preInitialize() {
    }

    /**
     * Fix the view which allow to manipulate the tree
     *
     * @param treeView The view on the tree
     */
    public void setTreeView(TreeView treeView) {
        Object o = treeView.getHandleObject();
        if (o != null)
            add(new JLabel(o.toString()), BorderLayout.CENTER);
    }

    /**
     * Invokes just before removing
     */
    public void postInitialize() {
    }

}
