/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.deployment.gui;

// Package dependencies
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.openccm.descriptor.softpkg.gui.SoftpkgZipper;

/**
 * This is the action class for building an archive for a package
 *
 */
public class ComponentPackager
  implements MenuItem
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  Status of the menu item
     *
     * @param treeView to obtain the activated node
     */
    public int
    getStatus(org.objectweb.util.browser.api.TreeView treeView)
    {
        return org.objectweb.util.browser.api.MenuItem.ENABLED_STATUS;
    }

    /**
     *  The constructor taking an event as parameter
     */
    public void actionPerformed(MenuItemTreeView e)
    {
        String action = e.getActionEvent().getActionCommand();

        // gets the calling instance
        org.objectweb.apollon.framework.Bean zeus_instance
            = (org.objectweb.apollon.framework.Bean)
                e.getSelectedObject();

        // gets the calling entry
        org.objectweb.util.browser.api.Entry entry
         = e.getSelectedEntry();

        // gets the file name for the component descriptor
        // it is registered as an absolute path in the GUI for this entry
        String descriptor_filename
         = CCMSplitPane.get_file_by_id(
            (String) entry.getName()
            );

        // displays a dialog box to select archive name
        // CHANGE : we use the Softpkg ID to build the CAR file
/*        java.io.File zipfile;
        javax.swing.JFileChooser dialogBox
         = new javax.swing.JFileChooser(System.getProperty("user.dir"));
        int returnVal = dialogBox.showSaveDialog(new javax.swing.JPanel());

        if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION)
        {
            zipfile = dialogBox.getSelectedFile().getAbsoluteFile();
*/
            java.io.File zipfile
             = new java.io.File(
                zeus_instance.idBean()
                +".car"
                );

            System.err.println("Starting Component ARchive creation...");

            // creates a new zip factory for this package
            ZipFactory zip_factory
            = new ZipFactory();

            zip_factory.setZipName(zipfile.getAbsolutePath());

            // gets the descriptor file for the described Component
            java.io.File original_descriptor_file
             = new java.io.File(
                descriptor_filename
                );
            // creating the file to be zipped
            java.io.File temp_descriptor_file
             = new java.io.File(
                "META-INF"
                +System.getProperty("file.separator")
                +original_descriptor_file.getName()
                );

            try
            {
                // marshaling the temporary descriptor
                zeus_instance.marshalBean(temp_descriptor_file);
            } catch (Exception except) {
                except.printStackTrace();
            }

            // adds the descriptor to the zip archive
            zip_factory
                .addFileToZip(
                    temp_descriptor_file.getPath()
                    );

            // launches the ZIP extensions in the SOFTPKG framework
            SoftpkgZipper zipper
            = (SoftpkgZipper) zeus_instance
                .getExtensionManager()
                .getExtensionByName("gui.Zipper")
                .getInstance();
            zipper.zipCall(
                (org.objectweb.openccm.descriptor.softpkg.beans.SoftpkgBean) zeus_instance
                , zip_factory);

            // builds the archive after file retrieving
            try
            {
                zip_factory.buildZip();
                System.err.println("End of the CAR creation, writing file:");
                System.err.println(zipfile.getAbsolutePath());
            } catch (Exception exc) {
                System.err.println("Package could not be built. See following stacktrace");
                exc.printStackTrace();
            }
//        }
    }
}
