#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Areski Flissi
# Contributor(s): 
#
# ====================================================================
#
# Starting an OpenCCM DCI NodeManager.
#
# Usage: node_start.sh <NodeName>
#
# ====================================================================

# Checks the command line.

if [ $# != 1 ]
then
    echo "=================================================="
    echo "Usage: node_start.sh <NodeName>"
    echo "=================================================="
    exit 1
fi

# Get the IOR of the started NS
ns_ior=`cat @OpenCCM_CONFIG_DIR@/NameService.IOR`

# Get the IOR of the started DCI Manager
dci_ior=`cat @OpenCCM_CONFIG_DIR@/DCI.IOR`



echo "Starting OpenCCM DCI Node"

node_name=$1
NODE_PATH=@OpenCCM_CONFIG_DIR@/NodeManagers/$node_name/node_$node_name

mkdir @OpenCCM_CONFIG_DIR@/NodeManagers/$node_name
ci_dir=@OpenCCM_CONFIG_DIR@/NodeManagers/$node_name/ComponentInstallation
mkdir $ci_dir

work_dir=@OpenCCM_CONFIG_DIR@/NodeManagers

echo "No User Node Properties File define, use default properties"

run_id=node_start_default
npdFilePath=-I@OpenCCM_DIR@/xml/descriptor/dci/NodeProperties.npd

@JVM@ -Dior_ns=$ns_ior -Dior_dci=$dci_ior -Dnode_name=$node_name -Dci_dir=$ci_dir -Dwork_dir=$work_dir org.objectweb.util.launcher.Launcher --runid $run_id NPDFILE=$npdFilePath NSREGISTER=OpenCCM/NodeManagers/$node_name NODENAME=$node_name @OpenCCM_DIR@/xml/launcher/node_server.xml

echo "The NodeManager $1 is started"

