@echo off
REM # ====================================================================
REM #
REM # OpenCCM: The Open CORBA Component Model Platform
REM # Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
REM # Contact: openccm@objectweb.org
REM #
REM # This library is free software; you can redistribute it and/or
REM # modify it under the terms of the GNU Lesser General Public
REM # License as published by the Free Software Foundation; either
REM # version 2.1 of the License, or any later version.
REM #
REM # This library is distributed in the hope that it will be useful,
REM # but WITHOUT ANY WARRANTY; without even the implied warranty of
REM # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
REM # Lesser General Public License for more details.
REM #
REM # You should have received a copy of the GNU Lesser General Public
REM # License along with this library; if not, write to the Free Software
REM # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
REM # USA
REM #
REM # Initial developer(s): Areski Flissi
REM # Contributor(s): 
REM #
REM # ====================================================================
REM #
REM #  Starting the Ant Compilation Process.
REM #  Installing OpenCCM on the device connected via ActiveSync
REM #
REM # ====================================================================

set openccm_pda.dir=\OpenCCM
set ORB.pda.name=ORBacus-4.1


set rcmd=externals\rcmd1.2\rcmd.exe
set build_dir=%cd%\%ORB.pda.name%

call ant %1 -buildfile build.xml

if "%1"=="clean" goto build_clean

:build
echo *************************************
echo * Installing OpenCCM on the WinCE PDA
echo *************************************


echo Creating OpenCCM directories structure on device
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\archives
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\bin
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\dtd
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\dtd\ccm
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\externals
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\externals\apollon
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\externals\jidlscript
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\externals\xerces
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\jar
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\lib
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\xml
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\xml\deployer
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\xml\descriptor
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\xml\descriptor\dci
call %rcmd% /nologo /nologo2 md %openccm_pda.dir%\%ORB.pda.name%\xml\launcher



echo  ==^> Copying [%build_dir%] directory to connected device...
echo * Copying OpenCCM command scripts...
call %rcmd% /nologo /nologo2 copy %build_dir%\bin\*.bat %openccm_pda.dir%\%ORB.pda.name%\bin\ /i
echo * Copying OpenCCM Launcher XML configuration file...
call %rcmd% /nologo /nologo2 copy %build_dir%\xml\launcher\*.xml %openccm_pda.dir%\%ORB.pda.name%\xml\launcher\ /i
echo * Copying OpenCCM default DeployerConfig .dcf file...
call %rcmd% /nologo /nologo2 copy %build_dir%\xml\deployer\*.dcf %openccm_pda.dir%\%ORB.pda.name%\xml\deployer\ /i
echo * Copying OpenCCM NodeProperties.npd file...
call %rcmd% /nologo /nologo2 copy %build_dir%\xml\descriptor\dci\*.npd %openccm_pda.dir%\%ORB.pda.name%\xml\descriptor\dci\ /i
echo * Copying OpenCCM Java libraries...
call %rcmd% /nologo /nologo2 copy %build_dir%\jar\*.jar %openccm_pda.dir%\%ORB.pda.name%\jar\ /i
call %rcmd% /nologo /nologo2 copy %build_dir%\lib\*.jar %openccm_pda.dir%\%ORB.pda.name%\lib\ /i
echo * Copying OpenCCM externals...
call %rcmd% /nologo /nologo2 copy %build_dir%\externals\jidlscript\*.jar %openccm_pda.dir%\%ORB.pda.name%\externals\jidlscript\ /i
call %rcmd% /nologo /nologo2 copy %build_dir%\externals\xerces\*.jar %openccm_pda.dir%\%ORB.pda.name%\externals\xerces\ /i
call %rcmd% /nologo /nologo2 copy %build_dir%\externals\apollon\*.jar %openccm_pda.dir%\%ORB.pda.name%\externals\apollon\ /i
echo * Copying OpenCCM DTD files
call %rcmd% /nologo /nologo2 copy %build_dir%\dtd\ccm\*.dtd %openccm_pda.dir%\%ORB.pda.name%\dtd\ccm\ /i
echo * Copying OpenCCM archive demos
 call %rcmd% /nologo /nologo2 copy %build_dir%\archives\*.aar %openccm_pda.dir%\%ORB.pda.name%\archives\ /i
echo * done.

goto:eof


:build_clean

echo  ==^> Deleting previous OpenCCM build dir on the device...

echo * removing %openccm_pda.dir%\%ORB.pda.name%\bin\*.bat...
call %rcmd% /nologo del %openccm_pda.dir%\%ORB.pda.name%\bin\*.bat

echo * removing %openccm_pda.dir%\%ORB.pda.name%\xml\launcher\*.xml...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\xml\launcher\*.xml

echo * removing %openccm_pda.dir%\%ORB.pda.name%\xml\deployer\*.dcf...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\xml\deployer\*.dcf

echo * removing %openccm_pda.dir%\%ORB.pda.name%\jar\*.jar...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\jar\*.jar

echo * removing %openccm_pda.dir%\%ORB.pda.name%\lib\*.jar...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\lib\*.jar

echo * removing %openccm_pda.dir%\%ORB.pda.name%\externals\*...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\externals\jidlscript\*.*
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\externals\xerces\*.*
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\externals\apollon\*.*

echo * removing %openccm_pda.dir%\%ORB.pda.name%\dtd\ccm\*.dtd...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\dtd\ccm\*.dtd
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\xml\descriptor\dci\*.npd

echo * removing %openccm_pda.dir%\%ORB.pda.name%\archives\*.aar...
call %rcmd% /nologo /nologo2 del %openccm_pda.dir%\%ORB.pda.name%\archives\*.aar


echo Removing directories structure on device...
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\archives
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\bin
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\dtd\ccm
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\dtd
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\externals\xerces
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\externals\apollon
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\externals\jidlscript
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\externals
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\jar
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\lib
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\xml\deployer
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\xml\descriptor\dci
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\xml\descriptor
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\xml\launcher
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%\xml
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%\%ORB.pda.name%
call %rcmd% /nologo /nologo2 rd %openccm_pda.dir%

echo done.