/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ________________________________________.

====================================================================*/

package org.objectweb.openccm.generator.java.core.api;

import org.objectweb.openccm.generator.java.ast.api.Repository;
import org.objectweb.openccm.generator.java.ast.api.InterfaceObject;
import java.util.List;


/**
 * This is the Java generator interface.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</A>
 */

public interface JavaGenerator
         extends org.objectweb.openccm.generator.common.api.Generator
{
    /**
     * Initialize the generator.
     *
     * @param app_name - The application's name.
     * @param templates - Templates files to use.
     **/
    public void
    initialize( String app_name,
                List templates );

    /**
     * Generate java files from the repository.
     *
     * @param base_dir - The base directory where files will be generated.
     **/
    public void
    generate(Repository rep, String base_dir);

    /**
     * Create the output file.
     * This include creation of package directories if necessary.
     *
     * @param object - The class or interface to generate.
     * @param id - An identifiant for this stream.
     **/
    public void
    create_file(InterfaceObject object, String id);
}

