@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Christophe Demarey.
rem # Contributor(s): ______________________________________.
rem #
rem # ====================================================================

rem # Goes to the production module root dir
cd ..

rem # Install the OpenCCM platform
call ccm_install

rem # Starts the Interface Repository
call ir3_start

rem # Checks an idl3 file
call idl3_check test/sample.idl3

rem # Feeds an idl3 file
call ir3_feed test/sample.idl3

rem # Tests the ir3_idl2 command
call ir3_idl2 sample

rem # Tests the ir3_idl3 command
call ir3_idl3 sample

rem # Tests the ir3_idl2 command
call ir3_idl2 sample

rem # Tests the psdl command
call psdl test/sample.psdl

rem # Tests the cidl command
call cidl test/sample.cidl

rem # Tests the ir3_destroy command
call ir3_destroy sample

rem # Stops the Interface Repository
call ir3_stop

rem # Starts the Interface Repository with all IDL files
call ir3_start_with_all

rem # Uninstall the OpenCCM platform
call corba_uninstall

rem # Goes back to the test directory
cd test

