#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Philippe Merle.
# Contributor(s): ______________________________________.
#
# ====================================================================

# Goes to the root of the OpenCCM distribution.
cd ../..

# Shell function to stop the Interface Repository and exit.
stop_and_exit()
{
  ir3_stop
  echo Please report this problem to the openccm@objectweb.org mailing list!
  exit -1
}

# Shell function to exit if error occurs on the last command.
exit_if_status_is_not_OK()
{
  if [ $? != 0 ]
  then
    stop_and_exit
  fi
}

# Starts the OpenCCM Interface Repository.
ir3_start

# Checks the OMG IDL file test/sample.idl3.
idl3_check test/sample.idl3
exit_if_status_is_not_OK

# Checks the OMG IDL file test/sample.idl3.
idl3_check test/sample.idl3
exit_if_status_is_not_OK

# Stops the OpenCCM Interface Repository.
ir3_stop

# Tests run successfully.
echo All idl3_check tests run successfully.
exit 0
