/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ________________________________________.

====================================================================*/

package org.objectweb.openccm.pss.generator.common.api;

// Package dependencies
import org.objectweb.openccm.ast.api.AbstractStorageHomeDecl;

/**
 * Interface to get Mapping from PSDL Abstract Storage Homes.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 * 
 * @version 0.1
 */

public interface AbstractStorageHomeMapping
         extends JavaMappingObject
{
    /** 
     * Set the PSDL Abstract StorageHome Declaration to map. 
     *
     * @param ash - The Abstract Storage Home to map.
     */
     public void
     setAbstractStorageHome(AbstractStorageHomeDecl ash);
}
