/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): Alex Andrushchak.

====================================================================*/

package org.objectweb.openccm.pss.runtime.common.api;


/**
 * Connector is a base interface for Connectors.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 * @author <a href="mailto:pretend@ukr.net">Alex Andrushchak</a>
 *
 * @version 0.1
 */

public interface Connector
         extends org.omg.CosPersistentState.Connector
{
    /**
     * Key constants for connector parameters.
     */
    public static final String CONF_FILE_KEY    = "CONF_FILE";

    /**
     * Get a storage object factory.
     */
    public java.lang.Class
    get_storage_object_factory(String storage_type_name);

    /**
     * Get a storage home factory
     */
    public java.lang.Class
    get_storage_home_factory(String storage_home_type_name);    
}
