/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.pss.runtime.common.api;

/**
 * Base interface for Storage Homes.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public interface StorageHomeBase
         extends org.omg.CosPersistentState.StorageHomeBase
{
    /**
     * Initialize the storage home.
     *
     * @param catalog - The storage home catalog.
     */
    public void
    initialize(org.objectweb.openccm.pss.runtime.common.api.CatalogBase catalog);

    /**
     * Register a storage type incarnation.
     *
     * @param st_incarnation - The storage object to register.
     */
    public void
    register_storage_type_incarnation(java.lang.Object st_incarnation);

    /**
     * Unregister a storage type incarnation.
     *
     * @param pid - The storage object Pid.
     */
    public void
    unregister_storage_type_incarnation(byte[] pid);

    /**
     * Get the Repository ID of a storage home.
     *
     * @return The storage home RID.
     */
    public String
    get_rid();

    /**
     * Get the Repository ID of the managed storage type.
     *
     * @return The storage type RID.
     */
    public String
    get_st_rid();
}
