/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.pss.runtime.common.lib;


/**
 * This class encode some IDL Types into byte array to make
 * them serializable.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */
public class IDLTypeCodec
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    private static org.omg.IOP.Codec codec = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     * The default constructor.
     */
    public IDLTypeCodec()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    static
    {
        org.omg.IOP.CodecFactory cf = null;
        org.omg.IOP.Encoding enc = null;

        try{
        cf = (org.omg.IOP.CodecFactory) org.objectweb.openccm.corba.TheORB.getORB().
                    resolve_initial_references("CodecFactory");
        }catch(org.omg.CORBA.ORBPackage.InvalidName ex){
            ex.printStackTrace();
        }

        try{
            // Try Version 1.2
            enc =   new org.omg.IOP.Encoding(
                        org.omg.IOP.ENCODING_CDR_ENCAPS.value, (byte) 1, (byte) 2);
            codec = cf.create_codec(enc);
        }catch(org.omg.IOP.CodecFactoryPackage.UnknownEncoding ex1){
            try{
                // Try Version 1.1
                enc =   new org.omg.IOP.Encoding(
                            org.omg.IOP.ENCODING_CDR_ENCAPS.value, (byte) 1, (byte) 1);
                codec = cf.create_codec(enc);
            }catch(org.omg.IOP.CodecFactoryPackage.UnknownEncoding ex2){
                // Try Version 1.0
                enc =   new org.omg.IOP.Encoding(
                            org.omg.IOP.ENCODING_CDR_ENCAPS.value, (byte) 1, (byte) 0);
                try{
                    codec = cf.create_codec(enc);
                }catch(org.omg.IOP.CodecFactoryPackage.UnknownEncoding ex3){
                    ex3.printStackTrace();
                }
            }
        }
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Get the codec singleton.
     *
     * @return A CDR codec.
     */
    public static org.omg.IOP.Codec
    getCodec()
    {
        return codec;
    }
}
