/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: CCMPropertyUtil.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.ast;

import ispuml.mdaTransformation.model.SimplePropertyUtil;

import java.lang.reflect.InvocationTargetException;

/**
 * An implementation of the property util for
 * the CORBA Properties.
 * @author Pierre Carpentier
 */
public class CCMPropertyUtil extends SimplePropertyUtil
{

   /**
    * Set the property with the parameter value to the bean.
    * @param bean The bean which will contain this property.
    * @param name The name of the property.
    * @param value The value of the property.
    */
   public void setProperty(Object bean, String name, Object value)
      throws IllegalAccessException, InvocationTargetException, NoSuchMethodException
   {
   CCMPropertyUtils.setProperty( bean, name, value);
   }
   
}
