/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: CategoryKind.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.ast;

import ispuml.mdaTransformation.RuleContext;
import ispuml.mdaTransformation.TransformationException;
import ispuml.mdaTransformation.ActionBase;
import ispuml.mdaTransformation.rules.xml.CompositeXmlAction;

        
/**
 * This action sets the Category Kind of a CIDL Composition.
 */
public class CategoryKind extends CompositeXmlAction {

    /**
     * Constructor.
     */
    public CategoryKind() {
        // The src property is not required. If it is not set, use the bean provided
        // as parameter.
        isSrcPropertyRequired = false;
        isDstPropertyRequired = false;
        action = new TransformAction();
    }

    /**
     * Inner class
     */
    class TransformAction extends ActionBase {
        /**
         * Transform the bean and return the result.
         * @param object
         * @return Object
         */
        public Object execute(Object bean, RuleContext request) throws TransformationException {
            CCMASTModelContext context;
            context = (CCMASTModelContext) request.engineContext.getModel("ccm-ast");
            Object obj = request.getAttribute("declaration");
            org.objectweb.openccm.ast.api.CompositionDecl composition;
            composition = (org.objectweb.openccm.ast.api.CompositionDecl) obj;
            String category = (String)bean;
            if (category.equalsIgnoreCase("entity"))
                composition.setCategoryKind(org.objectweb.openccm.ast.api.CategoryKind.ck_entity);
            else if (category.equalsIgnoreCase("process"))
                composition.setCategoryKind(org.objectweb.openccm.ast.api.CategoryKind.ck_process);
            else if (category.equalsIgnoreCase("service"))
                composition.setCategoryKind(org.objectweb.openccm.ast.api.CategoryKind.ck_service);
            else
                composition.setCategoryKind(org.objectweb.openccm.ast.api.CategoryKind.ck_session);
            //System.out.println("composition.setCategoryKind(" + category + ")");
            return composition;
        }

    } // end class
}
