/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: ConsoleSingleton.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.log;

import org.objectweb.util.cmdline.api.Console;

/**
 * Singleton class for retrieving the current Console.
 * 
 * @author Pierre Carpentier
 */
public class ConsoleSingleton {

    /** The console. */
    private static Console console;
    
    /**
     * Gets the current console.
     * @return The current console.
     */
    public static Console getConsole() {
        return console;
    }
    
    /**
     * Sets the current console.
     * @param newConsole The new current console.
     */
    public static void setConsole(Console newConsole) {
        console = newConsole;
    }


}
