/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: TransformJmiModelRootsAction.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.modfact;

import ispuml.mdaTransformation.RuleContext;
import ispuml.mdaTransformation.TransformationException;
import ispuml.mdaTransformation.ActionBase;
import ispuml.mdaTransformation.rules.xml.CompositeXmlAction;

import javax.jmi.reflect.RefPackage;
import java.util.Collection;
import java.util.Iterator;

/**
 * An action walking the roots of the model and calling the engine on each roots.
 */
public class TransformJmiModelRootsAction extends CompositeXmlAction {

	/**
	 * Default Constructor.
	 */
	public TransformJmiModelRootsAction() {
		// The src property is not required. If it is not set, use the bean provided
		// as parameter.
		isSrcPropertyRequired = false;
		isDstPropertyRequired = false;
		action = new TransformAction();
	}

	/**
	 * Inner class
	 */
	class TransformAction extends ActionBase {
		/**
		 * Transform the bean and return the result.
		 * @param object
		 * @return Object
		 */
		public Object execute(Object bean, RuleContext request) throws TransformationException {
			Collection roots = JmiModFactModelCreateUtils.getRoots((RefPackage) bean);
			Iterator iter = roots.iterator();

			if (!iter.hasNext())
				System.out.println("  Warning - no roots found for model '" + bean + "'");
			while (iter.hasNext()) {
				Object cur = iter.next();
				request.engineContext.engine.transform(cur, request);
			}
			return null;
		}
	} // end class
}
