/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: RemoveArrayBracket.java,v 1.2 2004/06/07 09:09:37 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.rules.xml;

import ispuml.mdaTransformation.RuleContext;
import ispuml.mdaTransformation.TransformationException;
import ispuml.mdaTransformation.rules.xml.XmlAction;

/**
 * Action to remove the end brackets '[]' from the name of the bean.
 * 
 * @author Pierre Carpentier
 */
public class RemoveArrayBracket extends XmlAction {
    
    
    /**
     * Default Constructor
     */
    public RemoveArrayBracket () {
        super();
    }

    /* (non-Javadoc)
     * @see ispuml.mdaTransformation.Action#execute(java.lang.Object, ispuml.mdaTransformation.RuleContext)
     */
    public Object execute(Object bean, RuleContext context) throws TransformationException {
        if (bean instanceof org.omg.uml.core.DataType) {
            org.omg.uml.core.DataType dt = (org.omg.uml.core.DataType)bean;
            dt.setName(dt.getName().substring(0, dt.getName().lastIndexOf("[]")));
        }
        return bean;
    }

}
