/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_m3120Components;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;

import intt.itu.itut_m3120.NOuserLabelPackageException;
import intt.itu.itut_m3120.NOvendorNamePackageException;
import intt.itu.itut_m3120.NOversionPackageException;
import intt.itu.itut_m3120.NOlocationNamePackageException;
import intt.itu.itut_m3120.ManagedElementValueType;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.StateChangedEventImpl;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ManagedElementValueTypeImpl;
import java.util.Hashtable;

/**
 **  Implementation skeleton class for the ::itut_m3120Components::ManagedElementProvider component.
 **  Business operations MUST be completed !!!
 **/
public class ManagedElementProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_ManagedElementProvider,
                  ist.coach.itut_m3120Components.CCM_ManagedElementMgmt,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_ManagedElementProvider_Context the_context_;
    private String _facade_name;
    private int notifId = 200;
	private Hashtable elements;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    ManagedElementProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_ManagedElementProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
		elements = new java.util.Hashtable();
		System.err.println(facade_name() + " configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_ManagedElementProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_ManagedElementProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_m3120Components/CCM_ManagedElementProvider/get_mgmt:1.0
    //
    /**
     **  Implementation of the ::itut_m3120Components::CCM_ManagedElementProvider::get_mgmt operation.
     **/
    public ist.coach.itut_m3120Components.CCM_ManagedElementMgmt
    get_mgmt()
    {
        return this;
    }
    //
    //  IDL:coach.ist/itut_x780Components/CCM_NamedComponent_Executor/facade_name:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     **/
    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
			_facade_name = new String(val);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/administrativeStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateGet operation.
     **/
    public intt.itu.itut_x780.AdministrativeStateType
    administrativeStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE: implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.administrativeState;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/administrativeStateSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateSet operation.
     **/
    public void
    administrativeStateSet(org.omg.CosNaming.NameComponent[] name,
	intt.itu.itut_x780.AdministrativeStateType administrativeState)
    throws intt.itu.itut_x780.ApplicationError
    {
	    //
		//  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
	    ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.remove(key);
	    mo_value.administrativeState = administrativeState;
		elements.put(key, mo_value);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/operationalStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::operationalStateGet operation.
     **/
    public intt.itu.itut_x780.OperationalStateType
    operationalStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.operationalState;

    }

    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/usageStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::usageStateGet operation.
     **/
    public intt.itu.itut_x780.UsageStateType
    usageStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.usageState;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/userLabelGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::userLabelGet operation.
     **/
    public java.lang.String
    userLabelGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOuserLabelPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.userLabel;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/userLabelSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::userLabelSet operation.
     **/
    public void
    userLabelSet(org.omg.CosNaming.NameComponent[] name, java.lang.String userLabel)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOuserLabelPackageException
    {
	    //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
	    ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.remove(key);
	    mo_value.userLabel = userLabel;
		elements.put(key, mo_value);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/vendorNameGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::vendorNameGet operation.
     **/
    public java.lang.String
    vendorNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOvendorNamePackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.vendorName;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/vendorNameSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::vendorNameSet operation.
     **/
    public void
    vendorNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String vendorName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOvendorNamePackageException
    {
	    //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
	    ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.remove(key);
	    mo_value.vendorName = vendorName;
		elements.put(key, mo_value);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/versionGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::versionGet operation.
     **/
    public java.lang.String
    versionGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.version;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/versionSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::versionSet operation.
     **/
    public void
    versionSet(org.omg.CosNaming.NameComponent[] name, java.lang.String version)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
	    ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.remove(key);
	    mo_value.version = version;
		elements.put(key, mo_value);

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/locationNameGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::locationNameGet operation.
     **/
    public java.lang.String
    locationNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOlocationNamePackageException
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name" +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	   }
	   ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.get(key);

		return mo_value.locationName;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/locationNameSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::locationNameSet operation.
     **/
    public void
    locationNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String locationName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOlocationNamePackageException
    {
	    //
        //  DONE : implement
        //
		String key = Utils.name2string(name);
		if (this.elements.containsKey(key) == false) {

		  ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		  error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		  error_code.details = new String ("object with name " +
			key + " does not exist.");

		  throw new ApplicationError(error_code);
	    }
	    ManagedElementValueType mo_value =
		(ManagedElementValueType) elements.remove(key);
	    mo_value.locationName = locationName;
		elements.put(key, mo_value);
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/nameGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        //  DONE : implement
        //
        return Utils.string2name(_facade_name);
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/
    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
       		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.objectClass;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
       		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedElementValueType mo_value =
			(ManagedElementValueType) elements.get(Utils.name2string(name));
		return mo_value;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.packages;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
        		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.creationSource;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.deletePolicy;

    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);

		}
		ManagedElementValueType mo_value =
			(ManagedElementValueType) elements.remove(Utils.name2string(name));
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		the_context_.push_objectDeletion_alarm(new ObjectDeletionImpl(eventTime, name,
										mo_value.objectClass,
										getUniqueNotificationIdentifier(),
										mo_value.creationSource,
										new AttributeValueType[0]));
    }
    // ==================================================================
    //
    // Public methods for the ::itut_m3120Components::CCM_ManagedElementMgmt local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_m3120Components/ManagedElementMgmt/create:1.0
    //
    /**
     **  Implementation of the ::itut_m3120Components::ManagedElementMgmt::create operation.
     **/
    public void
    create(org.omg.CosNaming.NameComponent[] name, java.lang.String objectClass,
		  java.lang.String[] packages, short deletePolicy,
		  intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
		  intt.itu.itut_x780.AdministrativeStateType administrativeState,
		  java.lang.String userLabel, java.lang.String vendorName,
		  java.lang.String version, java.lang.String locationName)
    throws intt.itu.itut_x780.CreateError, intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if (elements.containsKey(Utils.name2string(name))) {
			System.err.println(Utils.name2string(name) + " already exists!");
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

            error_code.details =  ExceptionMessages.already_exists_error;
            throw new CreateError(error_code);
		}
		ManagedElementValueTypeImpl value_type =
				new ManagedElementValueTypeImpl(name, objectClass, packages,
						sourceIndicator, deletePolicy, administrativeState,
						userLabel, vendorName, version, locationName);

		elements.put(Utils.name2string(name), value_type);

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);

		//System.err.println("ManagedElementProvider  attempts to push object creation alarm...");
		the_context_.push_objectCreation_alarm(new ObjectCreationImpl(eventTime, name,
										objectClass,
										getUniqueNotificationIdentifier(),
										sourceIndicator,
										new AttributeValueType[0]));

    }
   private int getUniqueNotificationIdentifier() {

       notifId++;

       return (notifId);
   }
}
