/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_q816Components;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.DeleteErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.DeleteError;
import intt.itu.itut_x780.ManagedObject_F;

import org.omg.CosNaming.NameComponent;

/**
 **  Implementation skeleton class for the ::itut_q816Components::TerminatorServiceProvider component.
 **  Business operations MUST be completed !!!
 **/
public class TerminatorServiceProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_TerminatorServiceProvider,
                  intt.itu.itut_q816.CCM_TerminatorService,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_TerminatorServiceProvider_Context the_context_;
	intt.itu.itut_q816.ContainmentComponent c_admin = null;
	intt.itu.itut_q816.Containment c_query = null;

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    TerminatorServiceProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_TerminatorServiceProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
		if ((c_admin = the_context_.get_connection_containment_admin()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_query = the_context_.get_connection_containment_query()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		System.err.println("TerminatorServiceProvider configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_TerminatorServiceProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_TerminatorServiceProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_q816Components/CCM_TerminatorServiceProvider/get_terminator:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_TerminatorServiceProvider::get_terminator operation.
     **/
    public intt.itu.itut_q816.CCM_TerminatorService
    get_terminator()
    {
        return this;
    }
    // ==================================================================
    //
    // Public methods for the ::itut_q816::CCM_TerminatorService local interface.
    //
    // ==================================================================
    //
    //  IDL:itu.intt/itut_q816/TerminatorService/deleteByName:1.0
    //
    /**
     **  Implementation of the ::itut_q816::TerminatorService::deleteByName operation.
     **/
    public void
    deleteByName(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

		String name_str 	= Utils.name2string(name);
		String facade_name 	= Utils.name2facade(name_str);

		if (facade_name.length() == 0) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.root_delete_error;

			System.err.println("Terminator: Root Object can not be deleted!");
            throw new ApplicationError(error_code);
		}
		System.err.println("deleteByName called for " + name_str + " of " +
				facade_name);


/* HACK: Must have <componentsupportedinterface> in deployment script */
/********/
		ist.coach.itut_q816Components.
		TerminatorServiceProviderPackage.target_facadesConnection [] facades =
			the_context_.get_connections_target_facades();

		int i = 0;
		org.omg.CosNaming.NameComponent[] facade_name_comp;
		for(i = 0; i < facades.length; i++) {
			facade_name_comp = facades[i].objref.nameGet();
			System.err.println("TerminatorService>Examining facade " +
			  Utils.name2string(facade_name_comp));

			int len = facade_name_comp.length;
			if (len > 0 &&
				facade_name_comp[len - 1].kind.equals(facade_name))

					break;
		}

		if (i >= facades.length) {

			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.facade_not_exists_error;

			System.err.println("Terminator: Could not locate the facade!");
            throw new ApplicationError(error_code);
		}

		ManagedObject_F facade = facades[i].objref;

		short objectDeletePolicy = facade.deletePolicyGet(name);

		org.omg.CosNaming.NameComponent[][] contained_objects = null;
		switch (objectDeletePolicy) {

		case intt.itu.itut_x780.notDeletable.value:

			System.err.println("notDeletable policy holds");

			DeleteErrorInfoTypeImpl error_code =
               	new DeleteErrorInfoTypeImpl();
           	error_code.error = new UIDType(
               	intt.itu.itut_x780.DeleteErrorConst.moduleName.value,
               	intt.itu.itut_x780.DeleteErrorConst.notDeletable.value);
           	error_code.details = name_str + ExceptionMessages.manager_delete_error;
			throw new DeleteError(error_code);

		case intt.itu.itut_x780.deleteOnlyIfNoContainedObjects.value:

			System.err.println("deleteOnlyIfNoContainedObjects policy holds");

			contained_objects = c_query.getContained(name);

			if (contained_objects.length > 0) {

				DeleteErrorInfoTypeImpl error_contained =
                	new DeleteErrorInfoTypeImpl();
            	error_contained.error = new UIDType(
                	intt.itu.itut_x780.DeleteErrorConst.moduleName.value,
                	intt.itu.itut_x780.DeleteErrorConst.containsObjects.value);
            	error_contained.details = ExceptionMessages.contains_object_error +
								".\n " + name_str + " contains " +
                	contained_objects.length + " children";
				throw new DeleteError(error_contained);
			}

			delete(name, facade);
			//delete(name, facades[i].objref);
			return;

		case intt.itu.itut_x780.deleteContainedObjects.value:

			System.err.println("deleteContainedObjects policy holds");

            contained_objects = c_query.getContained(name);

			if (contained_objects.length ==  0) {
				delete(name, facade);
				//delete(name, facades[i].objref);
				return;
			}

			for(int j = 0; j < contained_objects.length; j++) {
				deleteByName(contained_objects[j]);
			}
			delete(name, facade);
			//delete(name, facades[i].objref);
			return;

		default:		// Signifies error in provided deletePolicy
				return;
    	}
	}

	public void delete(org.omg.CosNaming.NameComponent[] name,
						intt.itu.itut_x780.ManagedObject_F facade)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
	{

			// remove object from the facade
		facade.destroy(name);
			// remove object from the containment service
		c_admin.removeName(name);
			// remove object from the SNMP service
		System.err.println("delete: Successfully removed object " +
			Utils.name2string(name) + " from its facade and containment service!");
	}

}
