/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;

import intt.itu.itut_m3120.NOuserLabelPackageException;
import intt.itu.itut_m3120.NOvendorNamePackageException;
import intt.itu.itut_m3120.NOversionPackageException;
import intt.itu.itut_m3120.NOlocationNamePackageException;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.StateChangedEventImpl;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ManagedObjectValueTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;

import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpNodeValueType;
import ist.coach.coachEmsMib.NOsysInformationSetPackageException;

import ist.coach.coachEmsCommon.IpNodeValueTypeImpl;
import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;

import java.util.Hashtable;
/**
 **  Implementation skeleton class for the ::coachEmsMibComponents::IpNodeProvider component.
 **  Business operations MUST be completed !!!
 **/
public class IpNodeProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_IpNodeProvider,
                  ist.coach.coachEmsMibComponents.CCM_IpNodeMgmt,
                  ist.coach.coachEmfServices.SnmpAdapter.CCM_TrapCallback,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    org.omg.CORBA.ORB orb = null;
    private CCM_IpNodeProvider_Context the_context_;
	private String _facade_name;
	private int notifId = 1000;

	private static final String IF_NUMBER_OID	 = ".1.3.6.1.2.1.2.1.0";
	private static final String SYS_DESCR_OID	 = ".1.3.6.1.2.1.1.1.0";
	private static final String SYS_OBJECTID_OID = ".1.3.6.1.2.1.1.2.0";
	private static final String SYS_UPTIME_OID	 = ".1.3.6.1.2.1.1.3.0";
	private static final String SYS_CONTACT_OID	 = ".1.3.6.1.2.1.1.4.0";
	private static final String SYS_NAME_OID	 = ".1.3.6.1.2.1.1.5.0";
	private static final String SYS_LOCATION_OID = ".1.3.6.1.2.1.1.6.0";
	private static final String SYS_SERVICES_OID = ".1.3.6.1.2.1.1.7.0";
	private static final String TIME_OID		 = ".1.3.6.1.2.1.1.3.0";

	private static final int COLDSTART_TRAP = 1;
	private static final int NETSNMP_SHUTDOWN_TRAP = 4;

	private static final String SYS_INFO_SET_PACKAGE = "sysInfoSetPackage";
	private static final String LOCATION_NAME_PACKAGE = "locationNamePackage";
	private static final String USER_LABEL_PACKAGE = "userLabelPackage";
	private static final String VENDOR_NAME_PACKAGE = "vendorNamePackage";
	private static final String VERSION_PACKAGE = "versionPackage";

    private static final String READ_COMMUNITY = "public";
    private static final String WRITE_COMMUNITY = "private";

	private Hashtable elements;

	ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;
	ist.coach.coachEmfServices.SnmpAdapter.SnmpTrapDaemon config = null;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpNodeProviderMonolithicImpl()
    {
        the_context_ = null;
    	this.elements = new Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================


    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_IpNodeProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

	if ((connector = the_context_.get_connection_connector()) == null)
			throw new org.omg.Components.InvalidConfiguration();

	if ((config = the_context_.get_connection_config()) == null)
			throw new org.omg.Components.InvalidConfiguration();

	orb = org.objectweb.ccm.CORBA.TheORB.getORB();
		System.err.println("IpNodeProvider configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_IpNodeProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_IpNodeProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMibComponents/CCM_IpNodeProvider/get_mgmt:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::CCM_IpNodeProvider::get_mgmt operation.
     **/
    public ist.coach.coachEmsMibComponents.CCM_IpNodeMgmt
    get_mgmt()
    {
        return this;
    }
    //
    //  IDL:coach.ist/coachEmsMibComponents/CCM_IpNodeProvider/get_snmp_callback:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::CCM_IpNodeProvider::get_snmp_callback operation.
     **/
    //public ist.coach.coachEmfServices.SnmpAdapter.CCM_TrapCallback
    //get_snmp_callback()
    //{
    //    return this;
   // }
    //
    //  IDL:coach.ist/itut_x780Components/CCM_NamedComponent_Executor/facade_name:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     **/
    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
		return _facade_name;
    }

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);


    }

    /**
     **  Implementation of the ManagedObject_F::nameGet operation.
     **/
    public NameComponent[] nameGet() {
        return Utils.string2name(_facade_name);
    }

    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/domainNameGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::domainNameGet operation.
     **/
    public java.lang.String
    domainNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.domainName;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/hostnameGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::hostnameGet operation.
     **/
    public java.lang.String
    hostnameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //


	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

	error_code.error = new UIDType(
		intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

	error_code.details = new String ("object with name" +
		key + " does not exist.");

	throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.hostname;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/managementIPAddressGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::managementIPAddressGet operation.
     **/
    public byte[]
    managementIPAddressGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

	error_code.error = new UIDType(
		intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

	error_code.details = new String ("object with name" +
		key + " does not exist.");

	throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.managementIPAddress;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/supportedSnmpVersionsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::supportedSnmpVersionsGet operation.
     **/
    public int
    supportedSnmpVersionsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //


	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

	error_code.error = new UIDType(
		intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

	error_code.details = new String ("object with name" +
		key + " does not exist.");

	throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.supportedSnmpVersions;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/snmpPortGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::snmpPortGet operation.
     **/
    public int
    snmpPortGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.snmpPort;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/ifNumberGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::ifNumberGet operation.
     **/
    public int
    ifNumberGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	DataType ifNumberData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		ifNumberData = this.connector.get(
			IF_NUMBER_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ifNumber " +
		 		"for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + IF_NUMBER_OID +
		 		" does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = ifNumberData.value;

	if(value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ifNumber " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + IF_NUMBER_OID +
			 " is not of type long, as expected.");

		throw new ApplicationError(error_code);

	}

	int ifNumber = value.extract_long();

	return ifNumber;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysDescrGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysDescrGet operation.
     **/
    public java.lang.String
    sysDescrGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE: implement
        //

	DataType sysDescrData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysDescrData = this.connector.get(
			SYS_DESCR_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysDescr " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SYS_DESCR_OID +
				 " does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysDescrData.value;

	//if(value.type().kind().value() != TCKind._tk_string) {
	if(value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysDescr " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_DESCR_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}
	String sysDescr = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	//String sysDescr = value.extract_string();

	return sysDescr;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysObjectIDGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysObjectIDGet operation.
     **/
    public java.lang.String
    sysObjectIDGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	DataType sysObjectIDData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysObjectIDData = this.connector.get(
			SYS_OBJECTID_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysObjectID " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SYS_OBJECTID_OID +
				 " does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysObjectIDData.value;

	if(value.type().kind().value() != TCKind._tk_string) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysObjectID " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_OBJECTID_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}

	String sysObjectID = value.extract_string();

	return sysObjectID;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysUpTimeGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysUpTimeGet operation.
     **/
    public long
    sysUpTimeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	DataType sysUpTimeData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysUpTimeData = this.connector.get(
			SYS_UPTIME_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysUpTime " +
			 	"for IpNode Object with name " + key + ":" +
			 	" Object with Snmp Object Identifier " + SYS_UPTIME_OID +
			 	" does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysUpTimeData.value;

	if(value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysUpTime " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_UPTIME_OID +
			 " is not of type long, as expected.");

		throw new ApplicationError(error_code);

	}

	long sysUpTime = value.extract_longlong();

	return sysUpTime;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysContactGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysContactGet operation.
     **/
    public java.lang.String
    sysContactGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //


	DataType sysDescrData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysDescrData = this.connector.get(
			SYS_CONTACT_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
				error_code.details = new String ("Could not retrieve sysContact " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SYS_CONTACT_OID +
				 " does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysDescrData.value;

	//if(value.type().kind().value() != TCKind._tk_string) {
	if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysContact " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_CONTACT_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}
	String sysContact = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	//String sysContact = value.extract_string();

	return sysContact;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysContactSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysContactSet operation.
     **/
    public void
    sysContactSet(org.omg.CosNaming.NameComponent[] name, java.lang.String sysContact)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOsysInformationSetPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(SYS_INFO_SET_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + SYS_INFO_SET_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOsysInformationSetPackageException();
	}

	org.omg.CORBA.Any value = orb.create_any();
	//value.insert_string(sysContact);
	org.omg.CORBA.OctetSeqHelper.insert(value, sysContact.getBytes());
	DataTypeImpl sysContactData = new DataTypeImpl(
		SYS_CONTACT_OID,
		value,
		SnmpSMI.SMI_STRING);

	try {

		this.connector.set(
			sysContactData,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			WRITE_COMMUNITY);
		}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not set sysContact " +
				 "for IpNode Object with name " + key + ".");

		throw new ApplicationError(error_code);

	}

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysNameGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysNameGet operation.
     **/
    public java.lang.String
    sysNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	DataType sysNameData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysNameData = this.connector.get(
			SYS_NAME_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysName " +
			 	"for IpNode Object with name " + key + ":" +
			 	" Object with Snmp Object Identifier " + SYS_NAME_OID +
			 	" does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysNameData.value;

	//if(value.type().kind().value() != TCKind._tk_string) {
	if(value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysName " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_NAME_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}

	//String sysContact = value.extract_string();
	String sysName = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	return sysName;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysNameSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysNameSet operation.
     **/
    public void
    sysNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String sysName)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOsysInformationSetPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(SYS_INFO_SET_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + SYS_INFO_SET_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOsysInformationSetPackageException();
	}

	org.omg.CORBA.Any value = orb.create_any();
	//value.insert_string(sysName);

	org.omg.CORBA.OctetSeqHelper.insert(value, sysName.getBytes());

	DataTypeImpl sysNameData = new DataTypeImpl(
		SYS_NAME_OID,
		value,
		SnmpSMI.SMI_STRING);

	try {

		this.connector.set(
			sysNameData,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			WRITE_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not set sysName " +
				 "for IpNode Object with name " + key + ".");

		throw new ApplicationError(error_code);

	}
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysServicesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysServicesGet operation.
     **/
    public short
    sysServicesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	DataType sysServicesData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysServicesData = this.connector.get(
			SYS_SERVICES_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysServices " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SYS_SERVICES_OID +
				 " does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysServicesData.value;

	if(value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysServices " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_SERVICES_OID +
			 " is not of type int, as expected.");

		throw new ApplicationError(error_code);

	}

	short sysServices = (short)value.extract_long();

	return sysServices;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/administrativeStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateGet operation.
     **/
    public intt.itu.itut_x780.AdministrativeStateType
    administrativeStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(
		Utils.name2string(name));

	return ipNodeData.administrativeState;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/administrativeStateSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateSet operation.
     **/
    public void
    administrativeStateSet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.AdministrativeStateType administrativeState)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	//HACK: Dummy operation! No support from underlying SNMP Agent!

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.administrativeState = administrativeState;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/operationalStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::operationalStateGet operation.
     **/
    public intt.itu.itut_x780.OperationalStateType
    operationalStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
    	//HACK: Dummy operation! No support from underlying SNMP Agent!

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(
		Utils.name2string(name));

	return ipNodeData.operationalState;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/usageStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::usageStateGet operation.
     **/
    public intt.itu.itut_x780.UsageStateType
    usageStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	//HACK: Dummy operation! No support from underlying SNMP Agent!

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}
	return intt.itu.itut_x780.UsageStateType.active;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/userLabelGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::userLabelGet operation.
     **/
    public java.lang.String
    userLabelGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOuserLabelPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(USER_LABEL_PACKAGE,
			packagesGet(name))) {
		throw new NOuserLabelPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.userLabel;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/userLabelSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::userLabelSet operation.
     **/
    public void
    userLabelSet(org.omg.CosNaming.NameComponent[] name, java.lang.String userLabel)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOuserLabelPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(USER_LABEL_PACKAGE,
			packagesGet(name))) {
		throw new NOuserLabelPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.userLabel = userLabel;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/vendorNameGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::vendorNameGet operation.
     **/
    public java.lang.String
    vendorNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOvendorNamePackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VENDOR_NAME_PACKAGE,
			packagesGet(name))) {
		throw new NOvendorNamePackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.vendorName;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/vendorNameSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::vendorNameSet operation.
     **/
    public void
    vendorNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String vendorName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOvendorNamePackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VENDOR_NAME_PACKAGE,
				packagesGet(name))) {
		throw new NOvendorNamePackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.vendorName = vendorName;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/versionGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::versionGet operation.
     **/
    public java.lang.String
    versionGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VERSION_PACKAGE,
			packagesGet(name))) {
		throw new NOversionPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.version;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/versionSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::versionSet operation.
     **/
    public void
    versionSet(org.omg.CosNaming.NameComponent[] name, java.lang.String version)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VERSION_PACKAGE,
			packagesGet(name))) {
		throw new NOversionPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.version = version;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/locationNameGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::locationNameGet operation.
     **/
    public java.lang.String
    locationNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOlocationNamePackageException
    {
        //
        //  DONE : implement
        //

	DataType sysLocationData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(LOCATION_NAME_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + LOCATION_NAME_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOlocationNamePackageException();
	}


	try {

		sysLocationData = this.connector.get(
			SYS_LOCATION_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysLocation " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SYS_LOCATION_OID +
				 " does not exist.");

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysLocationData.value;
	//by digi
	//if(value.type().kind().value() != TCKind._tk_string) {
	if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysLocation " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SYS_LOCATION_OID +
			 " is not of expected type.");

		throw new ApplicationError(error_code);

	}
	// by digi
	//String sysLocation = value.extract_string();
	String sysLocation = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	return sysLocation;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/locationNameSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::locationNameSet operation.
     **/
    public void
    locationNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String locationName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOlocationNamePackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(LOCATION_NAME_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + LOCATION_NAME_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOlocationNamePackageException();
	}

	org.omg.CORBA.Any value = orb.create_any();
	// by digi
	//value.insert_string(locationName);

	org.omg.CORBA.OctetSeqHelper.insert(value, locationName.getBytes());

	DataTypeImpl sysLocationData = new DataTypeImpl(
		SYS_LOCATION_OID,
		value,
		SnmpSMI.SMI_STRING);

	try {

		this.connector.set(
			sysLocationData,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			WRITE_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not set sysLocation " +
				 "for IpNode Object with name " + key + ".");

		throw new ApplicationError(error_code);

	}
  }

    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/

    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.objectclass;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	String userLabel = new String();
	String vendorName = new String();
	String version = new String();
	String locationName = new String();

	try {
		userLabel = userLabelGet(name);
	}
	catch (NOuserLabelPackageException noUserLabel) {

	}

	try {
		vendorName = vendorNameGet(name);
	}
	catch (NOvendorNamePackageException noVendorName) {

	}

	try {
		version = versionGet(name);
	}
	catch (NOversionPackageException noVersion) {

	}

	try {
		locationName = locationNameGet(name);
	}
	catch (NOlocationNamePackageException noLocation) {

	}

	IpNodeValueTypeImpl ipNodeValueType = new IpNodeValueTypeImpl(

		ipNodeData.administrativeState,
		this.operationalStateGet(name),
		this.usageStateGet(name),
		userLabel,
		vendorName,
		version,
		locationName,
		ipNodeData.domainName,
		ipNodeData.hostname,
		ipNodeData.managementIPAddress,
		ipNodeData.supportedSnmpVersions,
		ipNodeData.snmpPort,
		this.ifNumberGet(name),
		this.sysDescrGet(name),
		this.sysObjectIDGet(name),
		this.sysUpTimeGet(name),
		this.sysContactGet(name),
		this.sysNameGet(name),
		this.sysServicesGet(name),
		ipNodeData.name,
		ipNodeData.objectclass,
		ipNodeData.packageNameList,
		ipNodeData.sourceIndicator,
		ipNodeData.deletePolicy
	);

	return ipNodeValueType;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.packageNameList;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.sourceIndicator;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.deletePolicy;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {

			ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("object with name" +
			key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpNodeDataStructure ipNodeData = (IpNodeDataStructure) this.elements.remove(key);
		try {
			config.unregister(name);
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_e) {
			System.err.println("There was a problem unregistering " + Utils.name2string(name) +
			" from the SNMP Trap Deamon");
		}

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		the_context_.push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
										ipNodeData.objectclass,
										getUniqueNotificationIdentifier(),
										//ipNodeData.getUniqueNotificationIdentifier(),
										ipNodeData.sourceIndicator,
										new AttributeValueType[0]));
    }
    // ==================================================================
    //
    // Public methods for the ::coachEmsMibComponents::CCM_IpNodeMgmt local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMibComponents/IpNodeMgmt/create:1.0
    //
    /**
     **  Implementation of the ::coachEmsMibComponents::IpNodeMgmt::create operation.
     **/
    public void
    create( org.omg.CosNaming.NameComponent[] name,
				String objectClass,
				java.lang.String[] packages,
				short deletePolicy,
            	intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
				java.lang.String domainName,
				java.lang.String hostname,
				byte[] managementIPAddress,
				int supportedSnmpVersions,
				intt.itu.itut_x780.AdministrativeStateType administrativeState,
				java.lang.String userLabel,
				java.lang.String vendorName,
				java.lang.String version,
				java.lang.String locationName,
				int snmpPort,
				java.lang.String sysName,
				java.lang.String sysContact)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //

		boolean sysInfoSetPackageIsSupported = false;


		if (this.elements.containsKey(Utils.name2string(name))) {

			CreateErrorInfoTypeImpl errorCode =
				new CreateErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.CreateErrorConst.moduleName.value,
				intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

			errorCode.details = new String(Utils.name2string(name) +
				" object already exists.");
			throw new intt.itu.itut_x780.CreateError(errorCode);

		}

		IpNodeDataStructure ipNodeData = new IpNodeDataStructure(
												domainName,
												hostname,
												managementIPAddress,
												name,
												packages,
												supportedSnmpVersions,
												administrativeState,
												userLabel,
												vendorName,
												version,
												locationName,
												snmpPort,
												sysName,
												sysContact,
												objectClass,
												deletePolicy,
												sourceIndicator,
												intt.itu.itut_x780.OperationalStateType.enabled);

		this.elements.put(Utils.name2string(name), ipNodeData);

     	//System.err.println("IpNodeFacade>Before registering to the SNMP Trap service");

		String ipAddress = new String();
        if (managementIPAddress != null)
			ipAddress = new String(managementIPAddress);

        try {
            config.registerIP(name, ipAddress);
        }
        catch( ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
            System.err.println("Could not register IpNode " +
                Utils.name2string(name) + " to the SNMP Trap Service");
            System.err.println("Reason= " + snmp_ex.reason);
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.downstreamError.value);

            error_code.details = snmp_ex.reason;

            throw new ApplicationError(error_code);
        }

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);

		//System.err.println("IpNodeProvider  attempts to push object creation alarm...");
		the_context_.push_objectCreation(new ObjectCreationImpl(eventTime, name,
										objectClass,
										getUniqueNotificationIdentifier(),
										//ipNodeData.getUniqueNotificationIdentifier(),
										sourceIndicator,
										new AttributeValueType[0]));

		System.err.println("IpNodeProvider finished create operations...");
    }
    // ==================================================================
    //
    // Public methods for the ::coachEmfServices::SnmpAdapter::CCM_TrapCallback local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmfServices/SnmpAdapter/TrapCallback/notifyTrap:1.0
    //
    /**
     **  Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::notifyTrap operation.
     **/
    public void
    notifyTrap(org.omg.CosNaming.NameComponent[] name,
				java.lang.String community,
				int trapID, int trapType,
			ist.coach.coachEmfServices.SnmpAdapter.DataType[] trapData)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
        //
        //  TODO : implement
        //

		//System.err.println("IpNode_F: Notify trap is called for " +
		//	Utils.name2string(name));

		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("object with name" +
			key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	    intt.itu.itut_x780.OperationalStateType oldValue = data.operationalState;

	    intt.itu.itut_x780.OperationalStateType newValue = null;


		if (trapType == COLDSTART_TRAP) {

			newValue = intt.itu.itut_x780.OperationalStateType.enabled;

		}
		else
		if (trapType == NETSNMP_SHUTDOWN_TRAP) {

			newValue = intt.itu.itut_x780.OperationalStateType.disabled;

		}
		else {

			System.err.println("IpNode_F does not know how to handle trap of type " +
				trapType);

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpNode_F does not know how to handle" +
			" trap of type " + trapType + ".");

			throw new ApplicationError(error_code);

		}

		if (newValue == oldValue) {

			//System.err.println("No value change occured. Old value is equal to new one.");

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String (" Cannot emmit StateChange Event when no" +
				" state change has occured for IpNode with name " +
				Utils.name2string(name));

			throw new ApplicationError(error_code);
		}

		data.operationalState = newValue;

		long trapTime = 0;
		boolean trapTimeFound = false;

		for (int i = 0; i < trapData.length; i++) {

			if (trapData[i].identifier.equals(TIME_OID)) {

				org.omg.CORBA.Any value = trapData[i].value;

				if(value.type().kind().value() != TCKind._tk_longlong) {

					ApplicationErrorInfoTypeImpl error_code =
						new ApplicationErrorInfoTypeImpl();

					error_code.error = new UIDType(
						intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
						intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

					error_code.details = new String ("Could not retrieve event time " +
						" for trap. Object with Snmp Object Identifier " + TIME_OID +
			 			" is not of type long, as expected.");

					throw new ApplicationError(error_code);

				}

				trapTime = value.extract_longlong();
				trapTimeFound = true;
				break;
			}

		}

		if (trapTimeFound == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("Could not retrieve event time " +
				" for trap.");

			throw new ApplicationError(error_code);
		}

		//org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(trapTime, 0,(short) 0,(short) 0);
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
						0,(short) 0,(short) 0);

//		int notificationId = data.getUniqueNotificationIdentifier();
		int notificationId = getUniqueNotificationIdentifier();

		String sourceClass = data.objectclass;

		SourceIndicatorType sourceIndicator = SourceIndicatorType.unknown;

		org.omg.CORBA.Any oldValue_any =  orb.create_any();
		OperationalStateTypeHelper.insert(oldValue_any, oldValue);

		org.omg.CORBA.Any newValue_any =  orb.create_any();
		OperationalStateTypeHelper.insert(newValue_any, newValue);

		AttributeValueChangeType [] changedValues = new AttributeValueChangeType[1];
		changedValues[0] = new AttributeValueChangeType(
				"operationalState",
				oldValue_any,
				newValue_any);

		StateChangedEventImpl stateChangedEvent = new StateChangedEventImpl(
				eventTime,
				name,
				sourceClass,
				notificationId,
			  	sourceIndicator,
				//new AttributeValueChangeType[0]);
				changedValues);

		//System.err.println("IpNodeProvider>Before pushing StateChange event with identifier " +
		//	stateChangedEvent.notificationIdentifier + " for " +
		//	Utils.name2string(stateChangedEvent.source) + " of objectclass " +
		//	stateChangedEvent.sourceClass + " generated after SNMP agent " +
		//	"has been up for " + stateChangedEvent.eventTime.time +
		//	" caused by an action of type " + sourceIndicator + "." );

		the_context_.push_stateChange(stateChangedEvent);

    }

	 private int getUniqueNotificationIdentifier() {

            notifId++;

            return (notifId);
        }


    class IpNodeDataStructure {

		public String domainName;
		public String hostname;
		public byte[] managementIPAddress;
		public NameComponent[] name;
		public String[] packageNameList;
		public int supportedSnmpVersions;
		public intt.itu.itut_x780.AdministrativeStateType administrativeState;
		public String userLabel;
		public String vendorName;
		public String version;
		public String locationName;
		public int snmpPort;
		public String sysName;
		public String sysContact;
		public String objectclass;
		public short deletePolicy;
		public intt.itu.itut_x780.SourceIndicatorType sourceIndicator;
		public intt.itu.itut_x780.OperationalStateType operationalState;

		private int notificationIdentifier;

		public IpNodeDataStructure (
			String domainName,
			String hostname,
			byte[] managementIPAddress,
			NameComponent[] name,
			String[] packageNameList,
			int supportedSnmpVersions,
			intt.itu.itut_x780.AdministrativeStateType administrativeState,
			String userLabel,
			String vendorName,
			String version,
			String locationName,
			int snmpPort,
			String sysName,
			String sysContact,
			String objectclass,
			short deletePolicy,
			intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
			intt.itu.itut_x780.OperationalStateType operationalState) {

			this.domainName = domainName;
			this.hostname = hostname;
			this.managementIPAddress = managementIPAddress;
			this.name = name;
			this.packageNameList = packageNameList;
			this.supportedSnmpVersions = supportedSnmpVersions;
			this.administrativeState = administrativeState;
			this.userLabel = userLabel;
			this.vendorName = vendorName;
			this.version = version;
			this.locationName = locationName;
			this.snmpPort = snmpPort;
			this.sysName = sysName;
			this.sysContact = sysContact;
			this.objectclass = objectclass;
			this.deletePolicy = deletePolicy;
			this.sourceIndicator = sourceIndicator;
			this.operationalState = operationalState;

			this.notificationIdentifier = 0;
		}

		public int getUniqueNotificationIdentifier() {

			this.notificationIdentifier++;

			return (this.notificationIdentifier);
		}

    }
}
