/*====================================================================

created on 1 juil. 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AttributeTypeListImpl
extends LocalObject
implements AttributeTypeList
{
  Table _attributes;
  
  public AttributeTypeListImpl()
  {
    _attributes = new Table();
  }

  public AttributeType get_attribute_type(String name) throws InvalidName
  {
    return (AttributeType) _attributes.get(name);
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.AttributeTypeListOperations#get_named_attribute_types(java.lang.String[])
   */
  public AttributeType[] get_named_attribute_types(String[] names) throws InvalidName
  {
    AttributeType[] result = new AttributeType[names.length];

    // Iterate on all the connections.
  
    int i = 0;
    for(i=0;i<names.length;i++)
    {
      result[i] = (AttributeType)_attributes.get(names[i]);
    }
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.AttributeTypeListOperations#get_all_attribute_types()
   */
  public AttributeType[] get_all_attribute_types()
  {
    int idx = 0;
    AttributeType[] result = new AttributeType[_attributes.size()];
  
   // Iterate on all the connections.
 
   for(java.util.Enumeration enumeration = _attributes.elements(); enumeration.hasMoreElements(); )
   {
       AttributeType info = (AttributeType)enumeration.nextElement();
       result[idx++] = info;
   }
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.AttributeTypeListOperations#add_interface_type(org.objectweb.ccm.Containers.MetaInformation.AttributeType)
   */
  public void add_attribute_type(AttributeType ift)
  {
    _attributes.put(ift.name(),ift);
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.AttributeTypeListOperations#remove_attribute_type(java.lang.String)
   */
  public void remove_attribute_type(String name) throws InvalidName
  {
    _attributes.remove(name);
  }
}
