/*====================================================================

created on 14 aot 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ConsumerPortInstanceListImpl
extends LocalObject
implements ConsumerPortInstanceList
{
  private Table _consumers; 
  
  public ConsumerPortInstanceListImpl()
  {
    _consumers = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ConsumerPortInstanceListOperations#get_consumer_port_instance(java.lang.String)
   */
  public ConsumerPortInstance 
  get_consumer_port_instance(String name) 
  throws InvalidName
  {
    ConsumerPortInstance result = (ConsumerPortInstance) _consumers.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ConsumerPortInstanceListOperations#get_named_consumer_port_instances(java.lang.String[])
   */
  public ConsumerPortInstance[] 
  get_named_consumer_port_instances(String[] names) 
  throws InvalidName
  {
    ConsumerPortInstance[] result = new ConsumerPortInstance[names.length];

   // Iterate on all the connections.
  
   int i = 0;
   for(i=0;i<names.length;i++)
   {
     result[i] = (ConsumerPortInstance)_consumers.get(names[i]);
     
     if(result[i] == null)
     {
       throw new InvalidName();
     }
    }
   
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ConsumerPortInstanceListOperations#get_all_consumer_port_instances()
   */
  public ConsumerPortInstance[] 
  get_all_consumer_port_instances()
  {
    ConsumerPortInstance[] result = new ConsumerPortInstance[_consumers.size()];
  
     // Iterate on all the connections.
     int idx = 0;
     for(java.util.Enumeration enumeration = _consumers.elements(); enumeration.hasMoreElements(); )
     {
       ConsumerPortInstance info = (ConsumerPortInstance)enumeration.nextElement();
         result[idx++] = info;
     }
     return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ConsumerPortInstanceListOperations#add_consumer_port_instance(org.objectweb.ccm.Containers.MetaInformation.ConsumerPortInstance)
   */
  public void add_consumer_port_instance(ConsumerPortInstance cpi)
  {
    String key = cpi.type_reference().name();// + cpi.toString().substring(cpi.toString().lastIndexOf("@"));
    _consumers.put(key,cpi);
    
  }

  /* (non-Javadoc)
   * @see org.objectweb.ccm.Containers.MetaInformation.ConsumerPortInstanceListOperations#remove_consumer_port_instance(java.lang.String)
   */
  public void remove_consumer_port_instance(String name) 
  throws InvalidName
  {
    Object result = _consumers.remove(name);
    
    if (result == null) throw new InvalidName();
  }
}
