/*====================================================================

created on 10 avr. 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;

/**
 * @author hameau
 */
public class EmitterPortTypeListImpl
extends LocalObject 
implements EmitterPortTypeList
{
	private Table _emitters;
	
	public EmitterPortTypeListImpl()
	{
			_emitters = new Table();
	}

	public EmitterPortType[] get_all_emitter_port_types()
	{
		EmitterPortType[] result = new EmitterPortType[_emitters.size()];

		// Iterate on all the connections.
		int idx = 0;
		for(java.util.Enumeration enumeration = _emitters.elements(); enumeration.hasMoreElements(); )
		{
				EmitterPortType info = (EmitterPortType)enumeration.nextElement();
				result[idx++] = info;
		}
		return result;
	}

	public EmitterPortType[] get_named_emitter_port_types(String[] names)
	{
		EmitterPortType[] result = new EmitterPortType[names.length];

		// Iterate on all the connections.
		int i = 0;
		for(i=0;i<names.length;i++)
		{
				result[i] = (EmitterPortType)_emitters.get(names[i]);
		}
		return result;
	}	

	public EmitterPortType get_emitter_port_type(String name)
	{
			return (EmitterPortType) _emitters.get(name);
	}

	public void add_emitter_port_type(EmitterPortType _opt)
	{
		_emitters.put(_opt.name(),_opt);
	}

	public void remove_emitter_port_type(String name)
	{
		_emitters.remove(name);
	}
}
