/*====================================================================

created on 8 avr. 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;


import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;

/**
 * @author hameau
 */
public class InterfaceTypeListImpl
extends LocalObject
implements InterfaceTypeList{
	
	private Table _interfaces;
	
	public InterfaceTypeListImpl()
	{
			_interfaces = new Table();
	}
	
	public InterfaceType[] get_all_interface_types()
	{
		InterfaceType[] result = new InterfaceType[_interfaces.size()];

		// Iterate on all the interfaces.
		int idx = 0;
		for(java.util.Enumeration enumeration = _interfaces.elements(); enumeration.hasMoreElements(); )
		{
				InterfaceType info = (InterfaceType)enumeration.nextElement();
				result[idx++] = info;
		}
		return result;
	}

	public InterfaceType[] get_named_interface_types(String[] names)
	{
		InterfaceType[] result = new InterfaceType[names.length];

		// Iterate on all the Interfaces.
		int i = 0;
		for(i=0;i<names.length;i++)
		{
				result[i] = (InterfaceType)_interfaces.get(names[i]);
		}
		return result;
	}	
	
	public InterfaceType get_interface_type(String name)
	{
			return (InterfaceType) _interfaces.get(name);
	}
	
	public void add_interface_type(InterfaceType _ift)
	{
		_interfaces.put(_ift.name(),_ift);
	}
	
	public void remove_interface_type(String name)
	{
		_interfaces.remove(name);
	}

}
