/*====================================================================

created on 8 avr. 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;


/**
 * @author hameau
 */
public class OperationTypeListImpl
extends LocalObject
implements OperationTypeList
{
  private Table _operations;
  
  	public OperationTypeListImpl()
  	{
  			_operations = new Table();
  	}
  
  	public OperationType[] get_all_operation_types()
  	{
  		OperationType[] result = new OperationType[_operations.size()];
  
  		// Iterate on all the connections.
  	int idx = 0;
  	for(java.util.Enumeration enumeration = _operations.elements(); enumeration.hasMoreElements(); )
  	{
  			OperationType info = (OperationType)enumeration.nextElement();
  			result[idx++] = info;
  	}
  	return result;
  }
  
  public OperationType[] get_named_operation_types(String[] names)
  {
  	OperationType[] result = new OperationType[names.length];
  
  	// Iterate on all the connections.
  	int i = 0;
  	for(i=0;i<names.length;i++)
  	{
  			result[i] = (OperationType)_operations.get(names[i]);
  	}
  	return result;
  }	
  
  public OperationType get_operation_type(String name)
  {
  		return (OperationType) _operations.get(name);
  }
  
  public void add_operation_type(OperationType _opt)
  {
  	_operations.put(_opt.name(),_opt);
  }
  
  public void remove_operation_type(String name)
  {
  	_operations.remove(name);
  }
}
