/*====================================================================

created on 10 avr. 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.ccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
/**
 * @author hameau
 */
public class ReceptaclePortTypeListImpl
extends LocalObject
implements ReceptaclePortTypeList
{
  private Table _receptacles;
  
  public ReceptaclePortTypeListImpl()
  {
  		_receptacles = new Table();
  }
  
  public ReceptaclePortType[] get_all_receptacle_port_types()
  {
  	ReceptaclePortType[] result = new ReceptaclePortType[_receptacles.size()];
  
  	// Iterate on all the connections.
  	int idx = 0;
  	for(java.util.Enumeration enumeration = _receptacles.elements(); enumeration.hasMoreElements(); )
  	{
  			ReceptaclePortType info = (ReceptaclePortType)enumeration.nextElement();
  			result[idx++] = info;
  	}
  	return result;
  }
  
  public ReceptaclePortType[] get_named_receptacle_port_types(String[] names)
  {
  	ReceptaclePortType[] result = new ReceptaclePortType[names.length];
  
  	// Iterate on all the connections.
  	int i = 0;
  	for(i=0;i<names.length;i++)
  	{
  			result[i] = (ReceptaclePortType)_receptacles.get(names[i]);
  	}
  	return result;
  }	
  
  public ReceptaclePortType get_receptacle_port_type(String name)
  {
  		return (ReceptaclePortType) _receptacles.get(name);
  }
  
  public void add_receptacle_port_type(ReceptaclePortType _opt)
  {
  	_receptacles.put(_opt.name(),_opt);
  }
  
  public void remove_receptacle_port_type(String name)
  {
  	_receptacles.remove(name);
  }
}
